
(*****************************************************************************)
(*                                   "15"                                    *)
(*                 (c) Ing. Miroslav Nmeek 1997, GEMA Soft                 *)
(*****************************************************************************)


(*============================ definice promnnch ==========================*)

# Znak                                     (* schova znaku z klvesnice     *)

(*============================ definice pkaz =============================*)

(*-------------------- otoen smrem na vchod = doprava -------------------*)
! NaVychod
  (
    rychle                                 (* provede se zrychlen na pozad *)
    dokud neni vychod vlevo                (* otoen na vchod = doprava    *)
  )
(*---------------------- otoen smrem na jih = dol -----------------------*)
! NaJih
  (
    rychle                                 (* provede se zrychlen na pozad *)
    dokud neni jih vlevo                   (* otoen na jih = dol          *)
  )
(*--------------------- otoen smrem na zpad = doleva --------------------*)
! NaZapad
  (
    rychle                                 (* provede se zrychlen na pozad *)
    dokud neni zapad vlevo                 (* otoen na zpad = doleva      *)
  )
(*-------------------- otoen smrem na sever = nahoru ---------------------*)
! NaSever
  (
    rychle                                 (* provede se zrychlen na pozad *)
    dokud neni sever vlevo                 (* otoen na sever = nahoru      *)
  )
(*------------------------ navrcen na vchoz pozici ----------------------*)
! Domu
  (
    rychle                                 (* provede se zrychlen na pozad *)
    NaSever                                (* otoen na sever = nahoru      *)
    dokud neni zed krok                    (* jde a k hornmu okraji        *)
    vlevo                                  (* oto se vlevo                 *)
    dokud neni zed krok                    (* jde a k pravmu okraji        *)
    vlevo                                  (* oto se smrem dol           *)
  )
(*---------------------- vymazn celho pole -------------------------------*)
! Vymaz
  (
    rychle                                 (* provede se zrychlen na pozad *)
    Domu                                   (* nastaven vchoz pozice       *)
    krok                                   (* krok na jih = smrem dol      *)
    vzad                                   (* oto se nahoru na prvn dek *)
    Nic                                    (* vymazn prvnho polka       *)
    krok vpravo                            (* na 1. polko a otoen vpravo *)
    dokud neni zed
      (
        dokud neni zed (Nic krok)          (* vymazn dku zleva doprava   *)
        vpravo jestli neni zed (krok vpravo) (* na zatek dalho dku     *)
        dokud neni zed (Nic krok)          (* vymazn dku zprava doleva   *)
        vlevo jestli neni zed (krok vlevo) (* na zatek dalho dku       *)
      )
  )
(*----------------------------- zobrazen nadpisu ---------------------------*)
! Nadpis
  (
    rychle                                 (* provede se zrychlen na pozad *)
    Domu                                   (* navrt se na vchoz pozici   *)
    krok krok                              (* jde kousek smrem dol         *)
    vlevo                                  (* otoen na vchod = doprava    *)
    opakuj 7 krok                          (* jde kousek smrem doprava      *)
    Cis1 krok Cis5                         (* zobrazen slic "1" a "5"     *)
  )
(*-------------------- nastaven na zatek hrac plochy --------------------*)
! Zacatek
  (
    rychle                                 (* provede se zrychlen na pozad *)
    Domu                                   (* navrt se na vchoz pozici   *)
    opakuj 6 krok                          (* jde kousek smrem dol         *)
    vlevo                                  (* otoen na vchod = doprava    *)
    opakuj 6 krok                          (* jde kousek smrem doprava      *)
  )
(*----------------------- vykreslen nov hrac plochy ----------------------*)
! Nova
  (
    rychle                                 (* provede se zrychlen na pozad *)
    Zacatek                                (* jde na zatek hrac plochy    *)

            (* nakreslen prvn ady - jde zleva doprava *)
    Cis1  krok                             (* "1", vstoup na slo "1"      *)
    Cis2  krok                             (* "2", vstoup na slo "2"      *)
    Cis3  krok                             (* "3", vstoup na slo "3"      *)
    Cis4  krok                             (* "4", vstoup na slo "4"      *)

            (* nakreslen druh ady - jde zprava doleva *)
    vpravo                                 (* oto se na jih = smrem dol  *)
    Cis8  krok                             (* "8", vstoup na slo "8"      *)
    vpravo                                 (* oto se na zpad = doleva     *)
    Cis7  krok                             (* "7", vstoup na slo "7"      *)
    Cis6  krok                             (* "6", vstoup na slo "6"      *)
    Cis5  krok                             (* "5", vstoup na slo "5"      *)

            (* nakreslen tet ady - jde zleva doprava *)
    vlevo                                  (* oto se na jih = smrem dol  *)
    Cis9  krok                             (* "9", vstoup na slo "9"      *)
    vlevo                                  (* oto se na vchod = doprava   *)
    Cis10 krok                             (* "10", vstoup na slo "10"    *)
    Cis11 krok                             (* "11", vstoup na slo "11"    *)
    Cis12 krok                             (* "12", vstoup na slo "12"    *)

            (* nakreslen tvrt ady - jde zprava doleva *)
    vpravo                                 (* oto se na jih = smrem dol  *)
    Mezera  krok                           (* Mezera, vstoup na mezeru      *)
    vpravo                                 (* oto se na zpad = doleva     *)
    Cis15 krok                             (* "15", vstoup na slo "15"    *)
    Cis14 krok                             (* "14", vstoup na slo "14"    *)
    Cis13                                  (* "13", zstv na "14"          *)

            (* navrt se na polko s mezerou *)
    vzad                                   (* oto se na vchod = doprava   *)
    krok krok                              (* popojde na polko s mezerou   *)
  )
(*--------------------------- otoen nhodnm smrem -----------------------*)
! Otoc
  (
    rychle                                 (* provede se zrychlen na pozad *)
    $ = nahoda 4                           (* generovn nhodnho sla 0-3 *)
    jestli $ = 0 vlevo                     (* 0: oto se vlevo              *)
    jestli $ = 1 vpravo                    (* 1: oto se vpravo             *)
    jestli $ = 2 vzad                      (* 2: oto se vzad               *)
                                           (* 3: zstane rovn               *)
  )
(*-------------------------- posunut mezery vped --------------------------*)
! Posun
  (
    rychle                                 (* provede se zrychlen na pozad *)
    jestli Cis1  ( Mezera krok vzad Cis1  vzad ) jinak
    jestli Cis2  ( Mezera krok vzad Cis2  vzad ) jinak
    jestli Cis3  ( Mezera krok vzad Cis3  vzad ) jinak
    jestli Cis4  ( Mezera krok vzad Cis4  vzad ) jinak
    jestli Cis5  ( Mezera krok vzad Cis5  vzad ) jinak
    jestli Cis6  ( Mezera krok vzad Cis6  vzad ) jinak
    jestli Cis7  ( Mezera krok vzad Cis7  vzad ) jinak
    jestli Cis8  ( Mezera krok vzad Cis8  vzad ) jinak
    jestli Cis9  ( Mezera krok vzad Cis9  vzad ) jinak
    jestli Cis10 ( Mezera krok vzad Cis10 vzad ) jinak
    jestli Cis11 ( Mezera krok vzad Cis11 vzad ) jinak
    jestli Cis12 ( Mezera krok vzad Cis12 vzad ) jinak
    jestli Cis13 ( Mezera krok vzad Cis13 vzad ) jinak
    jestli Cis14 ( Mezera krok vzad Cis14 vzad ) jinak
    jestli Cis15 ( Mezera krok vzad Cis15 vzad )
  )
(*-------------------------- nvrat na polko mezery -----------------------*)
! Navrat
  (
    rychle                                 (* provede se zrychlen na pozad *)
    Zacatek                                (* jde na zatek hrac plochy    *)

    Dokud neni Mezera
      (
        Dokud neni (Mezera nebo Nic) krok  (* jde k pravmu okraji dku     *)
        jestli Nic (krok vpravo krok vpravo) (* je za pravm okrajem dku   *)
        Dokud neni (Mezera nebo Nic) krok  (* jde k levmu okraji dku      *)
        jestli Nic (krok vlevo krok vlevo) (* je ped levm okrajem dku    *)
      )
    krok                                   (* krok na polko mezery         *)
  )
(*-------------------------- zkouka dokonen hry --------------------------*)
! Zkouska
  (
    rychle                                 (* provede se zrychlen na pozad *)
    $=1                                    (* pznak spnho dokonen    *)
    Zacatek                                (* jde na zatek hrac plochy    *)

              (* test prvn ady - jde zleva doprava *)
    jestli neni Cis1  $=0  krok            (* "1", vstoup na slo "1"      *)
    jestli neni Cis2  $=0  krok            (* "2", vstoup na slo "2"      *)
    jestli neni Cis3  $=0  krok            (* "3", vstoup na slo "3"      *)
    jestli neni Cis4  $=0  krok            (* "4", vstoup na slo "4"      *)

               (* test druh ady - jde zprava doleva *)
    vpravo                                 (* oto se na jih = smrem dol  *)
    jestli neni Cis8  $=0  krok            (* "8", vstoup na slo "8"      *)
    vpravo                                 (* oto se na zpad = doleva     *)
    jestli neni Cis7  $=0  krok            (* "7", vstoup na slo "7"      *)
    jestli neni Cis6  $=0  krok            (* "6", vstoup na slo "6"      *)
    jestli neni Cis5  $=0  krok            (* "5", vstoup na slo "5"      *)

                (* test tet ady - jde zleva doprava *)
    vlevo                                  (* oto se na jih = smrem dol  *)
    jestli neni Cis9  $=0  krok            (* "9", vstoup na slo "9"      *)
    vlevo                                  (* oto se na vchod = doprava   *)
    jestli neni Cis10 $=0  krok            (* "10", vstoup na slo "10"    *)
    jestli neni Cis11 $=0  krok            (* "11", vstoup na slo "11"    *)
    jestli neni Cis12 $=0  krok            (* "12", vstoup na slo "12"    *)

                (* test tvrt ady - jde zprava doleva *)
    vpravo                                 (* oto se na jih = smrem dol  *)
    jestli neni Mezera  $=0  krok          (* Mezera, vstoup na mezeru      *)
    vpravo                                 (* oto se na zpad = doleva     *)
    jestli neni Cis15 $=0  krok            (* "15", vstoup na slo "15"    *)
    jestli neni Cis14 $=0  krok            (* "14", vstoup na slo "14"    *)
    jestli neni Cis13 $=0                  (* "13", zstv na "14"          *)

    Navrat                                 (* navrcen na polko mezery    *)
  )
(*--------------------- nhodn mchn hrac plochy ------------------------*)
! Michej
  (
    rychle                                 (* provede se zrychlen na pozad *)
    hlaseni "Stiskem libovoln klvesy ukonte mchn..."

    dokud klavesa="" (Otoc Posun)          (* mchn a do stisku klvesy   *)
  )
(*--------------------- vykreslen rmeku po vhe -------------------------*)
! Vyhra
  (
    rychle                                 (* provede se zrychlen na pozad *)
    hlaseni "%* **** Blahopeji  ! **** %*     %*F9%*=nov hra    %*F10%*=konec"
    Zacatek                                (* jde na zatek hrac plochy    *)
    vzad krok vpravo krok krok             (* vchoz pozice pro horn okraj *)
    opakuj 4
      (
        vpravo opakuj 7 (PetrikP krok cekej) (* nakreslen rmu kolem plochy *)
      )
  )
(*============================= hlavn program ==============================*)

rychle                                     (* Petk nebude viditeln        *)
Znak=""                                    (* inicializace schovy znaku     *)

Dokud neni (Znak=K_Esc nebo Znak=K_F10)    (* pln ukonen hry             *)
  (
    Vymaz                                  (* vymazn celho pole           *)
    Nadpis                                 (* zobrazen nadpisu              *)
    Nova                                   (* zobrazen nov hrac plochy    *)
    Michej                                 (* zamchn hrac plochy         *)
    hlaseni "%*kurzorov klvesy%*=posun kostky    %*F9%*=nov zamchn    %*F10%*=konec hry"
    Znak=""                                (* inicializace schovy znaku     *)

    Dokud neni (Znak=K_Esc nebo Znak=K_F9 nebo Znak=K_F10) (* cyklus jedn hry *)
      (
        Znak=klavesa                           (* naten znaku z klvesnice *)
        jestli Znak=K_Vpravo (NaZapad  Posun)  (* posun kamene zleva doprava *)
        jestli Znak=K_Dolu   (NaSever  Posun)  (* posun kamene shora dol    *)
        jestli Znak=K_Vlevo  (NaVychod Posun)  (* posun kamene zprava doleva *)
        jestli Znak=K_Nahoru (NaJih    Posun)  (* posun kamene zdola nahoru  *)

        jestli Zkouska
          (
            Vyhra                              (* zobrazen hlen o vhe  *)
            Znak=""
            Dokud neni (Znak=K_Esc nebo Znak=K_F9 nebo Znak=K_F10)
                          Znak=klavesa        (* ekn na znak z klvesnice *)
          )
      )
  )
prerus
