
; *****************************************************************************
;
;                                    Petk
;
; -----------------------------------------------------------------------------
; Velikost polek: 32*32 bod/16 barev (ikony WINDOWS)
; Pouit videomd: 640*480/16 barev (videomd VGA)
;                     Pro jin videokarty ne VGA jsou ikony
;                     redukovny na men rozlien
; Velikost plochy:  14*14 polek, kolem plochy rm o ce 8 bod,
;                   pod plochou textov a ovldac dek o vce 16 linek
;                   (dlka 80 znak=640 bod), vpravo od plochy ovldac ps
;                   5*14 polek (resp. ka 20 znak) s rmem 8 bod
; -----------------------------------------------------------------------------
; Intern souadnice se udvaj po nsobcch 8 bod: tj. max. X=80 a Y=60
; -----------------------------------------------------------------------------
; Nvratov kdy programu: 0=ve OK
;                          1=chyba syntaxe vstupnho programu nebo soubor nenalezen
;                          2=nedostatek pamti
; *****************************************************************************

PSIRKA   EQU       18                       ; ka hracho pole (polek)
PVYSKA   EQU       14                       ; vka hracho pole (polek)
MSIRKA   EQU       1                        ; ka okna menu (polek)
MVYSKA   EQU       14                       ; vka okna menu (polek)

CPOZADI  EQU       3                        ; barva pozad

BUFFSIZE EQU       1024                     ; vstupn buffer programu

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

HI       EQU       256

ICOSize  EQU       32*32*5/8                ; velikost ikony v bajtech

HistEdiM EQU       5                        ; velikost historie editace

HercSir  EQU       90                       ; ka dku pro Hercules

; ------ intern kdy

KOD_OBR  EQU       1                        ; 1: kreslen obrzku
KOD_OPAK EQU       2                        ; 2: OPAKUJ
KOD_LZAV EQU       3                        ; 3: lev zvorka
KOD_RZAV EQU       4                        ; 4: prav zvorka
KOD_PROC EQU       5                        ; 5: definice/proveden pkazu
KOD_CARK EQU       6                        ; 6: rka
KOD_KROK EQU       7                        ; 7: KROK
KOD_VLEV EQU       8                        ; 8: VLEVO
KOD_VPRA EQU       9                        ; 9: VPRAVO
KOD_VZAD EQU       10                       ; 10: VZAD
KOD_CEK  EQU       11                       ; 11: CEKEJ
KOD_RYCH EQU       12                       ; 12: RYCHLE
KOD_POM  EQU       13                       ; 13: POMALU
KOD_SEV  EQU       14                       ; 14: SEVER
KOD_JIH  EQU       15                       ; 15: JIH
KOD_VYCH EQU       16                       ; 16: VYCHOD
KOD_ZAP  EQU       17                       ; 17: ZAPAD
KOD_JEST EQU       18                       ; 18: JESTLI
KOD_JIN  EQU       19                       ; 19: JINAK
KOD_NENI EQU       20                       ; 20: NENI
KOD_PRER EQU       21                       ; 21: PRERUS
KOD_DOK  EQU       22                       ; 22: DOKUD
KOD_MASK EQU       23                       ; 23: MASKA
KOD_VSYN EQU       24                       ; 24: VSYN
KOD_PROM EQU       25                       ; 25: PROMENNA
KOD_CISL EQU       26                       ; 26: CISLO
KOD_ROVN EQU       27                       ; 27: ROVNITKO
KOD_PLUS EQU       28                       ; 28: PLUS
KOD_MIN  EQU       29                       ; 29: MINUS
KOD_KRAT EQU       30                       ; 30: KRAT
KOD_DEL  EQU       31                       ; 31: DELENO
KOD_MENS EQU       32                       ; 32: MENSI
KOD_VETS EQU       33                       ; 33: VETSI
KOD_NAH  EQU       34                       ; 34: NAHODA
KOD_VEKT EQU       35                       ; 35: VEKTOR
KOD_MIST EQU       36                       ; 36: MISTNI
KOD_AND  EQU       37                       ; 37: A
KOD_OR   EQU       38                       ; 38: NEBO
KOD_POZX EQU       39                       ; 39: POZICEX
KOD_POZY EQU       40                       ; 40: POZICEY
KOD_KLAV EQU       41                       ; 41: KLAVESA
KOD_OBN  EQU       42                       ; 42: OBNOV
KOD_SMER EQU       43                       ; 43: SMER
KOD_HLAS EQU       44                       ; 44: HLASENI
KOD_PRED EQU       45                       ; 45: PREDMET
KOD_TEXT EQU       46                       ; 46: TEXT
KOD_POLE EQU       47                       ; 47: POLE
KOD_MOD  EQU       48                       ; 48: MOD
KOD_MUS  EQU       49                       ; 49: HUDBA

; -----------------------------------------------------------------------------
;        noty pro hran melodie
; -----------------------------------------------------------------------------

MC       EQU       0                        ; C
MCI      EQU       1                        ; C#
MD       EQU       2                        ; D
MDI      EQU       3                        ; D#
ME       EQU       4                        ; E
MF       EQU       5                        ; F
MFI      EQU       6                        ; F#
MG       EQU       7                        ; G
MGI      EQU       8                        ; G#
MA       EQU       9                        ; A
MAI      EQU       10                       ; A#
MH       EQU       11                       ; H

M32      EQU       1                        ; dlka 1/32
M16      EQU       2                        ; dlka 1/16
M8       EQU       4                        ; dlka 1/8
M4       EQU       8                        ; dlka 1/4
M2       EQU       16                       ; dlka 1/2
M1       EQU       32                       ; dlka cel

MO0      EQU       1                        ; oktva 0
MO1      EQU       13                       ; oktva 1
MO2      EQU       25                       ; oktva 2
MO3      EQU       37                       ; oktva 3
MO4      EQU       49                       ; oktva 4
MO5      EQU       61                       ; oktva 5
MO6      EQU       73                       ; oktva 6
MO7      EQU       85                       ; oktva 7
MO8      EQU       97                       ; oktva 8
MO9      EQU       109                      ; oktva 9

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; ------ pedefinovn zsobnku

Start:   cmp       sp,offset Zasob          ; je pam؜ OK ?
         jb        ChybaMem                 ; chyba pamti
         mov       sp,offset Zasob          ; pedefinovn zsobnku

; ------ zmenen bloku programu

         mov       bx,(offset(Zasob-Start)+10fh)/16 ; nov velikost programu
         mov       ah,4ah
         int       21h                      ; zmenen alokanho bloku

; ------ vytvoen bloku vektoru

         mov       bx,1000h                 ; velikost vektoru
         mov       ah,48h
         int       21h                      ; vytvoen vektoru
         jc        ChybaMem                 ; chyba pamti
         mov       ds:[DataVekt],ax         ; adresa vektoru

; ------ vytvoen datovho bloku

         mov       bx,-1
         mov       ah,48h
         int       21h
         mov       ah,48h
         int       21h                      ; pidlen bloku pamti
         jnc       Start1                   ; je to OK

; ------ chyba - nedostatek pamti

ChybaMem:mov       bp,offset MemErr         ; chyba - nedostatek pamti
;Chyba1:  mov       ah,9
;         mov       dx,offset UvTxt
;         int       21h
         mov       ah,9
         mov       dx,bp                    ; text chyby
         int       21h
         mov       ax,4c02h
         int       21h

;Chyba:   jc        Chyba1                   ; je chyba
;         ret

; ------ ukazatele pam؜ovho bloku

Start1:  mov       ds:[DataSegm],ax         ; adresa datovho segmentu
         mov       ds:[DataProg],ax         ; adresa zatku programu
         cmp       bx,200h                  ; asi tak minimln 8 KB
         jb        ChybaMem                 ; chyba - mlo pamti
         add       ax,bx                    ; adresa konce pamti
         mov       ds:[DataEnd],ax          ; adresa konce pamti
         mov       ds:[DataICO],ax          ; adresa zatku ikon

; ------ inicializace genertoru nhody

         call      InitRnd                  ; inicializace genertoru nhody


Start2:


; ------ naten vech ikon do bufferu

         call      ReadICO                  ; naten vech ikon
         jc        ChybaMem                 ; chyba pamti

; ------ inicializace implicitnch ikon

         call      IniICOD                  ; inicializace implicitnch ikon

         mov       ax,ds:[ICOZed]           ; ikona pro ze
         mov       ds:[ICOLast],ax          ; naposledy zvolen ikona
         mov       ax,ds:[ICONic]           ; przdn ikona
         mov       ds:[EdiIHist],ax         ; historie editace ikon
         mov       ds:[EdiIHist+2],ax
         mov       ds:[EdiIHist+4],ax
         mov       ds:[EdiIHist+6],ax
         mov       ds:[EdiIHist+8],ax

; ------ naten programu

         call      ReadPrg                  ; naten programu
         jc        ChybaMem                 ; chyba pamti

         cmp       word ptr ds:[CitChyb],0
         je        Start22
         mov       ax,4c01h
         int       21h

; ------ inicializace pozad ikon

Start22: call      IniPozad                 ; inicializace pozad ikon

; ------ inicializace videomdu

         call      IniCard                  ; inicializace videokarty

; ------ inicializace palet displeje

         call      InitPal                  ; inicializace palet displeje

; ------ inicializace myi

         call      InitMous                 ; inicializace myi

; ------ instalace obsluhy INT 23h a INT 24h

         mov       dx,offset INT24
         mov       ax,2524h
         int       21h
         mov       dx,offset INT23
         mov       ax,2523h
         int       21h

; ------ instalace obsluhy INT 08h

         mov       ax,3508h
         int       21h                      ; poskytnut adresy INT 08h
         mov       word ptr ds:[Old08],bx
         mov       word ptr ds:[Old08+2],es
         mov       dx,offset Int08          ; nov obsluha INT 08h
         mov       ax,2508h
         int       21h                      ; nastaven nov obsluhy INT 08h

; ------ instalace obsluhy INT 09h

         mov       ax,3509h
         int       21h                      ; poskytnut adresy INT 09h
         mov       word ptr ds:[Old09],bx
         mov       word ptr ds:[Old09+2],es
         mov       dx,offset Int09
         mov       ax,2509h
         int       21h                      ; nastaven nov obsluhy INT 09h

; ------ instalace obsluhy INT 1Bh

         mov       ax,351Bh
         int       21h                      ; poskytnut adresy INT 1Bh
         mov       word ptr ds:[Old1B],bx
         mov       word ptr ds:[Old1B+2],es
         mov       dx,offset Int1B
         mov       ax,251Bh
         int       21h                      ; nastaven nov obsluhy INT 1Bh

; ------ vymazn obrazovky

         call      Vymaz                    ; vymazn plochy
StartPrg:call      IniVymaz                 ; inicializan vymazn obrazovky

         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         mov       byte ptr ds:[Rezim],1    ; pznak bhu programu
         call      DispMenu                 ; nov zobrazen menu
         call      NulBreak                 ; nulovn pznaku peruen
         call      ExecPrg                  ; proveden programu

         call      TstBreak                 ; bylo peruen programu ?
         jc        Start311                 ; bylo peruen programu
         test      byte ptr ds:[Param],bit4 ; je peruen programu ?
         jz        Start312                 ; nen peruen programu

Start311:mov       ax,3
         int       10h                      ; inicializace videomdu
         jmp       Konec1                   ; konec programu

Start312:

         call      TextRam                  ; vymazn textu hlen
         call      PetPom                   ; nastaven pomalho Petra
         call      CekKrokD                 ; zobrazen Petra

Start32: mov       word ptr ds:[BlokIf],0   ; odblokovn pkaz
         and       byte ptr ds:[Param],not bit4 ; nen peruen cyklu
         mov       byte ptr ds:[Rezim],2    ; pznak bاnho provozu
         call      DispMenu                 ; nov zobrazen menu
         call      DispPet                  ; zobrazen Petra
Start4:  call      InpChar                  ; vstup znaku z klvesnice
         jnc       Start4                   ; vyprzdnn bufferu klvesnice

Start402:call      MouseOn
         call      NulBreak                 ; nulovn pznaku peruen
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Start408                 ; je znak z klvesnice
         call      IntHlas                  ; mazn hlen
         call      GetMouse
         jc        Start402

         mov       ax,4800h                 ; vped
         cmp       dx,312h
         je        Start409
         mov       ax,5000h                 ; vzad
         cmp       dx,112h
         je        Start409
         mov       ax,4b00h
         cmp       dx,012h                  ; vlevo
         je        Start409
         mov       ax,4d00h                 ; vpravo
         cmp       dx,212h
         je        Start409
         mov       ax," "
         cmp       dx,412h
         je        Start409
         mov       ax,13
         cmp       dx,512h
         je        Start409
;         mov       al,"1"
;         cmp       dx,713h
;         je        Start409
         mov       ax,4300h                 ; F9: start
         cmp       dx,0b12h
         je        Start409

         mov       ax,3e00h                 ; F4: editace
         cmp       dx,0c12h
         je        Start409

         mov       ax,27
         cmp       dx,0d12h
         je        Start409

         cmp       dl,PSIRKA
         jae       Start402
         cmp       dh,PVYSKA
         jae       Start402
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         mov       ds:[PetrPoz],dx         ; nov pozice Petra
         call      DispPet                  ; nov zobrazen Petra
         jmp       short Start402

Start408:

Start409: cmp       al,27
         jne       Start411
         jmp       Konec

Start411:cmp       ax,4800h
         jne       Start42
         call      PetKrok
Start418:jmp       Start32

Start42: cmp       ax,5000h
         jne       Start43
         call      PetVzad
         jmp       short Start418

Start43: cmp       ax,4b00h
         jne       Start44
         call      PetVlevo
         jmp       short Start418

Start44: cmp       ax,4d00h
         jne       Start45
         call      PetVprav
         jmp       short Start418

Start45: cmp       al,13                    ; ENTER
         je        Start5

         cmp       ax,3e00h                 ; F4: editace ikon
         je        Start6                   ; editace ikon

         cmp       ax,4300h                 ; F9
         jne       Start452
         jmp       StartPrg                 ; nov start programu

Start452:

         mov       bx,ds:[ICOLast]          ; naposledy zvolen ikona
         cmp       al," "
         je        Start46

         call      UpCase
         sub       al,"A"
         jb        Start418
         cmp       al,26
         ja        Start418
         mov       ah,0                     ; AX = slo ikony
         xchg      ax,bx
Start46: xchg      ax,bx
Start47: call      PetPredm                 ; poloen pedmtu AX
         jmp       short Start418

; ------ volba ikony

Start5:  call      VolIcon                  ; volba ikony
         jc        Start52                  ; peruen operace
         mov       ds:[ICOLast],ax          ; schova ikony
         call      IniVymaz                 ; inicializan vymazn obrazovky
         jmp       short Start47            ; poloen pedmtu

Start52: call      IniVymaz                 ; inicializan vymazn obrazovky
         jmp       Start32

; ------ editace ikon

Start6:

         call      VolIcon                  ; volba ikony
         jc        Start52                  ; peruen operace
         call      EditIcon                 ; editace ikony AX
         jmp       short Start6             ; dal ikona


Konec:   mov       ax,3
         int       10h

         mov       ah,9
         mov       dx,offset UvTxt
         int       21h

; ------ zobrazen zbvajc voln pamti

         mov       ax,ds:[DataICO]          ; segment potku ikon
         mov       bx,ds:[DataNum]          ; poet bajt programu
         mov       cl,4
         shr       bx,cl
         sub       ax,bx                    ; odeten programu
         sub       ax,ds:[DataProg]
         jnc       Konec12
         xor       ax,ax
Konec12: mov       cl,10-4
         shr       ax,cl                    ; pevod na KB
         push      ds
         pop       es
         mov       di,offset ZbyvMem2
         call      DekNumR                  ; dekdovn sla

         mov       dx,offset ZbyvMem
         mov       ah,9
         int       21h

; ------ konec (sem se vrac pi peruen programu)

Konec1:  push      ds
         mov       ax,2508h
         lds       dx,ds:[Old08]            ; pvodn adresa INT 08h
         int       21h                      ; navrcen adresy INT 08h
         pop       ds

         push      ds
         mov       ax,2509h
         lds       dx,ds:[Old09]            ; pvodn adresa INT 09h
         int       21h                      ; navrcen adresy INT 09h
         pop       ds

         push      ds
         mov       ax,251Bh
         lds       dx,ds:[Old1B]            ; pvodn adresa INT 1Bh
         int       21h                      ; navrcen adresy INT 1Bh
         pop       ds

         mov       ax,4c00h
         int       21h

; *****************************************************************************
;
;                             Obsluha Petra
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        nastaven prvku pole
; -----------------------------------------------------------------------------

PetPole  PROC      NEAR

; ------ naten souadnice X pole -> CX

         call      VyrazPrg                 ; naten souadnice X pole
         jc        PetPole9                 ; chyba
         cmp       ax,PSIRKA                ; je platn souadnice ?
         jb        PetPole1                 ; souadnice je OK
         mov       al,PSIRKA                ; pznak peteen souadnice X

; ------ naten souadnice Y pole -> CX

PetPole1:push      ax                       ; AL = souadnice X pole
         call      VyrazPrg                 ; naten souadnice Y pole
         pop       dx                       ; DL <- souadnice X pole
         jc        PetPole9                 ; chyba
         mov       dh,al                    ; DH <- souadnice Y pole
         cmp       ax,PVYSKA                ; je platn souadnice ?
         jb        PetPole2                 ; souadnice je OK
         mov       dh,PVYSKA                ; pznak peteen souadnice Y

; ------ vyputn znaku rovntka

PetPole2:call      PetRovn                  ; vyputn znaku rovntka

; ------ naten sla pedmtu

PetPole3:push      dx
         call      VyrazPrg                 ; naten sla pedmtu
         pop       dx
         jc        PetPole8                 ; nen dal pedmt
         cmp       ax,ds:[DataICON]         ; je to platn slo ?
         jae       PetPole4                 ; nen platn slo pedmtu

; ------ kontrola peteen ukazatel pole

         cmp       dh,PVYSKA                ; je platn souadnice Y ?
         jae       PetPole5                 ; souadnice mimo rozsah
         cmp       dl,PSIRKA                ; je platn souadnice X ?
         jae       PetPole5                 ; souadnice mimo rozsah

; ------ test blokovn pkaz

         call      TestBlok                 ; test blokovn programu
         jnz       PetPole4                 ; je blokovn pkaz

; ------ uloen pedmtu AX na pozici DX

         xchg      ax,bx                    ; BX <- pedmt
         mov       al,PSIRKA                ; poet pozic na dek
         mul       dh                       ; pepoet dku na pozici
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; offset v tabulce pole
         xchg      ax,bx                    ; BX <- offset v poli, AX <- pedmt
         mov       ds:[bx+Pole],ax          ; uloen pedmtu

; ------ zobrazen novho pedmtu

         call      PoleIcon                 ; zobrazen pedmtu na nov pozici

; ------ zven ukazatele pozice

PetPole4:inc       dx                       ; zven ukazatele pozice

; ------ test, zda bude dal poloka

PetPole5:call      PetCark                  ; naten znaku rky
         jnc       PetPole3                 ; je rka - bude dal pedmt
PetPole8:clc                                ; pznak operace OK
PetPole9:ret

PetPole  ENDP

; -----------------------------------------------------------------------------
;        obnoven obrzku ped Petkem
; -----------------------------------------------------------------------------

PetObn   PROC      NEAR

         call      GetPred                  ; naten pedmtu
         jnc       PetKres2                 ; je platn pedmt
         clc                                ; pznak operace OK
         ret

PetObn   ENDP

; -----------------------------------------------------------------------------
;        zobrazen obrzku zadanho slem -> CY=peruen
; -----------------------------------------------------------------------------

PetNPre  PROC      NEAR

         call      VyrazPrg                 ; naten sla pedmtu
         jc        PetKres9                 ; chyba
         cmp       ax,ds:[DataICON]         ; je to platn slo ?
         jb        PetKres2                 ; je to platn slo
         mov       ax,ds:[ICONic]           ; przdn polko
         jmp       short PetKres2

PetNPre  ENDP

; -----------------------------------------------------------------------------
;        vykreslen obrzku programem -> CY=peruen
; -----------------------------------------------------------------------------

PetKresl PROC      NEAR

         call      WordPrg                  ; naten adresy ikony
         jc        PetKres9                 ; chyba
PetKres2:call      TestBlok                 ; test blokovn programu
         jnz       PetKres9                 ; je blokovn programu
         call      PetPredm                 ; vykreslen pedmtu
         jc        PetKres9                 ; chyba
         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetKres9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok (CY=peruen)
PetKres9:ret

PetKresl ENDP

; -----------------------------------------------------------------------------
;        vykreslen obrzku s maskou -> CY=peruen
; -----------------------------------------------------------------------------

PetMask  PROC      NEAR

         call      WordPrg                  ; naten adresy ikony
         jc        PetMask9                 ; chyba
         call      TestBlok                 ; test blokovn programu
         jnz       PetMask9                 ; je blokovn programu
         call      PetMPred                 ; vykreslen pedmtu
         jc        PetMask9                 ; chyba
         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetMask9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok (CY=peruen)
PetMask9:ret

PetMask ENDP

; -----------------------------------------------------------------------------
;        nastaven horizontln nov pozice Petra -> CY=peruen
; -----------------------------------------------------------------------------

PetPozX  PROC      NEAR

         call      PetRovn                  ; peskoen znaku rovntka

         call      VyrazPrg                 ; naten pozice
         jc        PetPozX9                 ; chyba

         cmp       ax,PSIRKA                ; je pozice OK ?
         jb        PetPozX2                 ; pozice je OK
         mov       al,PSIRKA-1              ; omezen pozice

PetPozX2:call      TestBlok                 ; test blokovn programu
         jnz       PetPozX9                 ; je blokovn programu

         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       al,byte ptr ds:[PetrPoz] ; zmnila se pozice ?
         je        PetPozX9                 ; pozice se nezmnila
         mov       byte ptr ds:[PetrPoz],al ; nov pozice Petra

         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetPozX9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok (CY=peruen)
PetPozX9:ret

PetPozX  ENDP

; -----------------------------------------------------------------------------
;        nastaven vertikln nov pozice Petra -> CY=peruen
; -----------------------------------------------------------------------------

PetPozY  PROC      NEAR

         call      PetRovn                  ; peskoen znaku rovntka

         call      VyrazPrg                 ; naten pozice
         jc        PetPozY9                 ; chyba

         cmp       ax,PVYSKA                ; je dek OK ?
         jb        PetPozY2                 ; dek je OK
         mov       al,PVYSKA-1              ; omezen dku

PetPozY2:call      TestBlok                 ; test blokovn programu
         jnz       PetPozY9                 ; je blokovn programu

         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       al,byte ptr ds:[PetrPoz+1] ; zmnil se dek ?
         je        PetPozY9                 ; dek se nezmnil
         mov       byte ptr ds:[PetrPoz+1],al ; nov dek Petra

         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetPozY9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok (CY=peruen)
PetPozY9:ret

PetPozY  ENDP

; -----------------------------------------------------------------------------
;        poloen pedmtu AX ped Petra -> CY=chyba, je okraj
; -----------------------------------------------------------------------------

PetPredm PROC      NEAR

; ------ schova registr

         push      bx
         push      dx
         xchg      ax,dx                    ; DX <- pedmt

; ------ pt pozice Petra -> BX

         call      NextPoz                  ; pt pozice -> BX
         jc        PetPred8                 ; chyba

; ------ uloen pedmtu na novou pozici

         mov       al,PSIRKA                ; poet pozic na dek
         mul       bh                       ; pepoet dku na pozici
         add       al,bl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; offset v tabulce pole
         xchg      ax,bx                    ; BX <- offset v poli
         mov       ds:[bx+Pole],dx          ; uloen pedmtu

; ------ zobrazen novho pedmtu

         xchg      ax,dx                    ; AX <- pedmt, DX <- souadnice
         call      PoleIcon                 ; zobrazen pedmtu na nov pozici
         xchg      ax,dx
         clc                                ; pznak operace OK
         jmp       short PetPred9

; ------ chyba operace - je okraj

PetPred8:push      si
         push      cx

         mov       si,offset OkrajTxt
         mov       ax,9b9bh                 ; barva
         mov       cx,2*18                  ; poadovan doba
         call      DispHlas                 ; zobrazen hlen
         cli
         mov       word ptr ds:[UkazMel],offset OkrajTon ; melodie
         mov       word ptr ds:[CitacMel],5 ; poet tn
         sti

         pop       cx
         pop       si
         stc                                ; pznak chyby operace

; ------ nvrat registr

PetPred9:xchg      ax,dx                    ; AX <- nvrat pedmtu
         pop       dx
         pop       bx
         ret

PetPredm ENDP

; -----------------------------------------------------------------------------
;        nsledujc pozice -> BX, CY=je okraj (BH nebo BL je mimo rozsah)
; -----------------------------------------------------------------------------

NextPoz  PROC      NEAR

; ------ schova registr

         push      ax

; ------ ukazatel pozice Petra

         mov       ah,0
         mov       al,ds:[PetrSme]         ; smr Petra
         mov       bx,ds:[PetrPoz]         ; dek a pozice Petra

; ------ smr vpravo

         dec       ax                       ; 1 = vpravo
         jnz       NextPoz1                 ; nen vpravo
         inc       bl                       ; smr vpravo

; ------ smr dol

NextPoz1:dec       ax                       ; 2 = dol
         jnz       NextPoz2
         inc       bh                       ; smr dol

; ------ smr vlevo

NextPoz2:dec       ax                       ; 3 = vlevo
         jnz       NextPoz3
         dec       bl                       ; smr vlevo

; ------ smr nahoru

NextPoz3:dec       ax                       ; 4 = nahoru
         jnz       NextPoz4
         dec       bh                       ; smr nahoru

; ------ kontrola peteen pozice a dku

NextPoz4:cmp       bl,PSIRKA                ; kontrola pozice
         jae       NextPoz5                 ; chyba
         cmp       bh,PVYSKA                ; kontrola dku
NextPoz5:cmc                                ; CY=peteen okraje

; ------ nvrat registr

NextPoz9:pop       ax
         ret

NextPoz  ENDP

; -----------------------------------------------------------------------------
;        zobrazen pedmtu AX s maskou ped Petra -> CY=chyba, je okraj
; -----------------------------------------------------------------------------

PetMPred PROC      NEAR

; ------ schova registr

         push      bx
         push      dx

; ------ pt pozice Petra -> BX

         call      NextPoz                  ; pt pozice -> BX
         jc        PetMPre4                 ; chyba

; ------ zobrazen novho pedmtu

         mov       dx,bx                    ; DX <- souadnice
         call      PoleMask                 ; zobrazen pedmtu na nov pozici
         clc                                ; pznak operace OK
         jmp       short PetMPre8

; ------ chyba operace - je okraj

PetMPre4:push      si
         push      cx
         push      ax

         mov       si,offset OkrajTxt
         mov       ax,9b9bh                 ; barva
         mov       cx,2*18                  ; poadovan doba
         call      DispHlas                 ; zobrazen hlen
         cli
         mov       word ptr ds:[UkazMel],offset OkrajTon ; melodie
         mov       word ptr ds:[CitacMel],5 ; poet tn
         sti

         pop       ax
         pop       cx
         pop       si
         stc                                ; pznak chyby operace

; ------ nvrat registr

PetMPre8:pop       dx
         pop       bx
         ret

PetMPred ENDP

; -----------------------------------------------------------------------------
;        otoen na sever (-> CY=peruen)
; -----------------------------------------------------------------------------

PetSev   PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetSev9                  ; je blokovn
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       byte ptr ds:[PetrSme],4  ; je ji otoen ?
         je        PetSev9                  ; je ji otoen
         mov       byte ptr ds:[PetrSme],4 ; nahoru = sever
         jmp       PetVlev3

PetSev9: ret

PetSev   ENDP

; -----------------------------------------------------------------------------
;        otoen na jih (-> CY=peruen)
; -----------------------------------------------------------------------------

PetJih   PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetJih9                  ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       byte ptr ds:[PetrSme],2  ; je ji otoen ?
         je        PetJih9                  ; je ji otoen
         mov       byte ptr ds:[PetrSme],2  ; dol = jih
         jmp       short PetVlev3

PetJih9: ret

PetJih   ENDP

; -----------------------------------------------------------------------------
;        otoen na vchod (-> CY=peruen)
; -----------------------------------------------------------------------------

PetVych  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetVych9                 ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       byte ptr ds:[PetrSme],1  ; je ji otoen ?
         je        PetVych9                 ; je ji otoen
         mov       byte ptr ds:[PetrSme],1  ; vpravo = vchod
         jmp       short PetVlev3

PetVych9:ret

PetVych  ENDP

; -----------------------------------------------------------------------------
;        otoen na zpad (-> CY=peruen)
; -----------------------------------------------------------------------------

PetZap   PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetZap9                  ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       byte ptr ds:[PetrSme],3  ; je ji otoen ?
         je        PetZap9                  ; je ji otoen
         mov       byte ptr ds:[PetrSme],3  ; vlevo = zpad
         jmp       short PetVlev3

PetZap9: ret

PetZap   ENDP

; -----------------------------------------------------------------------------
;        otoen vzad (-> CY=peruen)
; -----------------------------------------------------------------------------

PetVzad  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetVlev9                 ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         sub       byte ptr ds:[PetrSme],2  ; posun smru vzad
         jmp       short PetVlev2

PetVzad  ENDP

; -----------------------------------------------------------------------------
;        otoen vlevo (-> CY=peruen)
; -----------------------------------------------------------------------------

PetVlevo PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetVlev9                 ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         sub       byte ptr ds:[PetrSme],1  ; posun vlevo
PetVlev2:ja        PetVlev3                 ; nen podteen
         add       byte ptr ds:[PetrSme],4  ; posun nahoru
PetVlev3:test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetVlev9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok
PetVlev9:ret

PetVlevo ENDP

; -----------------------------------------------------------------------------
;        otoen vpravo (-> CY=peruen)
; -----------------------------------------------------------------------------

PetVprav PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetVlev9                 ; je blokovn pkaz
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         sub       byte ptr ds:[PetrSme],3  ; zmna smru vpravo
         jmp       short PetVlev2

PetVprav ENDP

; -----------------------------------------------------------------------------
;        nastaven smru Petra -> CY=peruen
; -----------------------------------------------------------------------------

PetSmer  PROC      NEAR

         call      PetRovn                  ; peskoen znaku rovntka

         call      VyrazPrg                 ; naten smru
         jc        PetSmer9                 ; chyba

         dec       ax
         and       ax,3                     ; maskovn smru
         inc       ax

         call      TestBlok                 ; test blokovn programu
         jnz       PetSmer9                 ; je blokovn programu

         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text
         cmp       al,ds:[PetrSme]          ; je smr ji nastaven ?
         je        PetSmer9                 ; nen poteba nastavovat
         mov       ds:[PetrSme],al          ; nastaven novho smru

         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetSmer9                 ; je TURBO reim
         call      CekKrokD                 ; ekn na jeden krok (CY=peruen)
PetSmer9:ret

PetSmer  ENDP

; -----------------------------------------------------------------------------
;        krok vped -> CY=chyba, je ze
; -----------------------------------------------------------------------------

PetKrok  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetVlev9                 ; je blokovn pkaz

; ------ schova registr

         push      ax
         push      bx

; ------ test, zda je ped Petrem ze

         call      TestZed                  ; test zdi ped Petrem
         jc        PetKrok0                 ; nen ze

; ------ chyba - nraz do zdi

         push      cx
         push      si

         mov       si,offset NarazTxt
         mov       ax,9b9bh                 ; barva
         mov       cx,2*18                  ; poadovan doba
         call      DispHlas                 ; zobrazen hlen
         cli
         mov       word ptr ds:[UkazMel],offset NarazTon ; melodie
         mov       word ptr ds:[CitacMel],5 ; poet tn
         sti

         pop       si
         pop       cx
         stc                                ; pznak chyby - je ze
         jmp       PetKrok9

; ------ nastaven nov pozice Petra

PetKrok0:call      NextPoz                  ; pt pozice -> BX
         xchg      bx,ds:[PetrPoz]         ; nov pozice Petra
         mov       byte ptr ds:[TextRad],-1 ; neplatn slo dku pro text

; ------ test, zda se m Petr zobrazovat

         test      byte ptr ds:[Param],bit0 ; je TURBO reim ?
         jnz       PetKrok9                 ; je TURBO reim
         cmp       bx,ds:[PetrOPz]         ; byl zobrazen na pedel pozici ?
         jne       PetKrok7                 ; nebyl na pedel pozici

; ------ vymazn Petra na pedel pozici

         call      MazPet                   ; vymazn Petra na pedel pozici

; ------ schova registr

         push      cx
         push      dx

         mov       dx,bx                    ; DX <- star pozice Petra

; ------ uren ikony k zobrazen kroku -> AX

         mov       bh,0
         mov       bl,ds:[PetrSme]          ; smr Petra
         dec       bx                       ; 1 = vpravo
         jnz       PetKrk42
         mov       ax,ds:[ICOPetR]          ; pohle zprava
PetKrk42:dec       bx                       ; 2 = dol
         jnz       PetKrk44                 ; nen vpravo
         mov       ax,ds:[ICOPetP]          ; pohled zepedu
PetKrk44:dec       bx                       ; 3 = vlevo
         jnz       PetKrk46
         mov       ax,ds:[ICOPetL]          ; pohled zleva
PetKrk46:dec       bx                       ; 4 = nahoru
         jnz       PetKrk48
         mov       ax,ds:[ICOPetZ]          ; pohled zezadu

; ------ uren prustku kroku -> BX

PetKrk48:mov       bx,ds:[PetrPoz]
         sub       bl,dl                    ; zmna pozice
         sub       bh,dh                    ; zmna dku

         shl       dx,1
         shl       dx,1
         add       dx,101h

; ------ zobrazen posouvanho Petra (ikona AX)

         mov       cx,3                     ; poet krok
PetKrok5:add       dl,bl                    ; zven pozice
         add       dh,bh                    ; zven dku
         call      MaskIcon                 ; zobrazen Petra na nov pozici

; ------ ekn po dobu jednoho kroku

         call      CekKrok                  ; ekn na jeden krok

; ------ vymazn Petra na mezipozici

         pushf
         push      dx
         mov       dx,ds:[PetrOPz]          ; star pozice
         call      PoleIcon                 ; zobrazen pedmtu na star pozici
         mov       dx,ds:[PetrPoz]          ; nov pozice
         call      PoleIcon                 ; zobrazen pedmtu na nov pozici
         pop       dx
         popf

; ------ dal krok

         jc        PetKrok6                 ; peruen
         loop      PetKrok5                 ; dal krok

; ------ nvrat registr

PetKrok6:pop       dx
         pop       cx
         jc        PetKrok9                 ; peruen

; ------ zobrazen Petra na nov pozici

PetKrok7:call      CekKrokD                 ; ekn na jeden krok (CY=peruen)

; ------ nvrat registr

PetKrok9:pop       bx
         pop       ax
         ret

PetKrok  ENDP

; -----------------------------------------------------------------------------
;        test prchodnosti, zda je ped Petrem ze -> NC=je ze
; -----------------------------------------------------------------------------

TestZed  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx

; ------ pt pozice

         call      NextPoz                  ; pt pozice -> BX
         jc        TestZed8                 ; chyba

; ------ kontrola, zda je na nov pozici ze

         test      byte ptr ds:[Param],bit0 ; je TURBO ?
         jnz       TestZed5                 ; je TURBO

         mov       al,PSIRKA                ; poet pozic na dek
         mul       bh                       ; pepoet dku na pozici
         mov       bh,0
         add       ax,bx                    ; piten pozice
         shl       ax,1                     ; offset v tabulce pole
         xchg      ax,bx                    ; BX <- offset v poli
         mov       ax,ds:[ICOZed]           ; ikona zdi
         cmp       ax,ds:[bx+Pole]          ; je to ze ?
TestZed5:stc                                ; pznak, e nen ze
         jne       TestZed9                 ; nen ze

; ------ je ze

TestZed8:clc                                ; pznak, e je ze

; ------ nvrat registr

TestZed9:pop       bx
         pop       ax
         ret

TestZed  ENDP

; -----------------------------------------------------------------------------
;        naten pedmtu ped Petrem -> AX (CY=je mimo okraj, AX nezmnn)
; -----------------------------------------------------------------------------

GetPred  PROC      NEAR

; ------ schova registr

         push      bx

; ------ pt pozice

         call      NextPoz                  ; pt pozice -> BX
         jc        GetPred9                 ; chyba

; ------ naten pedmtu ped Petrem

         mov       al,PSIRKA                ; poet pozic na dek
         mul       bh                       ; pepoet dku na pozici
         mov       bh,0
         add       ax,bx                    ; piten pozice
         shl       ax,1                     ; offset v tabulce pole
         xchg      ax,bx                    ; BX <- offset v poli
         mov       ax,ds:[bx+Pole]          ; naten pedmtu

; ------ nvrat registr

GetPred9:pop       bx
         ret

GetPred  ENDP

; -----------------------------------------------------------------------------
;        zapnut rychlho reimu
; -----------------------------------------------------------------------------

PetRych  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetRych9                 ; je blokovn pkaz
         or        byte ptr ds:[Param],bit0 ; zapnut TURBO
PetRych9:ret

PetRych  ENDP

; -----------------------------------------------------------------------------
;        zapnut pomalho reimu
; -----------------------------------------------------------------------------

PetPom   PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetPom9                  ; je blokovn pkaz
         and       byte ptr ds:[Param],not bit0 ; vypnut TURBO
PetPom9: ret

PetPom   ENDP

; -----------------------------------------------------------------------------
;        vymazn Petra na star pozici
; -----------------------------------------------------------------------------

MazPet   PROC      NEAR

         push      dx

         test      byte ptr ds:[Param],bit3 ; je Petr zobrazen ?
         jz        MazPet6                  ; Petr nen zobrazen
         mov       dx,ds:[PetrOPz]          ; star pozice Petra
         call      PoleIcon                 ; zobrazen pedmtu na star pozici

MazPet6: pop       dx
         ret

MazPet   ENDP

; -----------------------------------------------------------------------------
;        podmnn zobrazen Petra na aktuln pozici (s ppadnm vymaznm)
; -----------------------------------------------------------------------------

DispPet  PROC      NEAR

; ------ schova registr

         push      ax
         push      dx
         push      es

; ------ kontrola, zda je poteba Petra vymazat na star pozici

         test      byte ptr ds:[Param],bit3 ; je Petr zobrazen ?
         jz        DispPet3                 ; Petr nen zobrazen
         mov       dx,ds:[PetrOPz]         ; star pozice Petra
         cmp       dx,ds:[PetrPoz]         ; byla pozice zmnna ?
         jne       DispPet2                 ; pozice byla zmnna

; ------ kontrola, zda je poteba Petra pekreslovat

         mov       dl,ds:[PetrSme]         ; smr Petra
         cmp       dl,ds:[PetrOSm]         ; je zmnn smr ?
         je        DispPet8                 ; nen poteba pekreslen

; ------ vymazn Petra na star pozici

DispPet2:call      MazPet                   ; vymazn Petra na star pozici

; ------ zobrazen Petra

DispPet3:mov       dh,0
         mov       dl,ds:[PetrSme]         ; smr Petra
         mov       ds:[PetrOSm],dl         ; schova smru Petra

; ------ smr vpravo

         dec       dx                       ; 1 = vpravo
         jnz       DispPet4                 ; nen vpravo
         mov       ax,ds:[ICOPetR]          ; pohled zprava

; ------ smr dol

DispPet4:dec       dx                       ; 2 = dol
         jnz       DispPet5
         mov       ax,ds:[ICOPetP]          ; pohle zepedu

; ------ smr vlevo

DispPet5:dec       dx                       ; 3 = vlevo
         jnz       DispPet6
         mov       ax,ds:[ICOPetL]          ; pohled vlevo

; ------ smr nahoru

DispPet6:dec       dx                       ; 4 = nahoru
         jnz       DispPet7
         mov       ax,ds:[ICOPetZ]          ; pohled zezadu

; ------ schova aktulnho stavu

DispPet7:or        byte ptr ds:[Param],bit3 ; pznak zobrazen Petra
         mov       dx,ds:[PetrPoz]         ; aktuln pozice
         mov       ds:[PetrOPz],dx         ; schova zobrazen pozice

; ------ zobrazen Petra na nov pozici

         shl       dx,1
         shl       dx,1
         add       dx,101h
         call      MaskIcon

; ------ nvrat registr

DispPet8:pop       es
         pop       dx
         pop       ax
         ret

DispPet  ENDP

; *****************************************************************************
;
;                              Obsluha programu
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        proveden programu
; -----------------------------------------------------------------------------

ExecPrg  PROC      NEAR

         and       byte ptr ds:[Param],not bit4 ; nen peruen cyklu
         mov       word ptr ds:[BlokIf],0   ; odblokovn pkaz
         call      NulBreak                 ; nulovn pznaku peruen

; ------ pprava minimlnho povolenho SP

         mov       cl,4
         mov       ax,ds:[DataNum]          ; poet bajt v bufferu programu
         add       ax,0fh                   ; zarovnn na odstavec
         shr       ax,cl                    ; pevod na odstavce
         add       ax,ds:[DataProg]         ; zatek volnho bloku (segment)
         mov       bx,ds:[DataICO]          ; buffer ikon
         sub       bx,ax                    ; voln msto v bufferu
         jc        ExecPrg9                 ; peteen pamti
         cmp       bx,0e80h                 ; je vce voln pamti ?
         jb        ExecPrg2                 ; nen vce pamti
         mov       bx,0e80h                 ; omezen velikosti pamti
ExecPrg2:shl       bx,cl                    ; pevod na bajty
         mov       ax,0f200h                ; to se nastav pro SP + rezerva
         sub       ax,bx                    ; minimln nutn adresa
         mov       ds:[MinSP],ax            ; minimln povolen adresa SP
         cmp       ax,0ef00h                ; je dost voln pamti ?
         ja        ExecPrg9                 ; je mlo voln pamti

; ------ schova ukazatele zsobnku

         mov       ds:[RegSS],ss            ; schova ukazatele SS
         mov       ds:[RegSP],sp            ; schova ukazatele SP

; ------ pedefinovn ukazatele zsobnku

         cli
         mov       ax,ds:[DataICO]          ; buffer ikon
         sub       ax,0f10h                 ; buffer pro SS
         mov       ss,ax                    ; buffer zsobnku
         mov       sp,0f000h                ; ukazatel zsobnku
         sti

; ------ provdn pkaz

         mov       ax,ds:[MainProg]         ; offset hlavnho programu
         mov       word ptr ds:[UkazProg],ax ; nulovn ukazatele programu

         xor       bp,bp                    ; inicializace lokln promnn
ExecPrg6:call      ExePrik                  ; proveden jednoho pkazu
         jnc       ExecPrg6                 ; dal pkaz

; ------ nvrat ukazatele zsobnku

         cli
         mov       ss,ds:[RegSS]            ; nvrat registru SS
         mov       sp,ds:[RegSP]            ; nvrat registru SP
         sti
ExecPrg9:ret

ExecPrg  ENDP

RegSS    dw        0                        ; schova registru SS
RegSP    dw        0                        ; schova registru SP
MinSP    dw        0                        ; minimln povolen SP

; -----------------------------------------------------------------------------
;        test blokovn programu -> NZ=je blokovn, vrac vdy NC
; -----------------------------------------------------------------------------

TestBlok PROC      NEAR

         test      byte ptr ds:[Param],bit4 ; je peruen cyklu ?
         jnz       TestBlk9                 ; je peruen cyklu
         cmp       word ptr ds:[BlokIf],0   ; je blokovn pkaz IF ?
;         jne       PetBlk9                  ; je blokovn pkaz
TestBlk9:ret

TestBlok ENDP

; -----------------------------------------------------------------------------
;        lev zvorka
; -----------------------------------------------------------------------------

PetLZav  PROC      NEAR

PetLZav2:call      BytePrg                  ; naten dalho bajtu
         jc        PetLZav8                 ; nen dal bajt
         cmp       al,KOD_RZAV              ; je prav zvorka ?
         je        PetLZav8                 ; je prav zvorka - konec
         dec       word ptr ds:[UkazProg]   ; nvrat ukazatele programu
         call      ExePrik                  ; dal pkaz
         jnc       PetLZav2                 ; dal pkaz
PetLZav8:ret

PetLZav  ENDP

; -----------------------------------------------------------------------------
;        przdn operace
; -----------------------------------------------------------------------------

PetNop   PROC      NEAR

         clc
         ret

PetNop   ENDP

; -----------------------------------------------------------------------------
;        proveden jednoho pkazu (CY=konec nebo chyba) (ni AX a BX !)
; -----------------------------------------------------------------------------

ExePrik  PROC      NEAR

         cmp       sp,ds:[MinSP]            ; je peteen zsobnku ?
         jb        ExePrik2                 ; je peteen zsobnku

         call      TstBreak                 ; test peruen programu
         jc        ExePrik2                 ; je peruen programu

         call      BytePrg                  ; naten jednoho bajtu
         jc        ExePrik2                 ; konec programu
         mov       ah,0
         shl       ax,1
         xchg      ax,bx                    ; BX <- offset v tabulce
         jmp       word ptr ds:[PrikazX+bx-2] ; skok na obsluhu pkazu

ExePrik2:ret

ExePrik  ENDP

; -----------------------------------------------------------------------------
;        vyvoln procedury -> AX = nvratov hodnota (z lokln promnn)
; -----------------------------------------------------------------------------

PetProc  PROC      NEAR

         push      bp                       ; schova lokln promnn
; BP zstv nastaveno z externho programu !

         call      WordPrg                  ; naten parametru (slovo)
         jc        PetProc9                 ; chyba

         push      word ptr ds:[UkazProg]   ; schova ukazatele programu

         mov       ds:[UkazProg],ax         ; nov ukazatel programu
         mov       al,ds:[Param]            ; parametry (pznak TURBO)

         push      ax                       ; schova pznaku TURBO
         call      ExePrik                  ; proveden jednoho pkazu
         pop       ax                       ; nvrat pznaku TURBO

         pop       word ptr ds:[UkazProg]   ; nvrat ukazatele programu

         jc        PetProc9                 ; peruen operace

         mov       ah,ds:[Param]            ; pznak TURBO po operaci
         and       al,bit0                  ; pznak TURBO ped operac
         and       byte ptr ds:[Param],not bit0 ; nulovn souasnho pznaku
         or        ds:[Param],al            ; navrcen pznaku TURBO

         test      ah,bit0                  ; mla procedura TURBO zapnut ?
         jz        PetProc9                 ; nemla TURBO zapnut
         test      al,bit0                  ; navrtil se bاn reim ?
         jnz       PetProc9                 ; navrtil se reim TURBO
         call      CekKrokD                 ; prodleva po operaci

PetProc9:xchg      ax,bp                    ; nvratov hodnota procedury
         pop       bp
         ret

PetProc  ENDP

; -----------------------------------------------------------------------------
;        zobrazen hlen
; -----------------------------------------------------------------------------

PetHlas  PROC      NEAR

; ------ pprava textu hlen

         call      IniHlas                  ; pprava textu hlen
         jc        PetHlas9                 ; chyba

; ------ test, zda je blokovn pkazu

         call      TestBlok                 ; test blokovn programu
         jnz       PetHlas9                 ; je blokovn pkaz

; ------ zobrazen textu hlen

         mov       si,offset ProgStr        ; text hlen
         mov       ax,99h                   ; barva textu - ern/erven
         mov       cx,-1                    ; doba = -1
         call      DispHlas                 ; zobrazen hlen
         clc
PetHlas9:ret

PetHlas  ENDP

; -----------------------------------------------------------------------------
;        inicializace textu pro pkazy HLASENI a TEXT -> CY=peruen
; -----------------------------------------------------------------------------

IniHlas  PROC      NEAR

; ------ naten dlky textu hlen -> AX, CX

         call      BytePrg                  ; naten nsledujcho bajtu
         jc        IniHlas9                 ; chyba
         mov       ah,0                     ; AX = dlka textu
         xchg      ax,cx                    ; CX <- dlka textu
         mov       di,offset ProgStr+1      ; buffer k uloen textu
         mov       byte ptr ds:[di-1],0     ; inicializace tae dlky

; ------ pprava ukazatele parametr za programem -> DX

         mov       dx,ds:[UkazProg]         ; ukazatel programu
         add       dx,cx                    ; adresa za etzcem
         jcxz      IniHlas8                 ; dlka textu = 0

; ------ uloen etzce hlen

IniHlas2:call      BytePrg                  ; naten dalho bajtu
         mov       ds:[di],al               ; uloen znaku do bufferu
         inc       di                       ; zven ukldac adresy

; ------ test, zda je seln parametr

         cmp       word ptr ds:[di-2],"#%"  ; je seln parametr ?
         jne       IniHlas5                 ; nen seln parametr
         sub       byte ptr ds:[ProgStr],2  ; 2 znaky se nepotaj
         dec       di
         dec       di                       ; zruen znak z bufferu

; ------ vpoet selnho parametru -> AX

         xchg      dx,ds:[UkazProg]         ; ukazatel parametr
         push      cx
         push      dx
         push      di
         call      VyrazPrg                 ; naten hodnoty vrazu -> AX
         pop       di
         pop       dx
         pop       cx
         xchg      dx,ds:[UkazProg]         ; nvrat ukazatele parametr

; ------ uloen znamnka sla

         or        ax,ax                    ; je zporn slo ?
         jns       IniHlas3                 ; nen zporn slo
         mov       byte ptr ds:[di],"-"     ; znamnko sla
         inc       di                       ; zven ukazatele
         inc       byte ptr ds:[ProgStr]    ; zven tae dlky etzce
         neg       ax                       ; oprava znamnka sla

; ------ dekdovn sla AX do bufferu DS:DI

IniHlas3:mov       bx,di                    ; BX <- schova ukldac adresy
         call      DekNum                   ; dekdovn sla AX
         sub       bx,di                    ; BX <- -dlka textu
         neg       bx                       ; oprava znamnka dlky
         add       byte ptr ds:[ProgStr],bl ; zven tae dlky
         jmp       short IniHlas7           ; dal znak

; ------ test, zda je nastaven barvy

IniHlas5:cmp       word ptr ds:[di-2],"$%"  ; je nastaven barvy ?
         jne       IniHlas6                 ; nen nastaven barvy
         sub       byte ptr ds:[ProgStr],3  ; 3 znaky se nepotaj

; ------ test, zda je zmna barvy

IniHlas6:cmp       word ptr ds:[di-2],"*%"  ; je pepna barvy ?
         jne       IniHlas7                 ; nen pepna barvy
         sub       byte ptr ds:[ProgStr],2  ; 2 znaky se nepotaj
IniHlas7:inc       byte ptr ds:[ProgStr]    ; zven tae dlky
         loop      IniHlas2                 ; dal bajt

; ------ nvrat ukazatele programu

IniHlas8:mov       ds:[UkazProg],dx         ; nvrat ukazatele programu
         clc                                ; pznak operace OK
IniHlas9:ret

IniHlas  ENDP

; -----------------------------------------------------------------------------
;        hudba
; -----------------------------------------------------------------------------

PetMus   PROC      NEAR

; ------ naten dlky textu hlen -> CX

         call      BytePrg                  ; nsledujc bajt
         jc        PetMus1                  ; konec programu
         mov       ah,0                     ; AX = dlka textu
         xchg      ax,cx                    ; CX <- dlka textu

; ------ blokovn programu

         call      TestBlok                 ; test blokovn programu
         jz        PetMus2                  ; nen blokovn pkaz
         add       ds:[UkazProg],cx         ; zven ukazatele programu
PetMus1: jmp       PetMus8

; ------ inicializace ukazatel pehrvn (nejdve ta, kdyby bylo INT 08h!)

PetMus2: mov       word ptr ds:[CitacMel],0 ; nulovn tae melodie
         mov       word ptr ds:[UkazMel],offset BuffMel ; ukazatel melodie
         mov       di,offset BuffMel        ; buffer melodie
         mov       dx,49 + 8*HI             ; DL <- oktva=4, DH <- dlka tnu=4
         jcxz      PetMus1                  ; nen dn melodie
         mov       bl,0                     ; BL <- 0 nejsou pznaky

; ------ naten jednoho znaku

PetMus3: call      BytePrg                  ; naten jednoho bajtu
         jc        PetMus1                  ; konec programu
         call      UpCase                   ; konverze na velk psmeno

; ------ nastaven dlky tnu "1" a "8"

         cmp       al,"1"                   ; je slice 1 a 8 ?
         jb        PetMus4                  ; nen platn slice
         cmp       al,"8"
         ja        PetMus4                  ; nen platn slice
         sub       al,"1"                   ; relativn dlka tnu (0 a 7)
         push      cx
         xchg      ax,cx                    ; CL <- relativn dlka tnu
         mov       dh,bit0                  ; dlka tnu
         shl       dh,cl                    ; vpoet dlky tnu
         pop       cx
         jmp       short PetMus54           ; dal znak

; ------ zven oktvy "+"

PetMus4: cmp       al,"+"                   ; je zven oktvy ?
         jne       PetMs42                  ; nen zven oktvy
         cmp       dl,9*12                  ; maximln oktva
         jae       PetMus54                 ; je ji maximln oktva
         add       dl,12                    ; zven oktvy
         jmp       short PetMus54           ; dal znak

; ------ snen oktvy "-"

PetMs42: cmp       al,"-"                   ; je snen oktvy ?
         jne       PetMs44                  ; nen snen oktvy
         or        dl,dl                    ; minimln oktva
         jz        PetMus54                 ; je ji minimln oktva
         sub       dl,12                    ; snen oktvy
         jmp       short PetMus54           ; dal znak

; ------ prodlouen tnu o polovinu "." (BL <- bit0)

PetMs44: cmp       al,"."                   ; je prodlouen dlky tnu ?
         jne       PetMus5                  ; nen prodlouen dlky tnu
         or        bl,bit0                  ; pznak prodlouen dlky tnu
         jmp       short PetMus54           ; dal znak

; ------ zven tnu o pltn "#" (BL <- bit1)

PetMus5: cmp       al,"#"                   ; je zven o pltn ?
         jne       PetMus6                  ; nen zven o pltn
         or        bl,bit1                  ; pznak zven tnu o pltn
PetMus54:jmp       short PetMus7            ; dal znak

; ------ mezera "R"

PetMus6: mov       ah,0                     ; vka tnu pro prodlevu
         cmp       al,"R"                   ; je prodleva ?
         je        PetMs64                  ; je prodleva

; ------ vka tnu -> AH

         cmp       al,"C"
         je        PetMs62                  ; "C"

         mov       ah,2
         cmp       al,"D"
         je        PetMs62

         mov       ah,4
         cmp       al,"E"
         je        PetMs62

         mov       ah,5
         cmp       al,"F"
         je        PetMs62

         mov       ah,7
         cmp       al,"G"
         je        PetMs62

         mov       ah,9
         cmp       al,"A"
         je        PetMs62

         mov       ah,11
         cmp       al,"H"
         jne       PetMus7                  ; je nepovolen znak

PetMs62: add       ah,dl                    ; piten oktvy
         test      bl,bit1                  ; je zven o pltn ?
         jz        PetMs64                  ; nen zven o pltn
         inc       ah                       ; zven o pltn

; ------ uren dlky tnu

PetMs64: mov       al,0
         test      bl,bit0                  ; je prodlouen o polovinu ?
         jz        PetMs65                  ; nen prodlouen o polovinu
         mov       al,dh                    ; dlka tnu
         shr       al,1                     ; polovin dlka
PetMs65: add       al,dh                    ; dlka tnu

; ------ uloen tnu

         mov       ds:[di],ax               ; uloen tnu
         inc       di
         inc       di                       ; zven ukldav adresy
         inc       word ptr ds:[CitacMel]   ; zven tae hudby

; ------ dal znak

PetMus7: dec       cx                       ; ta znak
         jz        PetMus8                  ; konec
         jmp       PetMus3                  ; dal znak

PetMus8: clc                                ; pznak operace OK
PetMus9: ret

PetMus   ENDP

; -----------------------------------------------------------------------------
;        nastaven hodnoty vektoru
; -----------------------------------------------------------------------------

PetVekt  PROC      NEAR

; ------ naten indexu vektoru -> BX

         call      VyrazNum                 ; naten indexu vektoru
         jc        PetVekt9                 ; chyba - nen index
         shl       ax,1                     ; index * 2
         xchg      ax,bx                    ; BX <- adresa poloky vektoru

; ------ vyputn znaku rovntka

         call      PetRovn                  ; peskoen znaku rovntka

; ------ naten vrazu

PetVekt2:push      bx                       ; adresa poloky
         call      VyrazPrg                 ; naten hodnoty vrazu -> AX
         pop       bx
         jc        PetVekt8                 ; chyba

; ------ test blokovn pkaz

         call      TestBlok                 ; test blokovn programu
         jnz       PetVekt5                 ; je blokovn pkaz

; ------ uloen hodnoty vektoru

         push      es
         mov       es,ds:[DataVekt]         ; segment vektoru
         mov       es:[bx],ax               ; nastaven hodnoty vektoru
         pop       es

; ------ zven indexu vektoru

PetVekt5:inc       bx
         inc       bx                       ; zven indexu vektoru

; ------ test, zda bude dal poloka

         call      PetCark                  ; naten znaku rky
         jnc       PetVekt2                 ; je rka - bude dal poloka
PetVekt8:clc                                ; pznak operace OK
PetVekt9:ret

PetVekt  ENDP

; -----------------------------------------------------------------------------
;        vyprzdnn bufferu klvesnice
; -----------------------------------------------------------------------------

PetKlav  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetKlav4                 ; je blokovn pkaz

PetKlav2:call      InpChar                  ; vstup znaku z klvesnice
         jnc       PetKlav2                 ; je njak znak - zruen
PetKlav4:clc                                ; pznak operace OK
         ret

PetKlav  ENDP

; -----------------------------------------------------------------------------
;        nastaven hodnoty lokln promnn
; -----------------------------------------------------------------------------

PetMist  PROC      NEAR

         call      PetRovn                  ; peskoen znaku rovntka
         call      VyrazPrg                 ; naten hodnoty vrazu

         call      TestBlok                 ; test blokovn programu
         jnz       PetMist9                 ; je blokovn pkaz

         mov       bp,ax                    ; BP <- nastaven hodnoty promnn
PetMist9:clc
         ret

PetMist  ENDP

; -----------------------------------------------------------------------------
;        nastaven hodnoty promnn
; -----------------------------------------------------------------------------

PetProm  PROC      NEAR

         call      WordPrg                  ; naten adresy sla
         jc        PetProm9                 ; konec programu
         mov       di,ax                    ; DI <- adresa sla

         call      PetRovn                  ; peskoen znaku rovntka

         push      di
         call      VyrazPrg                 ; naten hodnoty vrazu
         pop       di

         call      TestBlok                 ; test blokovn programu
         jnz       PetProm9                 ; je blokovn pkaz

         push      es
         mov       es,ds:[DataProg]         ; segment programu
         mov       es:[di],ax               ; nastaven hodnoty promnn
         pop       es
                                          ;* zde je CY=konec programu
PetProm9:ret

PetProm  ENDP

; -----------------------------------------------------------------------------
;        peskoen znaku rovntka
; -----------------------------------------------------------------------------

PetRovn  PROC      NEAR

         push      ax
         call      BytePrg                  ; nsledujc bajt
         jc        PetRovn2                 ; konec programu
         cmp       al,KOD_ROVN              ; je rovntko ?
         je        PetRovn2                 ; je rovntko - vypust se
         dec       word ptr ds:[UkazProg]   ; nvrat ukazatele programu

PetRovn2:pop       ax
         clc                                ; pznak operace OK
         ret

PetRovn  ENDP

; -----------------------------------------------------------------------------
;        peskoen znaku rky -> CY=nebyla rka
; -----------------------------------------------------------------------------

PetCark  PROC      NEAR

         push      ax
         call      BytePrg                  ; nsledujc bajt
         jc        PetCark                  ; konec programu
         cmp       al,KOD_CARK              ; je rka ?
         je        PetCark2                 ; je rka - vypust se
         dec       word ptr ds:[UkazProg]   ; nvrat ukazatele programu
         stc                                ; pznak, e nen rka
PetCark2:pop       ax
         ret

PetCark  ENDP

; -----------------------------------------------------------------------------
;        slo - jako opakovn
; -----------------------------------------------------------------------------

PetCisl  PROC      NEAR

         call      WordPrg                  ; naten hodnoty sla
         jmp       short PetOpak0

PetCisl  ENDP

; -----------------------------------------------------------------------------
;        opakovn s potem
; -----------------------------------------------------------------------------

PetOpak  PROC      NEAR

         call      VyrazPrg                 ; naten parametru
PetOpak0:jc        PetOpak9                 ; chyba
         call      TestBlok                 ; test blokovn programu
         jnz       PetOpak1                 ; je blokovn pkaz
         xchg      ax,cx                    ; CX <- ta opakovn
         jmp       short PetOpak6           ; bude to bez poslednho cyklu

PetOpak1:call      ExePrik                  ; peskoen pkazu pi peruen
         ret

; ------ provdn pkaz uvnit smyky (bez poslednho prchodu)

PetOpak2:push      word ptr ds:[UkazProg]   ; schova ukazatele programu
         push      cx
         call      ExePrik                  ; proveden jednoho pkazu
         pop       cx
         pop       word ptr ds:[UkazProg]   ; nvrat ukazatele programu
         jc        PetOpak8                 ; chyba nebo peruen
         test      byte ptr ds:[Param],bit4 ; je peruen cyklu ?
         jnz       PetOpak7                 ; je peruen cyklu
PetOpak6:jcxz      PetOpak2                 ; nekonen cyklus
         loop      PetOpak2                 ; dal cyklus

; ------ posledn proveden pkazu

PetOpak7:call      ExePrik                  ; proveden poslednho pkazu

; ------ ukonen peruen cyklu (pedtm nebyl peruen)

PetOpak8:pushf
         and       byte ptr ds:[Param],not bit4 ; konec peruen cyklu
         popf
PetOpak9:ret

PetOpak  ENDP

; -----------------------------------------------------------------------------
;        podmnn opakovn
; -----------------------------------------------------------------------------

PetDok   PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jz        PetDok2                  ; nen blokovn pkaz IF
PetDok1: call      ExePrik                  ; peskoen pkazu pi peruen
         ret

; ------ provdn pkaz uvnit smyky (bez poslednho prchodu)

PetDok2: push      word ptr ds:[UkazProg]   ; schova ukazatele programu

         call      TestPodm                 ; test podmnky
         jnc       PetDok3                  ; podmnka splnna OK
         or        byte ptr ds:[Param],bit4 ; peruen cyklu
PetDok3: call      ExePrik                  ; proveden jednoho pkazu

PetDok4: mov       ax,ds:[UkazProg]         ; dosaen ukazatel
         pop       word ptr ds:[UkazProg]   ; nvrat ukazatele programu
         jc        PetDok7                  ; chyba nebo peruen
         test      byte ptr ds:[Param],bit4 ; je peruen cyklu ?
         jz        PetDok2                  ; nen peruen - dal cyklus

; ------ ukonen peruen cyklu (pedtm nebyl peruen)

PetDok7: mov       ds:[UkazProg],ax         ; nov dosaen ukazatel programu
         pushf
         and       byte ptr ds:[Param],not bit4 ; konec peruen cyklu
         popf
PetDok9: ret

PetDok  ENDP

; -----------------------------------------------------------------------------
;        peruen cyklu nebo programu
; -----------------------------------------------------------------------------

PetPrer  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       PetPrer9                 ; je blokovn pkaz
         or        byte ptr ds:[Param],bit4 ; pznak peruen cyklu
PetPrer9:ret

PetPrer  ENDP

; -----------------------------------------------------------------------------
;        synchronizace na VSYN (vol se t pi editaci ikony !)
; -----------------------------------------------------------------------------

PetVSyn  PROC      NEAR

         push      ax
         push      dx

         call      TestBlok                 ; test blokovn programu
         jnz       PetVSyn4                 ; je blokovn programu

         mov       byte ptr ds:[TimeKrok],2 ; nastaven tae
         mov       dx,3dah
PetVSyn2:sti
         cmp       byte ptr cs:[TimeKrok],0
         je        PetVSyn4                 ; peteen doby
         in        al,dx
         test      al,bit3
         jz        PetVSyn2                 ; ekn na impuls

PetVSyn4:pop       dx
         pop       ax
         clc
         ret

PetVSyn  ENDP

; -----------------------------------------------------------------------------
;        podmnka JESTLI
; -----------------------------------------------------------------------------

PetJest  PROC      NEAR

; ------ test splnn podmnky

         call      TestPodm                 ; test podmnky
         jc        PetJest4                 ; podmnka nesplnna

; ------ proveden pkazu, je-li splnna podmnka

PetJest2:call      ExePrik                  ; proveden pkazu bez blokovn
         jc        PetJest9                 ; peruen programu

; ------ test, zda nsleduje pkaz JINAK

         call      BytePrg                  ; naten dalho bajtu
         jc        PetJest8                 ; chyba
         cmp       al,KOD_JIN               ; je JINAK ?
         jne       PetJest7                 ; nen JINAK

; ------ neproveden pkazu za JINAK

         inc       word ptr ds:[BlokIf]     ; blokovn pkazu
         call      ExePrik                  ; proveden jednoho pkazu
         dec       word ptr ds:[BlokIf]     ; odblokovn pkazu
         jmp       short PetJest9

; ------ neproveden pkazu, podmnka nen splnna

PetJest4:inc       word ptr ds:[BlokIf]     ; blokovn pkazu
         call      ExePrik                  ; proveden jednoho pkazu
         dec       word ptr ds:[BlokIf]     ; odblokovn pkazu
         jc        PetJest9                 ; peruen programu

; ------ test, zda nsleduje pkaz JINAK

PetJest5:call      BytePrg                  ; naten dalho bajtu
         jc        PetJest8                 ; chyba
         cmp       al,KOD_JIN               ; je JINAK ?
         jne       PetJest7                 ; nen JINAK

; ------ proveden pkazu za JINAK

         call      ExePrik                  ; proveden pkazu bez blokovn
         jmp       short PetJest9

PetJest7:dec       word ptr ds:[UkazProg]   ; nvrat bajtu
PetJest8:clc                                ; pznak operace OK
PetJest9:ret

PetJest  ENDP

BlokIf   dw        0                        ; ta blokovn IF (0=nen blok)

; -----------------------------------------------------------------------------
;        test podmnky -> CY=nen podmnka splnna
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
;        naten rovn OR -> CY=nen podmnka splnna
; -----------------------------------------------------------------------------

TestPodm:

TestOr   PROC      NEAR

         push      cx

; ------ naten operandu

         mov       cl,1                     ; pznak nesplnn podmnky
TestOr1: call      TestAnd                  ; naten operandu
         jc        TestOr2                  ; podmnka nesplnna
         mov       cl,0                     ; pznak splnn podmnky

; ------ naten dalho bajtu

TestOr2: call      BytePrg                  ; naten dalho bajtu
         jc        TestOr8                  ; nen dal bajt
         cmp       al,KOD_OR                ; je OR ?
         je        TestOr1                  ; je OR - dal operand

         dec       word ptr ds:[UkazProg]   ; nvrat bajtu

TestOr8: shr       cl,1                     ; CY=podmnka nesplnna
         pop       cx
         ret

TestOr   ENDP

; -----------------------------------------------------------------------------
;        naten rovn AND -> CY=nen podmnka splnna
; -----------------------------------------------------------------------------

TestAnd  PROC      NEAR

         push      cx

; ------ naten operandu

         mov       cl,0                     ; pznak splnn podmnky
TestAnd1:call      Test1Pod                 ; naten operandu
         jnc       TestAnd2                 ; podmnka splnna
         mov       cl,1                     ; pznak nesplnn podmnky

; ------ naten dalho bajtu

TestAnd2:call      BytePrg                  ; naten dalho bajtu
         jc        TestAnd8                 ; nen dal bajt
         cmp       al,KOD_AND               ; je AND ?
         je        TestAnd1                 ; je AND - dal operand

         dec       word ptr ds:[UkazProg]   ; nvrat bajtu

TestAnd8:shr       cl,1                     ; CY=podmnka nesplnna
         pop       cx
         ret

TestAnd  ENDP

; -----------------------------------------------------------------------------
;        test jedn podmnky -> CY=nen podmnka splnna
; -----------------------------------------------------------------------------

Test1Pod PROC      NEAR

; ------ schova registr

         push      ax
         push      cx

; ------ kontrola ukazatele zsobnku

         cmp       sp,ds:[MinSP]            ; je peteen zsobnku ?
         jb        Test1Pd9                 ; je peteen zsobnku

; ------ naten identifikanho bajtu

         call      BytePrg                  ; naten bajtu
         jc        Test1Pd9                 ; chyba

; ------ negace podmnky

         cmp       al,KOD_NENI              ; je negace podmnky ?
         jne       Test1Pd1                 ; nen negace podmnky
         call      Test1Pod                 ; test dal podmnky
         cmc                                ; negace vsledku
         jmp       short Test1Pd9

; ------ test pedmtu

Test1Pd1:cmp       al,KOD_OBR               ; je obrzek ?
         jne       Test1Pd2                 ; nen obrzek
         call      WordPrg                  ; naten sla ikony
         jc        Test1Pd9                 ; chyba
         xchg      ax,cx                    ; CX <- schova pedmtu
         call      GetPred                  ; naten pedmtu -> AX
         jc        Test1P12                 ; je rm
         cmp       ax,cx                    ; souhlas pedmt ?
         je        Test1Pd9                 ; pedmt souhlas OK
         jmp       short Test1Pd8           ; pedmt nesouhlas
Test1P12:cmp       cx,ds:[ICOZed]           ; je test zdi ?
         je        Test1Pd9                 ; je ze
         cmp       cx,ds:[ICORam]           ; je test rmu ?
         je        Test1Pd9                 ; je rm
         jmp       short Test1Pd8           ; podmnka nesplnna

; ------ test smru

Test1Pd2:mov       ah,4                     ; kd pro SEVER
         cmp       al,KOD_SEV               ; SEVER
         je        Test1Pd3
         mov       ah,2                     ; kd pro JIH
         cmp       al,KOD_JIH               ; JIH
         je        Test1Pd3
         mov       ah,1                     ; kd pro VCHOD
         cmp       al,KOD_VYCH              ; VCHOD
         je        Test1Pd3
         mov       ah,3                     ; kd pro ZPAD
         cmp       al,KOD_ZAP               ; ZPAD
         jne       Test1Pd4
Test1Pd3:cmp       ah,ds:[PetrSme]          ; kontrola smru Petra
         je        Test1Pd9                 ; podmnka splnna
         jmp       short Test1Pd8

; ------ naten podmnky v zvorce

Test1Pd4:cmp       al,KOD_LZAV              ; je lev zvorka ?
         jne       Test1Pd6                 ; nen lev zvorka
         call      TestPodm                 ; naten podmnky v zvorce

; ------ test, zda je prav zvorka

         pushf
         call      BytePrg                  ; naten dalho bajtu
         jc        Test1Pd5                 ; nen dal bajt
         cmp       al,KOD_RZAV              ; je prav zvorka ?
         je        Test1Pd5                 ; je prav zvorka
         dec       word ptr ds:[UkazProg]   ; nvrat bajtu
Test1Pd5:popf
         jmp       short Test1Pd9

; ------ porovnn vraz

Test1Pd6:dec       word ptr ds:[UkazProg]   ; nvrat bajtu
         call      TestCmp                  ; porovnn dvou vraz
         jmp       short Test1Pd9

; ------ nvrat registr

Test1Pd8:stc                                ; pznak nesplnn podmnky
Test1Pd9:pop       cx
         pop       ax
         ret

Test1Pod ENDP

; -----------------------------------------------------------------------------
;        naten rovn porovnn dvou vraz -> CY=podmnka nesplnna
; -----------------------------------------------------------------------------

TestCmp  PROC      NEAR

; ------ schova registr

         push      bx
         push      cx

; ------ naten prvnho operandu

         call      VyrazPrg                 ; naten vrazu
         jc        TestCmp8                 ; chyba
         xchg      ax,cx                    ; CX <- schova operandu

; ------ naten nsledujcho bajtu

         mov       bl,0                     ; stada opertoru
TestCmp2:call      BytePrg                  ; naten dalho bajtu
         jc        TestCmp6                 ; nen dal bajt

; ------ opertor "="

         cmp       al,KOD_ROVN              ; je "=" ?
         jne       TestCmp3                 ; nen "="
         or        bl,bit0                  ; pznak "="
         jmp       short TestCmp2           ; dal bajt

; ------ opertor "="

TestCmp3:cmp       al,KOD_MENS              ; je "<" ?
         jne       TestCmp4                 ; nen "<"
         or        bl,bit1                  ; pznak "<"
         jmp       short TestCmp2

; ------ opertor ">"

TestCmp4:cmp       al,KOD_VETS              ; je ">" ?
         jne       TestCmp5                 ; nen ">"
         or        bl,bit2                  ; pznak ">"
         jmp       short TestCmp2

; ------ nvrat neplatnho znaku

TestCmp5:dec       word ptr ds:[UkazProg]   ; nvrat bajtu

; ------ test, zda je njak opertor

TestCmp6:or        bl,bl                    ; je njak opertor ?
         jnz       TestCm62                 ; je njak opertor
         shr       cx,1                     ; test bitu 0
         cmc
         jmp       short TestCmp9           ; CY=podmnka nesplnna

; ------ naten druhho operandu

TestCm62:call      VyrazPrg                 ; naten druhho operandu
         jnc       TestCmp7                 ; operace OK
         xor       ax,ax                    ; pi chyb se porovn s nulou

; ------ shoda

TestCmp7:test      bl,bit0                  ; je "=" ?
         jz        TestCm72                 ; nen "="
         cmp       cx,ax                    ; je shoda ?
         je        TestCmp8                 ; je shoda

; ------ men

TestCm72:test      bl,bit1                  ; je "<" ?
         jz        TestCm74                 ; nen "<"
         cmp       cx,ax                    ; je men ?
         jl        TestCmp8                 ; je men

; ------ vt

TestCm74:test      bl,bit2                  ; je ">" ?
         jz        TestCm76                 ; nen ">"
         cmp       cx,ax                    ; je vt ?
         jg        TestCmp8                 ; je vt

; ------ podmnka nesplnna

TestCm76:stc                                ; pznak nesplnn podmnky
         jmp       short TestCmp9

; ------ podmnka splnna

TestCmp8:clc                                ; pznak splnn podmnky

; ------ nvrat registr

TestCmp9:pop       cx
         pop       bx
         ret

TestCmp  ENDP

; -----------------------------------------------------------------------------
;        naten rovn soutu/rozdlu -> AX, CY=nen
; -----------------------------------------------------------------------------

VyrazPrg:

VyrazAdd PROC      NEAR

; ------ schova registr

         push      cx

; ------ naten prvnho operandu -> CX

         call      VyrazMul                 ; naten prvnho operandu
         jc        VyrazAd9                 ; chyba
         xchg      ax,cx                    ; CX <- prvn operand

; ------ naten nsledujcho identifiktoru

VyrazAd2:call      BytePrg                  ; naten dalho bajtu
         jc        VyrazAd8                 ; nen opertor

; ------ opertor soutu "+"

         cmp       al,KOD_PLUS              ; je souet ?
         jne       VyrazAd4                 ; nen souet

; ------ naten druhho operandu

         call      VyrazMul                 ; naten druhho operandu
         jc        VyrazAd8                 ; nen druh operand

; ------ proveden operace soutu

         add       cx,ax                    ; souet
         jmp       short VyrazAd2           ; dal operand

; ------ opertor rozdlu "-"

VyrazAd4:cmp       al,KOD_MIN               ; je rozdl ?
         jne       VyrazAd7                 ; nen rozdl

; ------ naten druhho operandu

         call      VyrazMul                 ; naten druhho operandu
         jc        VyrazAd8                 ; nen druh operand

; ------ proveden operace rozdlu

         sub       cx,ax                    ; rozdl
         jmp       short VyrazAd2           ; dal operand

; ------ nvrat registr

VyrazAd7:dec       word ptr ds:[UkazProg]   ; nvrat bajtu
VyrazAd8:clc                                ; pznak operace OK
         xchg      ax,cx                    ; AX <- stada vsledku
VyrazAd9:pop       cx
         ret

VyrazAdd ENDP

; -----------------------------------------------------------------------------
;        naten rovn nsoben/dlen -> AX, CY=nen
; -----------------------------------------------------------------------------

VyrazMul PROC      NEAR

; ------ schova registr

         push      cx

; ------ naten prvnho operandu -> CX

         call      VyrazNum                 ; naten prvnho operandu
         jc        VyrazMl9                 ; chyba
VyrazMl2:xchg      ax,cx                    ; CX <- prvn operand

; ------ naten nsledujcho identifiktoru

         call      BytePrg                  ; naten dalho bajtu
         jc        VyrazMl8                 ; nen opertor

; ------ opertor nsoben "*"

         cmp       al,KOD_KRAT              ; je nsoben ?
         jne       VyrazMl3                 ; nen nsoben

; ------ naten druhho operandu

         call      VyrazNum                 ; naten druhho operandu
         jc        VyrazMl8                 ; nen druh operand

; ------ proveden operace nsoben

         push      dx
         imul      cx                       ; proveden operace nsoben
         pop       dx
         jmp       short VyrazMl2           ; dal operand

; ------ opertor dlen "/"

VyrazMl3:cmp       al,KOD_DEL               ; je dlen ?
         jne       VyrazMl5                 ; nen dlen

; ------ naten druhho operandu

         call      VyrazNum                 ; naten druhho operandu
         jc        VyrazMl8                 ; nen druh operand

; ------ proveden operace dlen

         push      dx
         xchg      ax,cx                    ; AX <- dlenec, CX <- dlitel
         xor       dx,dx                    ; DX <- 0
         jcxz      VyrazMl4                 ; dlen nulou
         idiv      cx                       ; proveden operace dlen
VyrazMl4:pop       dx
         jmp       short VyrazMl2           ; dal operand

; ------ opertor MOD

VyrazMl5:cmp       al,KOD_MOD               ; je MODulo ?
         jne       VyrazMl7                 ; nen MODulo

; ------ naten druhho operandu

         call      VyrazNum                 ; naten druhho operandu
         jc        VyrazMl8                 ; nen druh operand

; ------ proveden operace dlen

         push      dx
         xchg      ax,cx                    ; AX <- dlenec, CX <- dlitel
         xor       dx,dx                    ; DX <- 0
         jcxz      VyrazMl6                 ; dlen nulou
         idiv      cx                       ; proveden operace dlen
VyrazMl6:xchg      ax,dx                    ; AX <- zbytek po dlen
         pop       dx
         jmp       short VyrazMl2           ; dal operand

; ------ nvrat registr

VyrazMl7:dec       word ptr ds:[UkazProg]   ; nvrat bajtu
VyrazMl8:clc                                ; pznak operace OK
         xchg      ax,cx                    ; AX <- stada vsledku
VyrazMl9:pop       cx
         ret

VyrazMul ENDP

; -----------------------------------------------------------------------------
;        naten jednoho sla/promnn ve vrazu -> AX, CY=nen
; -----------------------------------------------------------------------------

VyrazNum PROC      NEAR

; ------ kontrola peteen zsobnku

         cmp       sp,ds:[MinSP]            ; je peteen zsobnku ?
         jb        VyrazN29                 ; je peteen zsobnku

; ------ naten identifiktoru

VyrazNm1:call      BytePrg                  ; naten identifikanho bajtu
         jc        VyrazN29                 ; konec programu

; ------ unrn znamnko "+" se ignoruje

         cmp       al,KOD_PLUS              ; je "+" ?
         je        VyrazNm1                 ; znamnko se ignoruje

; ------ pkaz PREDMET se ignoruje (nsleduje vraz jako slo pedmtu)

         cmp       al,KOD_PRED              ; je pedmt ?
         je        VyrazNm1                 ; pedmt se ignoruje

; ------ negace sla

         cmp       al,KOD_MIN               ; je "-" ?
         jne       VyrazNm2                 ; nen "-"
         call      VyrazNum                 ; naten sla
         jc        VyrazN29                 ; nen platn slo
         neg       ax                       ; negace vsledku
         clc
         jmp       short VyrazN29

; ------ promnn

VyrazNm2:cmp       al,KOD_PROM              ; je promnn ?
         jne       VyrazNm3                 ; nen promnn
         call      WordPrg                  ; naten adresy promnn
         jc        VyrazN29                 ; konec programu

         push      bx
         push      es
         mov       es,ds:[DataProg]
         mov       bx,ax                    ; BX <- adresa promnn
         mov       ax,es:[bx]               ; hodnota promnn
         pop       es
         pop       bx
VyrazN29:jmp       VyrazNm9           ; zde je NC

; ------ vektor

VyrazNm3:cmp       al,KOD_VEKT              ; je vektor ?
         jne       VyrazN31                 ; nen vektor
         call      VyrazNum                 ; naten nsledujcho sla

         push      di
         push      es
         shl       ax,1                     ; index * 2
         xchg      ax,di                    ; DI <- index
         mov       es,ds:[DataVekt]         ; segment vektoru
         mov       ax,es:[di]               ; hodnota vektoru
         pop       es
         pop       di
         clc
         jmp       VyrazNm9

; ------ slo nebo obrzek

VyrazN31:cmp       al,KOD_OBR               ; je obrzek ?
         je        VyrzN312                 ; je obrzek - naten sla
         cmp       al,KOD_CISL              ; je slo ?
         jne       VyrazN32                 ; nen slo
VyrzN312:call      WordPrg                  ; naten hodnoty sla
         jmp       VyrazNm9

; ------ funkce

VyrazN32:cmp       al,KOD_PROC              ; je funkce ?
         jne       VyrazN33                 ; nen funkce
         push      bx
         push      cx
         push      dx
         call      PetProc                  ; vyvoln funkce
         pop       dx
         pop       cx
         pop       bx
         clc
         jmp       short VyrazNm9

; ------ mstn promnn

VyrazN33:cmp       al,KOD_MIST              ; je mstn promnn ?
         jne       VyrazN34                 ; nen mstn promnn
         mov       ax,bp                    ; hodnota mstn promnn
         jmp       short VyrazNm8

; ------ nhodn slo

VyrazN34:cmp       al,KOD_NAH               ; je nhodn slo ?
         jne       VyrazN35                 ; nen nhodn slo
         call      VyrazPrg                 ; naten vrazu
         call      RandomN                  ; vpoet nhodnho sla
         jmp       short VyrazNm8

; ------ pozice X

VyrazN35:cmp       al,KOD_POZX              ; je pozice X ?
         jne       VyrazN36                 ; nen pozice X
         mov       al,byte ptr ds:[PetrPoz] ; pozice X
         jmp       short VyrzN362

; ------ pozice Y

VyrazN36:cmp       al,KOD_POZY              ; je pozice Y ?
         jne       VyrazN37                 ; nen pozice Y
         mov       al,byte ptr ds:[PetrPoz+1] ; pozice Y
VyrzN362:mov       ah,0
         jmp       short VyrazNm8

; ------ klvesa

VyrazN37:cmp       al,KOD_KLAV
         jne       VyrazN38
         call      TestBlok                 ; test blokovn programu
         jnz       VyrazNm9                 ; je blokovn programu
         call      InpChar                  ; vstup znaku z klvesnice
         jmp       short VyrazNm8

; ------ smr

VyrazN38:cmp       al,KOD_SMER
         jne       VyrazN39
         mov       al,ds:[PetrSme]          ; nastaven smr
         jmp       short VyrzN362

; ------ obsah pole

VyrazN39:cmp       al,KOD_POLE              ; je pole ?
         jne       VyrazN3A                 ; nen pole

         call      VyrazPrg                 ; naten souadnice X pole
         push      ax                       ; AL = souadnice X pole
         call      VyrazPrg                 ; naten souadnice Y pole
         pop       dx                       ; DL <- souadnice X pole
         mov       dh,al                    ; DH <- souadnice Y pole
         call      GetPole                  ; poskytnut pedmtu z DX
         jmp       short VyrazNm8           ; operace OK

; ------ HUDBA

VyrazN3A:cmp       al,KOD_MUS               ; je HUDBA ?
         jne       VyrazNm4                 ; nen HUDBA
         mov       ax,ds:[CitacMel]         ; ta melodie
         jmp       short VyrazNm8           ; operace OK

; ------ lev zvorka - vraz

VyrazNm4:cmp       al,KOD_LZAV              ; je lev zvorka ?
         jne       VyrazNm7                 ; nen lev zvorka
         call      VyrazPrg                 ; naten vrazu v zvorce

; ------ test, zda je prav zvorka

         push      ax
         call      BytePrg                  ; naten dalho bajtu
         cmc
         jnc       VyrazNm5                 ; nen dal bajt
         cmp       al,KOD_RZAV              ; je prav zvorka ?
         je        VyrazNm5                 ; je prav zvorka
         stc                                ; pznak pro navrcen znaku
VyrazNm5:pop       ax
         jnc       VyrazNm9

; ------ nvrat neplatnho identifikanho bajtu

VyrazNm7:dec       word ptr ds:[UkazProg]   ; nvrat bajtu
VyrazNm8:clc                                ; pznak operace OK
VyrazNm9:ret

VyrazNum ENDP

; -----------------------------------------------------------------------------
;        poskytnut pedmtu ze souadnice DX -> AX (pi chyb AX=rm, CY)
; -----------------------------------------------------------------------------

GetPole  PROC      NEAR

; ------ schova registr

         push      bx

; ------ kontrola peteen okraj

         mov       ax,ds:[ICORam]           ; rm
         cmp       dh,PVYSKA                ; je platn souadnice Y ?
         jae       GetPole4                 ; souadnice mimo rozsah
         cmp       dl,PSIRKA                ; je platn souadnice X ?
         jae       GetPole4                 ; souadnice mimo rozsah

; ------ naten pedmtu

         mov       al,PSIRKA                ; poet pozic na dek
         mul       dh                       ; pepoet dku na pozici
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; offset v tabulce pole
         xchg      ax,bx                    ; BX <- offset v poli, AX <- pedmt
         mov       ax,ds:[bx+Pole]          ; naten pedmtu

; ------ nvrat registr

         stc                                ; pznak operace OK
GetPole4:cmc                                ; CY = neplatn souadnice
GetPole6:pop       bx
         ret

GetPole  ENDP

; -----------------------------------------------------------------------------
;        inicializace genertoru nhody
; -----------------------------------------------------------------------------

InitRnd  PROC      NEAR

         push      ax
         push      es

         xor       ax,ax
         mov       es,ax
         mov       ax,es:[46ch]             ; ta systmovho asovae
         mov       word ptr ds:[RandomR],ax ; inicializan konstanta

         pop       es
         pop       ax
         ret

InitRnd  ENDP

; -----------------------------------------------------------------------------
;        nhodn slo o rozsahu AX -> AX
; -----------------------------------------------------------------------------

RandomN  PROC      NEAR

; ------ pro 0 je jakkoliv slo

         or        ax,ax                    ; je 0 ?
         jz        Random                   ; je 0

; ------ schova registr

         push      bx
         push      cx

; ------ pprava masky -> CX

         xor       cx,cx
RandomN2:stc
         rcl       cx,1                     ; naten bitu
         cmp       ax,cx                    ; je rozah OK ?
         ja        RandomN2

; ------ nhodn slo -> AX

         xchg      ax,bx                    ; BX <- schova rozsahu
RandomN3:call      Random                   ; vpoet nhodnho sla
         and       ax,cx                    ; maskovn sla
         cmp       ax,bx                    ; je peteen rozsahu ?
         jae       RandomN3                 ; je peteen rozsahu

; ------ nvrat registr

RandomN4:pop       cx
         pop       bx
         clc
         ret

RandomN  ENDP

; -----------------------------------------------------------------------------
;        nhodn slo -> AX
; -----------------------------------------------------------------------------

Random   PROC      NEAR

         push      bx
         push      cx
         push      dx

         mov       ax,word ptr ds:[RandomR]
         mov       bx,word ptr ds:[RandomR+2]
         mov       cx,ax
         mul       word ptr ds:[RandomD]
         shl       cx,1
         shl       cx,1
         shl       cx,1
         add       ch,cl
         add       dx,cx
         add       dx,bx
         shl       bx,1
         shl       bx,1
         add       dx,bx
         add       dh,bl
         mov       cl,5
         shl       bx,cl
         add       dh,bl
         add       ax,1
         adc       dx,0
         mov       word ptr ds:[RandomR],ax
         mov       word ptr ds:[RandomR+2],dx
         xchg      ax,dx

         pop       dx
         pop       cx
         pop       bx
         clc
         ret

Random   ENDP

; -----------------------------------------------------------------------------
;        naten slova programu -> AX, CY=nen
; -----------------------------------------------------------------------------

WordPrg  PROC      NEAR

         call      BytePrg                  ; naten prvnho bajtu
         jc        WordPrg2                 ; nen dal bajt
         xchg      al,ah                    ; AH <- ni bajt
         call      BytePrg                  ; naten druhho bajtu
         xchg      al,ah
WordPrg2:ret

WordPrg  ENDP

; -----------------------------------------------------------------------------
;        naten jednoho bajtu programu -> AL, CY=nen
; -----------------------------------------------------------------------------

BytePrg  PROC      NEAR

         push      si
         push      es

         mov       es,ds:[DataProg]         ; segment adresy programu
         mov       si,ds:[UkazProg]         ; ukazatel pro ten programu
         cmp       si,ds:[DataNum]          ; je konec programu ?
         cmc                                ; CY = nen dal bajt
         jc        BytePrg2                 ; nen dal bajt
         cld
         lods      byte ptr es:[si]         ; naten dalho bajtu
         mov       ds:[UkazProg],si         ; nov ukazatel programu

BytePrg2:pop       es
         pop       si
         ret

BytePrg  ENDP

; -----------------------------------------------------------------------------
;        naten programu (-> CY=chyba pamti)
; -----------------------------------------------------------------------------
;
ReadPrg  PROC      NEAR

         mov       word ptr ds:[CitRad],1   ; ukazatel sla dku

; ------ oteven vstupnho souboru

         mov       dx,offset ProgFile       ; vstupn soubor
         mov       ax,3d00h
         int       21h
         jnc       ReadPrg1

; ------ chyba - vstupn soubor nenalezen

         mov       bp,offset FndErr
         call      DispErr                  ; obsluha chyby
         clc
         ret

; ------ uloen identifiktoru souboru

ReadPrg1:mov       ds:[ProgIdnt],ax         ; identifiktor vstupnho souboru

; ------ definice sel

ReadPrg2:mov       ax,ds:[DataNum]          ; konec programu
         mov       ds:[MainProg],ax         ; startovac adresa
         mov       ds:[ProcBeg],ax          ; zatek procedur
         call      ReadStr                  ; naten etzec
         jc        ReadP302                 ; konec programu
         cmp       byte ptr ds:[ProgStr+1],"#" ; je definice promnn ?
         jne       ReadPr30                 ; nen definice promnn

; ------ naten jmna promnn

         call      ReadStr                  ; naten dalho etzce
         jc        ReadP302                 ; konec souboru

; ------ uloen jmna promnn

         mov       ch,0
         mov       cl,ds:[ProgStr]          ; dlka jmna promnn
         inc       cx                       ; vetn dlky
         mov       si,offset ProgStr        ; jmno promnn s dlkou
ReaPrg21:cld
         lodsb                              ; naten bajtu
         call      UpCase                   ; konverze na velk psmeno
         call      StorPrg                  ; uloen bajtu
         loop      ReaPrg21                 ; dal bajt

; ------ uloen promnn

         xor       ax,ax                    ; AX <- 0 inicializan hodnota
         call      StorPrg                  ; ni bajt
         call      StorPrg                  ; vy bajt
         inc       word ptr ds:[PromNum]    ; ta promnnch
         jmp       short ReadPrg2           ; dal promnn

; ------ definice procedur

ReadPrg3:mov       ax,ds:[DataNum]          ; konec programu
         mov       ds:[MainProg],ax         ; startovac adresa
         call      ReadStr                  ; naten etzce
         jnc       ReadPr30
ReadP302:jmp       ReadPrg8                 ; konec souboru

ReadPr30:cmp       byte ptr ds:[ProgStr+1],"!" ; je definice procedury ?
         jne       ReadPr41                 ; nen definice procedury

; ------ naten jmna procedury

         call      ReadStr                  ; naten dalho etzce
         jc        ReadP302                 ; konec souboru

; ------ rezerva msta pro adresu dal procedury

         push      word ptr ds:[DataNum]    ; schova ukazatele

         xor       ax,ax
         call      StorPrg                  ; rezerva msta pro adresu
         jc        ReadPr38                 ; chyba pamti
         call      StorPrg
         jc        ReadPr38                 ; chyba pamti

; ------ uloen jmna procedury

         mov       ch,0
         mov       cl,ds:[ProgStr]          ; dlka jmna procedury
         inc       cx                       ; vetn dlky
         mov       si,offset ProgStr        ; jmno procedury s dlkou
ReadPr31:cld
         lodsb                              ; naten bajtu
         call      UpCase                   ; konverze na velk psmeno
         call      StorPrg                  ; uloen bajtu
         jc        ReadPr38                 ; chyba pamti
         loop      ReadPr31                 ; dal bajt

         inc       word ptr ds:[ProcNum]    ; ta procedur

; ------ naten a zpracovn dalho pkazu

         xor       cx,cx                    ; ukazatel hladiny zvorek
ReadPr33:call      ReadStr                  ; naten dalho etzce
         jc        ReadPr37                 ; konec souboru
         cmp       byte ptr ds:[ProgStr+1],"#"
         je        ReadPr33                 ; definice sla se ignoruje
         cmp       byte ptr ds:[ProgStr+1],"!"
         je        ReadPr33                 ; definice procedur se ignoruje
         push      cx
         call      ReadPrik                 ; zpracovn pkazu
         pop       cx
         jc        ReadPr38                 ; chyba pamti

; ------ test, zda je lev zvorka

         cmp       byte ptr ds:[ProgStr+1],"(" ; je lev zvorka ?
         jne       ReadPr34                 ; nen lev zvorka
         inc       cx                       ; zven ukazatele zvorek

; ------ test, zda je prav zvorka

ReadPr34:cmp       byte ptr ds:[ProgStr+1],")" ; je prav zvorka ?
         jne       ReadPr35                 ; nen prav zvorka
         jcxz      ReadPr37                 ; je ji nulov hladina
         dec       cx                       ; snen tae zvorek

; ------ test, zda je konec pkazu

ReadPr35:or        cx,cx                    ; je nulov hladina zvorek ?
         jnz       ReadPr33                 ; dal pkaz

; ------ uloen adresy dal procedury

ReadPr37:clc                                ; pznak operace OK

ReadPr38:pop       di                       ; DI <- ukazatel v bufferu

         push      es
         mov       es,ds:[DataProg]         ; segment adresy bufferu
         mov       ax,ds:[DataNum]          ; nov ukazatel
         cld
         stosw                              ; uloen adresy dal procedury
         pop       es

         jc        ReadPrg9                 ; peteen pamti

         jmp       ReadPrg3                 ; dal procedura

; ------ naten etzce ze souboru

ReadPrg4:call      ReadStr                  ; naten etzce
         jc        ReadPrg8                 ; konec souboru

; ------ chyba, je-li definice procedury

ReadPr41:cmp       byte ptr ds:[ProgStr+1],"#"
         je        ReadPr42                 ; definice sla
         cmp       byte ptr ds:[ProgStr+1],"!" ; je definice procedury ?
         jne       ReadPrg6                 ; nen definice procedury
ReadPr42:mov       bp,offset ProcErr
         call      DispErr                  ; chybov hlen
         jmp       short ReadPrg4           ; dal pkaz

; ------ zpracovn jednoho pkazu

ReadPrg6:call      ReadPrik                 ; zpracovn jednoho pkazu
         jc        ReadPrg9                 ; peteen pamti
         jmp       short ReadPrg4           ; dal pkaz

; ------ uzaven vstupnho souboru (CY=chyba pamti)

ReadPrg8:clc                                ; NC = pznak operace OK
ReadPrg9:pushf
         mov       bx,ds:[ProgIdnt]
         mov       ah,3eh
         int       21h                      ; uzaven vstupnho souboru
         popf
         ret

ReadPrg  ENDP

; -----------------------------------------------------------------------------
;  zpracovn jednoho pkazu programu, etzec je v bufferu -> CY=chyba pamti
; -----------------------------------------------------------------------------

ReadPrik PROC      NEAR

; ------ nalezen etzce v internch pkazech

         mov       si,offset ProgStr        ; naten etzec
         call      HledStr                  ; nalezen etzce v tabulce
         jc        ReadPri3                 ; etzec nenalezen

; ------ vykreslen obrzku s maskou

         cmp       al,KOD_MASK              ; je maska ?
         jne       ReadPri1                 ; nen maska
         call      ReadStr                  ; naten dalho etzce
         jnc       ReadPr32                 ; uloen definice obrzku
         jmp       ReadPri8                 ; konec souboru

; ------ uloen internho pkazu do bufferu programu

ReadPri1:call      StorPrg                  ; uloen internho pkazu
         jc        ReadPr19                 ; peteen pamti
         cmp       al,KOD_MUS               ; je hudba ?
         je        ReadPri2                 ; je hudba
         cmp       al,KOD_HLAS              ; je hlen ?
         je        ReadPri2                 ; je hlen
         cmp       al,KOD_TEXT              ; je text ?
         je        ReadPri2                 ; je text
ReadPr18:clc                                ; pznak operace OK
ReadPr19:ret                                ; CY = peteen pamti

; ------ uloen ASCII textu pro hlen a text

ReadPri2:call      ReadStr                  ; naten dalho etzce
         jc        ReadPr19                 ; nen etzec
         mov       si,offset ProgStr+1      ; buffer s etzcem
         mov       ch,0
         mov       cl,ds:[si-1]             ; dlka etzce
         cmp       byte ptr ds:[si],'"'     ; je oznaen textu " ?
         jne       ReadPr21                 ; nen oznaen textu
         inc       si                       ; peskoen znaku "
         dec       cx                       ; snen tae dlky textu
ReadPr21:mov       al,cl                    ; AL <- dlka textu
         call      StorPrg                  ; uloen bajtu do bufferu
         jc        ReadPr19                 ; chyba pamti
         jcxz      ReadPr18                 ; je przdn etzec
ReadPr22:cld
         lodsb                              ; naten znaku z bufferu
         call      StorPrg                  ; uloen bajtu do bufferu
         jc        ReadPr19                 ; chyba pamti
         loop      ReadPr22                 ; dal znak
         jmp       short ReadPr18           ; operace OK

; ------ nalezen obrzku k vykreslen

ReadPri3:mov       al,KOD_OBR               ; pkaz pro vykreslen obrzku
ReadPr32:xchg      ax,cx                    ; CL <- schova pkazu
         call      SrcICO                   ; nalezen obrzku
         xchg      ax,cx                    ; CX <- slo ikony, AL <- pkaz
         jc        ReadPri5                 ; obrzek nenalezen

; ------ uloen pkazu pro vykreslen obrzku

         call      StorPrg                  ; uloen internho pkazu
         jc        ReadPri9                 ; peteen pamti
         xchg      ax,cx                    ; AX <- slo obrzku

; ------ uloen slova AX jako parametr

ReadPri4:call      StorPrg                  ; uloen internho pkazu
         jc        ReadPri9                 ; peteen pamti
         xchg      al,ah                    ; AL <- adresa obrzku HIGH
         call      StorPrg                  ; uloen internho pkazu
         jmp       short ReadPri9           ; konec nebo chyba pamti

; ------ nalezen procedury

ReadPri5:call      SrcPrik                  ; nalezen pkazu
         jc        ReadPr54                 ; nenalezen

; ------ uloen identifiktoru pkazu

         push      ax
         mov       al,KOD_PROC
ReadPr52:call      StorPrg                  ; uloen pkazu
         pop       ax
         jc        ReadPri9                 ; chyba pamti
         jmp       short ReadPri4           ; uloen adresy

; ------ nalezen promnn

ReadPr54:call      SrcProm                  ; nalezen promnn
         jc        ReadPri6                 ; nenalezena

; ------ uloen identifiktoru promnn

         push      ax
         mov       al,KOD_PROM              ; promnn
         jmp       short ReadPr52           ; uloen promnn

; ------ naten jako kd klvesy

ReadPri6:call      ReadPKlv                 ; naten jako kd klvesy
         jnc       ReadP612                 ; kd klvesy nalezen OK

; ------ naten jako slo - textov parametr

         cmp       byte ptr ds:[ProgStr+1],'"' ; je text ?
         jne       ReadPr61                 ; nen text
         xor       ax,ax                    ; przdn pkaz
         cmp       byte ptr ds:[ProgStr],2  ; je njak znak ?
         jb        ReadP612                 ; nen znak - przdn etzec
         mov       al,ds:[ProgStr+2]        ; znak etzce
         jmp       short ReadP612

; ------ naten jako slo

ReadPr61:call      ReadPNum                 ; naten jako slo
         jc        ReadPr62                 ; chyba

; ------ uloen hodnoty sla

ReadP612:push      ax
         mov       al,KOD_CISL              ; kd pro slo
         jmp       short ReadPr52           ; uloen hodnoty sla

; ------ chyba - neznm povel

ReadPr62:mov       si,offset ProgStr+1      ; pkaz
         mov       cl,ds:[si-1]             ; dlka pkazu
         mov       ch,0
         push      ds
         pop       es
         mov       di,offset NeznErr2
         mov       ax,30
         cmp       cx,ax
         jb        ReadPri7
         mov       cx,ax
ReadPri7:cld
         sub       ax,cx
         rep       movsb
         xchg      ax,cx
         mov       al," "
         rep       stosb

         mov       bp,offset NeznErr        ; chyba - neznm pkaz
         call      DispErr                  ; chybov hlen

ReadPri8:clc                                ; pznak operace OK
ReadPri9:ret

ReadPrik ENDP

; -----------------------------------------------------------------------------
;        naten jako kd klvesy -> AX, CY=nenalezeno
; -----------------------------------------------------------------------------

ReadPKlv PROC      NEAR

; ------ schova registr

         push      cx
         push      si
         push      di
         push      es

         push      ds
         pop       es                       ; ES <- datov segment

; ------ test, zda je zatek kdu klvesy

         cmp       byte ptr ds:[ProgStr],3  ; minimln dlka
         jb        ReadPKl8                 ; je mal dlka
         cmp       word ptr ds:[ProgStr+1],"_K" ; je kd klvesy ?
         jne       ReadPKl8                 ; nen kd klvesy

; ------ pprava k vyhledn kdu klvesy

         cld
         mov       ch,0
         mov       di,offset KodKlav        ; tabulka kd klves

; ------ pprava k porovnn jedn klvesy

ReadPKl2:mov       si,offset ProgStr+3      ; zatek textu klvesy
         mov       al,ds:[ProgStr]          ; dlka etzce
         sub       al,2                     ; bez zatku kdu

; ------ porovnn dlky klvesy

         mov       cl,ds:[di]               ; dlka textu klvesy
         inc       di                       ; zatek textu klvesy
         cmp       al,cl                    ; souhlas dlka textu klvesy ?
         jne       ReadPKl6                 ; dlka textu klvesy nesouhlas

; ------ porovnn textu klvesy

         push      cx
         push      di
         repe      cmpsb                    ; porovnn textu klvesy
         pop       di
         pop       cx
         jne       ReadPKl6                 ; text klvesy nesouhlas

; ------ kd klvesy nalezen OK

         add       di,cx                    ; adresa kdu klvesy
         mov       ax,ds:[di]               ; AX <- kd klvesy
         clc                                ; pznak operace OK
         jmp       short ReadPKl9

; ------ kd dal klvesy

ReadPKl6:add       di,cx                    ; adresa kdu klvesy
         inc       di
         inc       di                       ; peskoen kdu klvesy
         cmp       byte ptr ds:[di],0       ; je konec tabulky ?
         jne       ReadPKl2                 ; porovnn dal klvesy

; ------ nvrat registr

ReadPKl8:stc                                ; pznak neplatnho kdu
ReadPKl9:pop       es
         pop       di
         pop       si
         pop       cx
         ret

ReadPKlv ENDP

; -----------------------------------------------------------------------------
;        vyhledn pkazu DS:SI -> AX=adresa, CY=nenalezeno
; -----------------------------------------------------------------------------

SrcPrik  PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      di
         push      es

; ------ pprava registr

         mov       di,ds:[ProcBeg]          ; potek procedur
         mov       es,ds:[DataProg]         ; segment programu
         mov       bx,ds:[ProcNum]          ; poet procedur
         mov       ch,0

; ------ test, zda je dal procedura

SrcPrik2:or        bx,bx                    ; je dal procedura ?
         stc                                ; pznak nenalezen
         jz        SrcPrik8                 ; nenalezeno

; ------ porovnn jmna procedury

         push      si
         push      di
         inc       di
         inc       di                       ; zatek jmna
         mov       cl,es:[di]               ; dlka jmna procedury
         inc       cx                       ; vetn bajtu dlky
         repe      cmpsb                    ; porovnn jmna
         pop       di
         pop       si
         je        SrcPrik6                 ; procedura nalezena OK

; ------ dal procedura

         mov       di,es:[di]               ; adresa dal procedury
         dec       bx                       ; ta procedur
         jmp       short SrcPrik2           ; dal hledn

; ------ adresa procedury -> AX

SrcPrik6:mov       ax,di
         add       al,es:[di+2]             ; piten dlky jmna
         adc       ah,0
         add       ax,3                     ; peskoen offsetu a bajtu dlky
         clc                                ; pznak operace OK

; ------ nvrat registr

SrcPrik8:pop       es
         pop       di
         pop       cx
         pop       bx
         ret

SrcPrik  ENDP

; -----------------------------------------------------------------------------
;        vyhledn promnn DS:SI -> AX=adresa, CY=nenalezena
; -----------------------------------------------------------------------------

SrcProm  PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      di
         push      es

; ------ pprava registr

         xor       di,di                    ; potek promnnch
         mov       es,ds:[DataProg]         ; segment programu
         mov       bx,ds:[PromNum]          ; poet promnnch
         mov       ch,0

; ------ test, zda je dal promnn

SrcProm2:or        bx,bx                    ; je dal promnn ?
         stc                                ; pznak nenalezen
         jz        SrcProm8                 ; nenalezena

; ------ porovnn jmna promnn

         mov       cl,es:[di]               ; dlka jmna procedury
         inc       cx                       ; vetn bajtu dlky
         push      cx
         push      si
         push      di
         repe      cmpsb                    ; porovnn jmna
         pop       di
         pop       si
         pop       cx
         je        SrcProm6                 ; slo nalezeno OK

; ------ dal promnn

         add       di,cx                    ; piten dlky jmna
         inc       di
         inc       di                       ; peskoen hodnoty promnn
         dec       bx                       ; ta promnnch
         jmp       short SrcProm2           ; dal hledn

; ------ adresa procedury -> AX

SrcProm6:mov       ax,di
         add       ax,cx                    ; piten dlky jmna
         clc                                ; pznak operace OK

; ------ nvrat registr

SrcProm8:pop       es
         pop       di
         pop       cx
         pop       bx
         ret

SrcProm  ENDP

; -----------------------------------------------------------------------------
;        uloen bajtu AL do bufferu programu -> CY=chyba pamti
; -----------------------------------------------------------------------------

StorPrg  PROC      NEAR

; ------ schova registr

         push      di
         push      es

; ------ uloen bajtu do bufferu

         mov       es,ds:[DataProg]         ; segment adresy bufferu
         mov       di,ds:[DataNum]          ; poet bajt v bufferu
         cld
         stosb                              ; uloen bajtu do bufferu
         mov       ds:[DataNum],di          ; nov poet bajt v bufferu

; ------ kontrola peteen pamti

         add       di,18h                   ; zarovnn na odstavec + rezerva
         jc        StorPrg9                 ; mohlo by bt peteen
         shr       di,1
         shr       di,1
         shr       di,1
         shr       di,1                     ; pevod na odstavce
         add       di,ds:[DataProg]         ; adresa konce programu
         cmp       di,ds:[DataICO]          ; je peteen pamti ?
         cmc                                ; CY = je peteen pamti

; ------ nvrat registr

StorPrg9:pop       es
         pop       di
         ret

StorPrg  ENDP

; -----------------------------------------------------------------------------
;        nalezen etzce DS:SI v tabulce pkaz -> AX=slo pkazu, CY=nen
; -----------------------------------------------------------------------------

HledStr  PROC      NEAR

; ------ schova pkaz

         push      di
         push      cx
         push      es

; ------ pprava k vyhledn etzce

         cld
         push      ds
         pop       es                       ; ES <- datov segment
         mov       di,offset Prikazy        ; tabulka internch pkaz
         mov       ch,0
HledStr1:xor       ax,ax                    ; ukazatel sla pkazu

; ------ kontrola jednoho etzce

HledStr2:inc       ax                       ; zven ukazatele sla pkazu
         mov       cl,ds:[di]               ; dlka porovnvanho etzce
         inc       cx                       ; vetn bajtu dlky
         push      si
         push      di
         push      cx
         repe      cmpsb                    ; porovnn etzce (i s dlkou)
         pop       cx
         pop       di
         pop       si
         je        HledStr8                 ; etzez nalezen OK

; ------ dal etzec -> CY=nenalezen

HledStr4:add       di,cx                    ; dal etzec
         cmp       byte ptr ds:[di],0       ; je dal etzec ?
         jne       HledStr2                 ; je dal etzec OK

; ------ hledn v tabulce zkratek

         cmp       di,offset Prikazy0       ; je prvn tabulka ?
         mov       di,offset Prikazy2       ; tabulka zkratek
         je        HledStr1                 ; prohledn tabulky zkratek
         stc                                ; pznak nenalezen etzce

; ------ nvrat pkaz

HledStr8:pop       es
         pop       cx
         pop       di
         ret

HledStr  ENDP

; -----------------------------------------------------------------------------
;        naten parametru jako slo -> AX, CY=nen platn slo
; -----------------------------------------------------------------------------

ReadPNum PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si

; ------ pprava registr

         xor       bx,bx                    ; nulovn stadae
         mov       si,offset ProgStr+1      ; buffer
         mov       cl,ds:[si-1]             ; dlka etzce
         mov       ch,0

; ------ naten dalho znaku

ReadPNm2:clc                                ; pznak operace OK
         jcxz      ReadPNm9                 ; je konec etzce
         cld
         lodsb                              ; naten dalho znaku
         dec       cx                       ; snen tae znak

; ------ test, zda je znak slice

         sub       al,"0"
         jb        ReadPNm8                 ; nen to slice
         cmp       al,9
         ja        ReadPNm8                 ; nen to slice

; ------ pidn slice ke stadai

         mov       ah,0
         xchg      ax,bx                    ; AX <- stada, BX <- slice
         mov       dx,10                    ; nsobitel
         mul       dx                       ; posun stadae o d
         add       bx,ax                    ; pidn slice ke stadai
         adc       dx,dx                    ; je peteen ?
         jz        ReadPNm2                 ; nen peteen
         mov       bx,-1                    ; omezen pi peteen
         jmp       short ReadPNm2           ; dal slice

; ------ nvrat registr

ReadPNm8:stc                                ; pznak neplatnho znaku
ReadPNm9:xchg      ax,bx                    ; AX <- naten slo
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

ReadPNum ENDP

; -----------------------------------------------------------------------------
;        naten etzce ze souboru -> CY=nen dal etzec
; -----------------------------------------------------------------------------

ReadStr  PROC      NEAR

; ------ schova registr

         push      ax
         push      di

; ------ pprava ukazatel

         mov       byte ptr ds:[ProgStr],0  ; nulovn dlky etzce programu
         mov       di,offset ProgStr+1      ; buffer etzce programu

; ------ vyputn mezer ped etzcem

         call      ReadSpc                  ; vyputn mezer
         jc        ReadStr8                 ; konec souboru

; ------ jako prvn znak me bt jakkoliv znak (mezera je ji vyputna)

         call      ReadChr                  ; naten znaku
         call      UpCase                   ; konverze na velk psmeno
         mov       ds:[di],al               ; uloen prvnho znaku do bufferu
         inc       di                       ; zven ukazatele v bufferu
         inc       byte ptr ds:[ProgStr]    ; zven tae dlky etzce

; ------ naten textovho etzce

         cmp       al,"'"
         je        ReadSt11
         cmp       al,'"'
         jne       ReadSt16                 ; nen etzec
ReadSt11:mov       ah,al                    ; schova ukonovacho znaku
         mov       byte ptr ds:[ProgStr+1],'"' ; oznaen textu
ReadSt12:call      ReadChr                  ; naten dalho znaku
         jc        ReadStr6                 ; konec souboru
         cmp       al,ah                    ; je konec etzce ?
         je        ReadStr6
         cmp       byte ptr ds:[ProgStr],255 ; je buffer pln ?
         jae       ReadSt12                 ; buffer je pln
         mov       ds:[di],al               ; uloen znaku do bufferu
         inc       di                       ; zven ukazatele v bufferu
         inc       byte ptr ds:[ProgStr]    ; zven tae dlky etzce
         jmp       short ReadSt12           ; naten dalho znaku

; ------ test prvnho znaku, zda me etzec pokraovat

ReadSt16:cmp       al,"_"
         je        ReadStr2                 ; je podtrtko - me pokraovat
         cmp       al,"0"
         jb        ReadStr1                 ; nen slice
         cmp       al,"9"
         jbe       ReadStr2                 ; je slice - me pokraovat
ReadStr1:cmp       al,"A"
         jb        ReadStr6                 ; nen psmeno - konec
         cmp       al,"Z"
         ja        ReadStr6                 ; nen psmeno - konec

; ------ naten dalho znaku

ReadStr2:call      ReadChr                  ; naten dalho znaku
         jc        ReadStr6                 ; konec souboru
         call      UpCase                   ; konverze na velk psmeno

; ------ test, zda je znak povolen

         cmp       al,"_"
         je        ReadStr4                 ; je podtrtko - me pokraovat
         cmp       al,"0"
         jb        ReadStr3                 ; nen slice
         cmp       al,"9"
         jbe       ReadStr4                 ; je slice - me pokraovat
ReadStr3:cmp       al,"A"
         jb        ReadStr5                 ; nen psmeno - konec
         cmp       al,"Z"
         ja        ReadStr5                 ; nen psmeno - konec

; ------ uloen znaku do bufferu

ReadStr4:cmp       byte ptr ds:[ProgStr],255 ; je buffer pln ?
         jae       ReadStr2                 ; buffer je pln
         mov       ds:[di],al               ; uloen znaku do bufferu
         inc       di                       ; zven ukazatele v bufferu
         inc       byte ptr ds:[ProgStr]    ; zven tae dlky etzce
         jmp       short ReadStr2           ; naten dalho znaku

; ------ navrcen neplatnho znaku

ReadStr5:call      ReadRet                  ; navrcen oddlovae zpt
ReadStr6:clc                                ; pznak operace OK

; ------ navrcen registr

ReadStr8:pop       di
         pop       ax
         ret

ReadStr  ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer a koment ze souboru -> CY=je konec souboru
; -----------------------------------------------------------------------------

ReadSpc  PROC      NEAR

; ------ vyputn mezer

         push      ax
ReadSpc1:call      ReadChr                  ; naten znaku ze souboru
         jc        ReadSpc8                 ; konec souboru
         cmp       al," "                   ; je oddlova ?
         jbe       ReadSpc1                 ; oddlova se vypust

; ------ test, zda je zatek komente

         cmp       al,"("                   ; me to bt koment ?
         jne       ReadSpc7                 ; nen to koment
         call      ReadChr                  ; naten dalho znaku
         jc        ReadSpc6                 ; nen dal znak
         cmp       al,"*"                   ; je to koment ?
         jne       ReadSpc5                 ; nen to koment

; ------ nalezen konce komente

ReadSpc2:call      ReadChr                  ; naten dalho znaku
         jc        ReadSpc8                 ; konec souboru
ReadSpc3:cmp       al,"*"                   ; me to bt konec komente ?
         jne       ReadSpc2                 ; nen to konec komente
         call      ReadChr                  ; naten dalho znaku
         jc        ReadSpc8                 ; konec souboru
         cmp       al,")"                   ; je to konec komente ?
         jne       ReadSpc3                 ; nen to konec komente
         jmp       short ReadSpc1           ; vyputn dalch mezer

; ------ nvrat znak

ReadSpc5:call      ReadRet                  ; navrcen znaku
ReadSpc6:mov       al,"("                   ; navracen znak
ReadSpc7:call      ReadRet                  ; navrcen znaku do bufferu
ReadSpc8:pop       ax
         ret

ReadSpc  ENDP

; -----------------------------------------------------------------------------
;        navrcen znaku AL do bufferu -> NC
; -----------------------------------------------------------------------------

ReadRet  PROC      NEAR

         xchg      al,ds:[InpRetB]          ; navrcen znaku do bufferu
         mov       ds:[InpRetB+1],al        ; druh znak
         mov       al,ds:[InpRetB]
         cmp       al,10                    ; je LF ?
         jne       ReadRet2                 ; nen LF
         dec       word ptr ds:[CitRad]     ; snen ukazatele sla dku
ReadRet2:clc
         ret

ReadRet  ENDP

; -----------------------------------------------------------------------------
;        naten znaku ze vstupnho souboru -> AL, CY=konec souboru
; -----------------------------------------------------------------------------

ReadChr  PROC      NEAR

; ------ schova registr

         push      si

; ------ test, zda je znak v navracecm bufferu

         mov       al,0                     ; nulovac bajt
         xchg      al,ds:[InpRetB+1]
         xchg      al,ds:[InpRetB]          ; znak z navracecho bufferu
         or        al,al                    ; byl v bufferu znak ?
         jnz       ReadChr4                 ; v bufferu byl znak

; ------ test, zda je v bufferu pipraven dal znak

         mov       si,ds:[InpRead]          ; tec offset z bufferu
         cmp       si,ds:[InpNum]           ; bude dal bajt ?
         jb        ReadChr3                 ; bude dal bajt

; ------ naten bufferu ze souboru

         call      ReadBuff                 ; naten bufferu ze souboru
         jc        ReadChr6                 ; konec souboru
         xor       si,si                    ; ukazatel na zatek bufferu

; ------ naten znaku z bufferu

ReadChr3:mov       al,ds:[si+InpBuff]       ; naten znaku z bufferu
         inc       word ptr ds:[InpRead]    ; zven ukazatele v bufferu

; ------ navrcen registr

ReadChr4:cmp       al,10                    ; je LF ?
         jne       ReadChr5                 ; nen LF
         inc       word ptr ds:[CitRad]     ; zven ukazatele sla dku
ReadChr5:clc                                ; pznak operace OK

ReadChr6:pop       si
         ret

ReadChr  ENDP

; -----------------------------------------------------------------------------
;        naten bufferu ze vstupnho souboru -> CY=konec souboru
; -----------------------------------------------------------------------------

ReadBuff PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ naten bufferu

         mov       ah,3fh
         mov       bx,ds:[ProgIdnt]         ; identifiktor souboru
         mov       cx,BUFFSIZE              ; velikost bufferu
         mov       dx,offset InpBuff        ; vstupn buffer
         int       21h                      ; naten bufferu ze souboru

; ------ schova potu bajt

         jnc       ReadBuf2                 ; operace byla OK
         xor       ax,ax                    ; pznak, e nebylo nic nateno
ReadBuf2:mov       ds:[InpNum],ax           ; poet bajt v bufferu
         mov       word ptr ds:[InpRead],0  ; tec offset v bufferu
         cmp       ax,1                     ; bylo nco nateno ? (CY=nebylo)

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

ReadBuff ENDP

; *****************************************************************************
;
;                                Obsluha ikon
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        editace ikony AX (nutno inicializovat historii zmn !!!)
; -----------------------------------------------------------------------------

EditIcon PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      es
         mov       bl,ds:[Rezim]            ; aktuln reim
         push      bx
         mov       byte ptr ds:[Rezim],4    ; reim editace ikon

; ------ aktivn editovan ikona

         mov       ds:[EditIcoC],ax         ; slo editovan ikony
         mov       word ptr ds:[EdiIHAkt],0 ; aktivn ikona
         mov       word ptr ds:[BlokSize],0 ; nen blok

; ------ zaazen ikony do historie ikon

         mov       cx,HistEdiM
         mov       si,offset EdiIHist-2
EdiIco12:inc       si
         inc       si
         xchg      ax,ds:[si]               ; vloen ikony
         cmp       ax,ds:[EdiIHist]         ; je to aktivn ikona ?
         je        EdiIco13                 ; je to aktivn ikona - zru se
         loop      EdiIco12

; ------ pprava ukazatel ikon zmn

EdiIco13:mov       ax,ds:[DataICO]          ; zatek ikon
         mov       ds:[BegHICO],ax          ; adresa prvn ikony v historii
         mov       ds:[AktHICO],ax          ; aktuln ikona v historii
         mov       ax,ds:[DataNum]          ; poet bajt programu
         add       ax,10h
         mov       cl,4
         shr       ax,cl                    ; pepoet na odstavce
         add       ax,ds:[DataProg]         ; adresa konce programu
         mov       ds:[MinHICO],ax          ; minimln adresa ikon

; ------ zobrazen rmu kolem hrac plochy

         call      DispRam                  ; zobrazen rmu kolem hrac plochy

; ------ zobrazen rmu kolem menu

         call      MenuRam                  ; zobrazen rmu kolem menu

; ------ zobrazen menu

         call      DispMenu                 ; zobrazen menu

         call      EdiIDNam                 ; zobrazen jmna ikony

; ------ vymazn plochy voleb

         call      MouseOff                 ; vypnut kurzoru myi

         mov       dh,1                     ; ukazatel dku
         mov       ax,ds:[ICOMenu]          ; plocha menu
EdiIco14:mov       dl,1+32*2                ; pozice
         call      DispIcon                 ; zobrazen ikony plochy
         add       dl,4
         call      DispIcon
         add       dh,4
         cmp       dh,1+PVYSKA*4
         jb        EdiIco14
         mov       word ptr ds:[MousZPoz],-1 ; kurzor myi neplatn

; ------ zobrazen editovan plochy

EdiIcon3:call      EdiIDisp                 ; zobrazen editovan ikony
         call      EdiVDis                  ; zobrazen voleb editoru
         call      EdiIPush                 ; uloen zmn

; ------ ekn na stisk klvesy nebo stisk myi

EdiIcon4:call      BlokKDis                 ; obsluha zobrazovn kurzoru bloku
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       EdiIcon7                 ; je klvesa

; ------ ten tlatka myi

         call      IntMouse                 ; obsluha myi
         jc        EdiIcon4                 ; nen zmna

; ------ test, zda je vyvoln akce stiskem tlatka myi

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk tlatka ?
         jz        EdiIcon4                 ; nen stisk tlatka myi

; ------ souadnice X

         mov       cx,ds:[MouseX]
         shr       cx,1
         shr       cx,1
         shr       cx,1

; ------ obsluha editace

         cmp       cx,1+32*2
         jae       EdiIcon5                 ; nen editan pole
         call      EdiEdit                  ; obsluha editace
;         call      EdiIPush                 ; uloen zmn
         jmp       short EdiIcon3

; ------ souadnice X

EdiIcon5:dec       cx
         js        EdiIcon4                 ; neplatn souadnice X

; ------ souadnice Y -> DX = (Y-1)

         mov       dx,ds:[MouseY]
         sub       dx,8
         jb        EdiIcon4                 ; neplatn souadnice Y
         cmp       dx,PVYSKA*32
         jae       EdiIcon4                 ; neplatn souadnice Y

; ------ menu volby barev

         cmp       cx,32*2+8
         jae       EdiIcon6                 ; nen volba barev
         call      EdiVCol                  ; menu volby barev a ikony
         jmp       short EdiIcon3           ; nov zobrazen veho

; ------ menu volby funkce

EdiIcon6:mov       cl,5
         shr       dx,cl                    ; DL = slo ikony

         call      Edi7EEnd                 ; ukonen editace bloku
         cmp       dl,5                     ; je volba funkce ?
         ja        EdiIco62                 ; nen volba funkce
         mov       ds:[FunkceEd],dl         ; je volba funkce
         jmp       EdiIcon3                 ; zobrazen veho

EdiIco62:shl       dx,1
         mov       bx,dx                    ; BX <- ikona * 2
         jmp       word ptr cs:[bx+EdiIMTbl-2*6] ; skok na funkci ikony

; ------ vstup znaku z klvesnice

EdiIcon7:;call      VolKVyp                  ; vypnut kurzoru

         call      Edi7EEnd                 ; ukonen editace bloku

; ------ nvrat registr

EdiIcon9:pop       bx
         mov       ds:[Rezim],bl            ; nvrat reimu
         pop       es
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

EditIcon ENDP

EdiIMTbl label     word
         dw        EdiIBRet                 ; 6: naten blok
         dw        EdiIFlip                 ; 7: pevrcen
         dw        EdiIRot                  ; 8: rotace
         dw        EdiIXCol                 ; 9: zmna barev
         dw        EdiIUndo                 ; 10: obnoven
         dw        EdiIRedo                 ; 11: navrcen obnoven
         dw        EdiISave                 ; 12: uloen
         dw        EdiIcon9                 ; 13: konec

; ------ UNDO

EdiIUndo:mov       ax,ds:[AktHICO]          ; aktuln ikona v historii
         add       ax,ICOSize/16            ; adresa dal ikony
         cmp       ax,ds:[DataICO]          ; je dal ikona ?
         jae       EdiIUnd8                 ; nen dal ikona
EdiIUnd6:mov       ds:[AktHICO],ax          ; nov aktivn ikona
         call      EdiIPop                  ; nvrat ikony
EdiIUnd8:jmp       EdiIcon3

; ------ REDO

EdiIRedo:mov       ax,ds:[AktHICO]          ; aktuln ikona v historii
         sub       ax,ICOSize/16            ; adresa pedel ikony
         cmp       ax,ds:[BegHICO]          ; je pedel ikona ?
         jb        EdiIUnd8                 ; nen pedel ikona
         jmp       short EdiIUnd6

; ------ navrcen bloku

EdiIBRet:mov       ax,ds:[BlokSiz2]         ; uschovan velikost bloku
         or        ax,ax                    ; je njak blok ?
         jz        EdiIUnd8                 ; nen blok
         mov       ds:[BlokSize],ax         ; navrcen velikosti bloku
         mov       byte ptr ds:[FunkceEd],6 ; pznak oznaen bloku
         jmp       short EdiIUnd8

; ------ pevrcen

EdiIFlip:mov       dh,0                     ; ukazatel dku
EdiIFlp2:mov       dl,0                     ; ukazatel stoupajc pozice
         mov       bl,31                    ; ukazatel klesajc pozice
EdiIFlp3:call      EdiGetB                  ; naten bodu z DX
         mov       ah,al                    ; AH <- schova bodu
         xchg      bl,dl                    ; zmna souadnic
         call      EdiGetB                  ; naten bodu z BX
         xchg      al,ah                    ; zmna bod
         call      EdiSetB                  ; nastaven bodu do BX
         xchg      bl,dl                    ; nvrat souadnic
         xchg      al,ah                    ; zmna bod
         call      EdiSetB                  ; nastaven bodu do DX
         inc       dx                       ; zven stoupajcho ukazatele
         dec       bx                       ; snen klesajcho ukazatele
         cmp       dl,16
         jb        EdiIFlp3
         inc       dh
         cmp       dh,32
         jb        EdiIFlp2
         jmp       short EdiIUnd8

; ------ rotace

EdiIRot: mov       dh,0                     ; ukazatel dku Y
EdiIRot2:mov       dl,dh                    ; ukazatel pozice X
EdiIRot3:call      EdiGetB                  ; naten bodu
         mov       ah,al                    ; AH <- schova bodu

         mov       cx,4
EdiIRot4:xchg      dl,dh
         sub       dh,31
         neg       dh
         call      EdiGetB
         xchg      al,ah
         call      EdiSetB
         loop      EdiIRot4

         inc       dx
         mov       al,31
         sub       al,dh
         cmp       dl,al
         jb        EdiIRot3
         inc       dh
         cmp       dh,16
         jb        EdiIRot2
         jmp       EdiIcon3

; ------ zmna barev

EdiIXCol:mov       dh,0                     ; ukazatel dku
EdiIXCl2:mov       dl,0                     ; ukazatel pozice
EdiIXCl3:call      EdiGetB                  ; naten bodu
         cmp       al,ds:[ColLeft]          ; je barva pro lev tlatko ?
         jne       EdiIXCl4
         mov       al,ds:[ColRight]
         jmp       short EdiIXCl5

EdiIXCl4:cmp       al,ds:[ColRight]         ; je barva pro prav tlatko ?
         jne       EdiIXCl6
         mov       al,ds:[ColLeft]
EdiIXCl5:call      EdiSetB                  ; nastaven bodu

EdiIXCl6:inc       dl
         cmp       dl,32
         jb        EdiIXCl3
         inc       dh
         cmp       dh,32
         jb        EdiIXCl2
         jmp       EdiIcon3

; -----------------------------------------------------------------------------
;        zobrazen jmna aktivn ikony
; -----------------------------------------------------------------------------

EdiIDNam PROC      NEAR

         push      ax
         push      cx
         push      si

         mov       ax,ds:[EditIcoC]         ; slo aktivn ikony
         call      GetIName                 ; naten jmna ikony AX
         xor       ax,ax                    ; barva textu = ern
         mov       cx,-1                    ; doba
         mov       si,offset ProgStr        ; buffer s textem
         call      DispHlas                 ; zobrazen jmna ikony

         pop       si
         pop       cx
         pop       ax
         ret

EdiIDNam ENDP

; -----------------------------------------------------------------------------
;        zobrazen aktuln pozice kurzoru myi
; -----------------------------------------------------------------------------

MousDPoz PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ aktuln souadnice kurzoru myi -> DX

         call      EdiGetM                  ; poskytnut pozice kurzoru
         cmp       dx,ds:[MousZPoz]         ; je pozice zmnna ?
         je        MousDPz9                 ; pozice nen zmnna
         mov       ds:[MousZPoz],dx         ; schova zobrazen pozice
         mov       cx,dx                    ; CX <- schova souadnic

; ------ vymazn polka

         mov       dx,(1+32*2+2) + (1 + 5*4 + 2)*HI
         mov       ax,ds:[ICOMenu]          ; plocha menu
         call      DispIcon                 ; zobrazen ikony plochy

; ------ zobrazen souadnice X

         mov       al,"X"                   ; oznaen souadnice X
         mov       dx,(1 + 5*4 + 2)*8       ; linka k zobrazen textu
         call      MousDPz2                 ; zobrazen souadnice X

; ------ zobrazen souadnice Y

         mov       cl,ch                    ; souadnice Y
         mov       al,"Y"                   ; oznaen souadnice Y
         mov       dx,(1 + 5*4 + 4)*8       ; linka k zobrazen textu
         call      MousDPz2                 ; zobrazen souadnice Y

; ------ nvrat registr

MousDPz9:pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

MousDPoz ENDP

; ------ zobrazen souadnice

MousDPz2:mov       ah,0                     ; barva k zobrazen textu
         mov       bx,1+32*2+2              ; pozice k zobrazen
         call      DispChr                  ; zobrazen znaku "X" nebo "Y"
         mov       al,"="
         call      DispChr                  ; zobrazen znaku "="

         mov       al,cl                    ; pozice nebo dek
         aam                                ; rozdlen na slice
         push      ax
         xchg      al,ah
         or        al,al                    ; jsou destky ?
         jz        MousDPz4                 ; nejsou destky
         add       al,"0"                   ; korekce na ASCII znak
         mov       ah,0                     ; barva
         call      DispChr                  ; zobrazen destek
MousDPz4:pop       ax
         add       al,"0"                   ; korekce na ASCII znak
         mov       ah,0                     ; barva
         call      DispChr                  ; zobrazen jednotek
         ret

; -----------------------------------------------------------------------------
;        uloen ikony na disk
; -----------------------------------------------------------------------------

; ------ ukonen obsluhy bloku

EdiISave:call      Edi7EEnd                 ; ukonen editace bloku

; ------ pprava jmna ikony

         mov       ax,ds:[EditIcoC]         ; slo aktivn ikony
         call      GetIName                 ; naten jmna ikony AX
         jnc       EdiISav0
         jmp       EdiIcon3                 ; jmno ikony nenalezeno

; ------ pprava zhlav ikony

EdiISav0:push      ds
         pop       es
         mov       di,offset SoubICO        ; soubor ikony
         mov       si,offset VzorICO        ; vzor ikony
         mov       cx,offset(IcoBuff-SoubICO) ; dlka zhlav
         cld
         rep       movsb                    ; penesen zhlav ikony

; ------ penesen dat ikony

         push      ds
         mov       cx,128                   ; poet bajt k penesen

         push      es
         mov       ax,ds:[EditIcoC]         ; slo ikony
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         pop       ds                       ; DS <- adresa ikonu
         pop       es
         cld

         mov       si,31*32/8               ; adresa poslednho dku
         mov       dh,32/8                  ; poet bajt na dek
EdiISv04:mov       dl,bit7                  ; bitov maska
EdiISav1:mov       al,0                     ; stada dat

         test      byte ptr ds:[si+4*128],dl ; je pozad ?
         jz        EdiISav5                 ; je pozad
         test      byte ptr ds:[si],dl      ; je bit nastaven ?
         jz        EdiISav2                 ; nen nastaven
         or        al,bit4
EdiISav2:test      byte ptr ds:[si+128],dl
         jz        EdiISav3
         or        al,bit5
EdiISav3:test      byte ptr ds:[si+2*128],dl
         jz        EdiISav4
         or        al,bit6
EdiISav4:test      byte ptr ds:[si+3*128],dl
         jz        EdiISav5
         or        al,bit7

EdiISav5:shr       dl,1

         test      byte ptr ds:[si+4*128],dl ; je pozad ?
         jz        EdiISav9                 ; je pozad
         test      byte ptr ds:[si],dl      ; je bit nastaven ?
         jz        EdiISav6                 ; nen nastaven
         or        al,bit0
EdiISav6:test      byte ptr ds:[si+128],dl
         jz        EdiISav7
         or        al,bit1
EdiISav7:test      byte ptr ds:[si+2*128],dl
         jz        EdiISav8
         or        al,bit2
EdiISav8:test      byte ptr ds:[si+3*128],dl
         jz        EdiISav9
         or        al,bit3

EdiISav9:shr       dl,1
         stosb                              ; uloen bajtu
         jnz       EdiISav1                 ; dal ukldan bajt
         inc       si                       ; zven tec adresy
         dec       dh
         jnz       EdiISv92
         mov       dh,32/8
         sub       si,2*32/8
EdiISv92:loop      EdiISv04                 ; dal bajt

         mov       cl,128
         mov       si,4*32*32/8+31*32/8     ; posledn dek masky
         mov       dh,32/8
EdiISavA:lodsb
         not       al
         stosb                              ; uloen masky
         dec       dh
         jnz       EdiISavB
         mov       dh,32/8
         sub       si,2*32/8
EdiISavB:loop      EdiISavA

         pop       ds

; ------ oteven souboru pro zpis

         mov       byte ptr ds:[ProgStr],"\" ; oddlova adresre
         mov       dx,offset JmenoICO       ; jmno souboru
         mov       ah,3ch
         xor       cx,cx
         int       21h                      ; vytvoen souboru
         jc        EdiISav9                 ; chyba
         xchg      ax,bx                    ; BX <- identifiktor souboru

; ------ zpis dat ikony

         mov       dx,offset SoubICO        ; soubor ikony
         mov       cx,offset(SoubICO2-SoubICO) ; velikost ikony
         mov       ah,40h
         int       21h                      ; zpis ikony na disk

; ------ uzaven souboru ikony

         mov       ah,3eh
         int       21h                      ; uzaven souboru ikony
         jmp       EdiIcon3

; -----------------------------------------------------------------------------
;        souadnice kurzoru myi -> DX (s omezenm na editovan pole)
; -----------------------------------------------------------------------------

EdiGetM  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx

; ------ souadnice X

         mov       cx,ds:[MouseX]           ; souadnice myi X
         shr       cx,1
         shr       cx,1
         shr       cx,1                     ; pevod na bajty
         dec       cx                       ; odeten potku
         jns       EdiGetM2                 ; nen podteen
         xor       cx,cx                    ; CX <- omezen pi podteen
EdiGetM2:shr       cx,1                     ; pevod na body
         cmp       cl,32                    ; je pozice OK ?
         jb        EdiGetM3
         mov       cl,31                    ; omezen pozice

; ------ souadnice Y

EdiGetM3:mov       dx,ds:[MouseY]           ; souadnice myi Y
         sub       dx,8                     ; odeten potku
         jnc       EdiGetM4                 ; nen podteen
         xor       dx,dx                    ; DX <- omezen pi podteen
EdiGetM4:xchg      ax,dx                    ; AX <- souadnice Y relativn
         mov       ch,14                    ; poet linek na dek
         div       ch                       ; pepoet na dek
         cmp       al,32                    ; je peteen ?
         jb        EdiGetM5                 ; nen peteen
         mov       al,31                    ; omezen dku
EdiGetM5:mov       dh,al                    ; DH <- dek v ikon
         mov       dl,cl                    ; DL <- pozice v ikon

; ------ nvrat registr

         pop       cx
         pop       ax
         ret

EdiGetM  ENDP

; -----------------------------------------------------------------------------
;        uloen ikony do historie zmn (je-li zmnn)
; -----------------------------------------------------------------------------

EdiIPush PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      si
         push      di
         push      ds
         push      es

; ------ test, zda je ikona uloena

         cld
         mov       ax,ds:[AktHICO]          ; aktuln ikona
         cmp       ax,ds:[DataICO]          ; je njak ikona ?
         jae       EdiIPsh2                 ; nen dn ikona

         push      ds

         push      ax
         mov       ax,ds:[EditIcoC]         ; slo editovan ikony
         call      AdrICO                   ; adresa ikony -> ES
         pop       ax
         mov       ds,ax                    ; DS <- aktuln ikona v historii
         mov       cx,ICOSize/2             ; veliksot ikony ve slovech
         xor       si,si
         xor       di,di
         repe      cmpsw                    ; porovnn ikony
         pop       ds
         je        EdiIPsh6                 ; ikona nen zmnna

; ------ adresa nov ikony (AX=aktivn ikona)

EdiIPsh2:sub       ax,ICOSize/16            ; adresa pedel ikony
         cmp       ax,ds:[MinHICO]          ; je platn adresa ?
         jae       EdiIPsh4                 ; adresa je OK

; ------ zkrcen historie

         call      EdiIDel                  ; zkrcen historie
         mov       ax,ds:[BegHICO]          ; adresa prvn ikony
         sub       ax,ICOSize/16            ; adresa pedel ikony

; ------ penos ikony

EdiIPsh4:mov       ds:[BegHICO],ax          ; adresa prvn ikony
         mov       ds:[AktHICO],ax          ; aktuln ikona

         push      ax                       ; AX = adresa nov ikony
         mov       ax,ds:[EditIcoC]         ; slo editovan ikony
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         pop       ds                       ; DS <- adresa ikony
         pop       es                       ; ES <- nov ikona

         mov       cx,ICOSize/2             ; veliksot ikony ve slovech
         xor       si,si
         xor       di,di
         rep       movsw                    ; penos dat ikony

; ------ nvrat registr

EdiIPsh6:pop       es
         pop       ds
         pop       di
         pop       si
         pop       cx
         pop       ax
         ret

EdiIPush ENDP

; -----------------------------------------------------------------------------
;        nvrat ikony z historie
; -----------------------------------------------------------------------------

EdiIPop  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      si
         push      di
         push      ds
         push      es

; ------ penos ikony

         mov       ax,ds:[EditIcoC]         ; AX <- slo editovan ikony
         call      AdrICO                   ; adresa ikony -> ES
         mov       ds,ds:[AktHICO]          ; adresa aktivn ikony v historii
         mov       cx,ICOSize/2             ; veliksot ikony ve slovech
         xor       si,si
         xor       di,di
         rep       movsw                    ; penos dat ikony

; ------ nvrat registr

         pop       es
         pop       ds
         pop       di
         pop       si
         pop       cx
         pop       ax
         ret

EdiIPop  ENDP

; -----------------------------------------------------------------------------
;        zkrcen historie zmn na polovinu
; -----------------------------------------------------------------------------

EdiIDel  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ vpoet zbylch ikon -> AX

         mov       ax,ds:[DataICO]          ; adresa ikon
         sub       ax,ds:[AktHICO]          ; velikost ikon
         shr       ax,1                     ; polovina
         xor       dx,dx                    ; DX <- 0
         mov       cx,ICOSize/16            ; velikost v odstavcch
         div       cx                       ; pepoet na poet ikon

; ------ adresa novho potku -> DX

         xchg      ax,cx                    ; CX <- poet ikon, AX <- velikost
         mul       cx                       ; pepoet na velikost ikon
         mov       dx,ds:[DataICO]          ; adresa ikon
         sub       dx,ax                    ; DX <- adresa potku

; ------ nov ukazatele ikon

         mov       bx,dx                    ; BX <- nov potek
         mov       ds:[AktHICO],dx          ; aktuln ikona v historii
         xchg      ds:[BegHICO],dx          ; nov potek ikon, DX <- star
         jcxz      EdiIDel9                 ; nezbyla dn ikona
         mov       bp,cx                    ; BP <- poet ikon

; ------ penos ikon

         cld
EdiIDel2:mov       ds,dx                    ; DS <- star potek ikon
         mov       es,bx                    ; ES <- nov potek ikon
         mov       cx,ICOSize/2             ; veliksot ikony ve slovech
         xor       si,si
         xor       di,di
         rep       movsw                    ; penos dat jedn ikony
         add       dx,ICOSize/16            ; dal star ikona
         add       bx,ICOSize/16            ; dal nov ikona
         dec       bp                       ; ta ikon
         jnz       EdiIDel2                 ; dal ikona

; ------ nvrat registr

EdiIDel9:pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

EdiIDel  ENDP

; -----------------------------------------------------------------------------
;        obsluha editace - tuka
; -----------------------------------------------------------------------------

EdiEdit  PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],0 ; je pero ?
         jne       Edi2Edit                 ; nen pero

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; vchoz pozice kurzoru

EdiEdit0:mov       bx,ds:[EdiBegPz]         ; BX <- poten bod
         call      EditLine                 ; nakreslen ry
         mov       ds:[EdiBegPz],dx         ; nov pozice kurzoru

; ------ zobrazen ikony

         call      EdiEdDis                 ; zobrazen ikony pi editaci

; ------ ekn na zmnu myi

EdiEdit1:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       EdiEdit8                 ; je znak z klvesnice
         call      IntMouse                 ; obsluha myi
         jc        EdiEdit1                 ; nen zmna

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk dalho tlatka ?
         jnz       EdiEdit0                 ; je stisk dalho tlatka

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       EdiEdit8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jz        EdiEdit1                 ; nen posun my

         cmp       dx,ds:[EdiBegPz]         ; je zmna pozice ?
         je        EdiEdit1                 ; nen zmna pozice
         jmp       short EdiEdit0

EdiEdit8:ret

EdiEdit  ENDP

; ------ zobrazen ikon pi editaci

EdiEdDis PROC      NEAR

         call      EdiIDisp                 ; zobrazen editovan ikony
         call      EdiVDis                  ; zobrazen voleb editoru

;         push      bx
;         push      dx
;         push      es
;
;         mov       bx,ds:[EdiIHAkt]         ; aktuln ikona v historii
;         mov       dh,bl                    ; aktuln ikona v historii
;         shl       dh,1
;         shl       dh,1                     ; * 4
;         add       dh,2
;         mov       dl,1+32*2+2
;         shl       bx,1
;         mov       es,ds:[EdiIHist+bx]      ; adresa aktivn ikony
;         call      DispIcon                 ; zobrazen mal ikony
;
;         pop       es
;         pop       dx
;         pop       bx

         ret

EdiEdDis ENDP

; -----------------------------------------------------------------------------
;        obsluha editace - ra
; -----------------------------------------------------------------------------

Edi2Edit PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],1 ; je ra ?
         jne       Edi3Edit                 ; nen ra

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace
         jmp       short Edi2Edi3

Edi2Edi2:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         cmp       dx,ds:[EdiOldPz]         ; byla pozice zmnna ?
         je        Edi2Edi4                 ; pozice nebyla zmnna
         call      EdiIPop                  ; nvrat ikony
Edi2Edi3:mov       ds:[EdiOldPz],dx         ; schova nov pozice
         mov       bx,ds:[EdiBegPz]         ; BX <- poten bod
         call      EditLine                 ; nakreslen ry

; ------ zobrazen ikony

         call      EdiEdDis                 ; zobrazen ikony pi editaci

; ------ ekn na zmnu myi

Edi2Edi4:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Edi2Edi8                 ; je znak z klvesnice
         call      IntMouse                 ; obsluha myi
         jc        Edi2Edi4                 ; nen zmna

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk dalho tlatka ?
         jnz       Edi2Edi2                 ; je stisk dalho tlatka

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       Edi2Edi8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jnz       Edi2Edi2                 ; obsluha myi
         jmp       short Edi2Edi4

Edi2Edi8:ret

Edi2Edit ENDP

; -----------------------------------------------------------------------------
;        obsluha editace - tverec
; -----------------------------------------------------------------------------

Edi3Edit PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],2 ; je tverec ?
         jne       Edi4Edit                 ; nen tverec

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace
         jmp       short Edi3Edi3

Edi3Edi2:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         cmp       dx,ds:[EdiOldPz]         ; byla pozice zmnna ?
         je        Edi3Edi4                 ; pozice nebyla zmnna
         call      EdiIPop                  ; nvrat ikony
Edi3Edi3:mov       ds:[EdiOldPz],dx         ; schova nov pozice
         mov       bx,ds:[EdiBegPz]         ; BX <- poten bod
         call      EditCtve                 ; nakreslen tverce

; ------ zobrazen ikony

         call      EdiEdDis                 ; zobrazen ikony pi editaci

; ------ ekn na zmnu myi

Edi3Edi4:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Edi3Edi8                 ; je znak z klvesnice
         call      IntMouse                 ; obsluha myi
         jc        Edi3Edi4                 ; nen zmna

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk dalho tlatka ?
         jnz       Edi3Edi2                 ; je stisk dalho tlatka

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       Edi3Edi8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jnz       Edi3Edi2                 ; obsluha myi
         jmp       short Edi3Edi4

Edi3Edi8:ret

Edi3Edit ENDP

; -----------------------------------------------------------------------------
;        obsluha editace - kruh
; -----------------------------------------------------------------------------

Edi4Edit PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],3 ; je kruh ?
         jne       Edi5Edit                 ; nen kruh

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace
         jmp       short Edi4Edi3

Edi4Edi2:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         cmp       dx,ds:[EdiOldPz]         ; byla pozice zmnna ?
         je        Edi4Edi4                 ; pozice nebyla zmnna
         call      EdiIPop                  ; nvrat ikony
Edi4Edi3:mov       ds:[EdiOldPz],dx         ; schova nov pozice
         mov       bx,ds:[EdiBegPz]         ; BX <- poten bod
         call      EditKruh                 ; nakreslen kruhu

; ------ zobrazen ikony

         call      EdiEdDis                 ; zobrazen ikony pi editaci

; ------ ekn na zmnu myi

Edi4Edi4:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Edi4Edi8                 ; je znak z klvesnice
         call      IntMouse                 ; obsluha myi
         jc        Edi4Edi4                 ; nen zmna

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk dalho tlatka ?
         jnz       Edi4Edi2                 ; je stisk dalho tlatka

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       Edi4Edi8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jnz       Edi4Edi2                 ; obsluha myi
         jmp       short Edi4Edi4

Edi4Edi8:ret

Edi4Edit ENDP

; -----------------------------------------------------------------------------
;        naplnn plochy
; -----------------------------------------------------------------------------

Edi5Edit PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],4 ; je plocha ?
         je        Edi5Edi1                 ; je plocha
         jmp       Edi6Edit                 ; nen plocha

; ------ naten pozice kurzoru myi -> DX

Edi5Edi1:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX

; ------ pprava plnc barvy -> BL=aktuln (sud), BH=doplkov (lich)

         mov       bl,ds:[ColLeft]          ; barva pro lev tlatko
         mov       bh,ds:[ColRight]         ; barva pro prav tlatko
         test      byte ptr ds:[MouseK],bit1 ; je prav tlatko ?
         jz        Edi5Edi4                 ; nen prav tlatko, je jen lev
         test      byte ptr ds:[MouseK],bit0 ; je lev tlatko ?
         jz        Edi5Edi3                 ; nen lev tlatko, je jen prav
         mov       al,dl                    ; pozice bodu
         xor       al,dh                    ; test lichosti bodu
         test      al,bit0                  ; je lich bod ?
         jz        Edi5Edi4                 ; je sud bod
Edi5Edi3:xchg      bl,bh                    ; aktivn je lich bod = prav tla.

; ------ test, zda jsou ob tlatka myi

Edi5Edi4:mov       al,ds:[MouseK]           ; stav myi
         and       al,bit0+bit1             ; stisknut tlatka myi
         cmp       al,bit0+bit1             ; jsou ob tlatka myi ?
         jne       Edi5Edi5                 ; nejsou ob tlatka myi

; ------ schova doplkov barvy, jsou-li ob tlatka myi
; Neuchovv se barva pod kurzorem, protoe ta je zejm ji zmnna
; pedelm stiskem pouze jednoho z obou tlatek

         dec       dl                       ; bod vlevo
         call      EdiGetB                  ; naten bodu vlevo
         jc        Edi5Edi5                 ; chyba
         mov       ch,al                    ; CH <- doplkov barva (lich)

         dec       dh                       ; bod vlevo nahoe
         call      EdiGetB                  ; naten bodu vlevo nahoe
         jc        Edi5Edi5                 ; chyba
         mov       cl,al                    ; CL <- barva pod kurzorem (sud)

; ------ kontrola okol bodu, zda me bt doplkov barva

         inc       dl                       ; bod nahoe
         call      Edi5Lich                 ; kontrola lich barvy
         jc        Edi5Edi5                 ; nesouhlas

         inc       dl                       ; bod vpravo nahoe
         call      Edi5Suda                 ; kontrola sud barvy
         jc        Edi5Edi5                 ; nesouhlas

         inc       dh                       ; bod vpravo
         call      Edi5Lich                 ; kontrola lich barvy
         jc        Edi5Edi5                 ; nesouhlas

         inc       dh                       ; bod vpravo dole
         call      Edi5Suda                 ; kontrola sud barvy
         jc        Edi5Edi5                 ; nesouhlas

         dec       dl                       ; bod dole
         call      Edi5Lich                 ; kontrola lich barvy
         jc        Edi5Edi5                 ; nesouhlas

         dec       dl                       ; bod vlevo dole
         call      Edi5Suda                 ; kontrola sud barvy
         jnc       Edi5Edi6                 ; ve souhlas OK

; ------ nebude doplkov barva

Edi5Edi5:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         call      EdiGetB                  ; naten barvy bodu pod kurzorem
         mov       cl,al                    ; CL <- schova barvy
         mov       ch,al                    ; barva pod kurzorem nen doplkov
         mov       bh,bl                    ; plnc barva nen doplkov

; ------ test, zda je plnc barva shodn s barvou pod kurzorem

Edi5Edi6:cmp       cx,bx                    ; je to barva kurzoru ?
         je        Edi5Edi9                 ; je to barva kurzoru

; ------ vyplnn plochy

         call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         call      EditFill                 ; vyplnn plochy

; ------ zobrazen ikony

         call      EdiEdDis                 ; zobrazen ikony pi editaci

Edi5Edi9:ret

Edi5Edit ENDP

; ------ kontrola sud barvy (CL)

Edi5Suda:call      EdiGetB                  ; naten bodu vlevo nahoe
         jc        Edi5Sud2                 ; chyba
         cmp       al,cl                    ; sud barva
         je        Edi5Sud4                 ; souhlas OK
Edi5Sud2:stc                                ; pznak nesouhlasn barvy
Edi5Sud4:ret

; ------ kontrola lich barvy (CH)

Edi5Lich:call      EdiGetB                  ; naten bodu vlevo nahoe
         jc        Edi5Lch2                 ; chyba
         cmp       al,ch                    ; sud barva
         je        Edi5Lch4                 ; souhlas OK
Edi5Lch2:stc                                ; pznak nesouhlasn barvy
Edi5Lch4:ret

; -----------------------------------------------------------------------------
;        oznaen bloku
; -----------------------------------------------------------------------------

Edi6Edit PROC      NEAR

         cmp       byte ptr ds:[FunkceEd],5 ; je blok ?
         je        Edi6Edi1
         jmp       Edi7Edit                 ; nen blok

Edi6Edi1:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace
         jmp       short Edi6Edi3

Edi6Edi2:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         cmp       dx,ds:[EdiOldPz]         ; byla pozice zmnna ?
         je        Edi6Edi4                 ; pozice nebyla zmnna
Edi6Edi3:mov       ds:[EdiOldPz],dx         ; schova nov pozice
         mov       bx,ds:[EdiBegPz]         ; BX <- poten bod

         call      PetVSyn                  ; synchronizace kvli blikn
         call      BlokKMaz                 ; vypnut kurzoru

; ------ schova souadnic bloku

         cmp       dl,bl                    ; DL mus bt potek vlevo
         jbe       Edi6Ed32
         xchg      bl,dl                    ; oprava poad
Edi6Ed32:cmp       dh,bh                    ; DH mus bt potek nahoe
         jbe       Edi6Ed33
         xchg      bh,dh
Edi6Ed33:mov       ds:[BLokPoz],dx          ; souadnice potku bloku
         sub       bl,dl                    ; ka bloku
         inc       bl                       ; korekce
         sub       bh,dh                    ; vka bloku
         inc       bh                       ; korekce
         mov       ds:[BlokSize],bx         ; velikost oznaenho bloku
         mov       ds:[BlokSiz2],bx         ; uschovan velikost bloku

; ------ zobrazen kurzoru

         call      BlokKDis                 ; zobrazen kurzoru

; ------ schova bloku do bufferu

         mov       di,offset BlokBuff       ; buffer k uloen bloku
         push      ds
         pop       es
Edi6Ed34:push      bx
         push      dx

Edi6Ed35:call      EdiGetB                  ; naten bodu
         cld
         stosb                              ; uloen bodu do bufferu

Edi6Ed38:inc       dx                       ; zven ukazatele pozice na dku
         dec       bl
         jnz       Edi6Ed35                 ; dal pozice na dku

         pop       dx
         pop       bx
         inc       dh                       ; zven ukazatele dku
         dec       bh
         jnz       Edi6Ed34                 ; dal dek

; ------ ekn na zmnu myi

Edi6Edi4:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Edi6Edi8                 ; je znak z klvesnice
         mov       cl,ds:[MouseK]           ; schova stavu myi
         call      IntMouse                 ; obsluha myi
         jc        Edi6Edi4                 ; nen zmna

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk dalho tlatka ?
         jnz       Edi6Edi5                 ; je stisk dalho tlatka

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       Edi6Edi8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jz        Edi6Edi4
Edi6Edi5:jmp       Edi6Edi2                 ; obsluha myi

; ------ vymazn plochy pod blokem

Edi6Edi8:cmp       word ptr ds:[BlokSize],101h ; je jen mal blok ?
         jne       Edi6Edi9                 ; nen mal blok
         mov       word ptr ds:[BlokSize],0 ; takov blok se zru
         ret

Edi6Edi9:mov       byte ptr ds:[FunkceEd],6 ; pznak oznaen bloku

         mov       ch,ds:[MouseK]           ; nov stav myi
         mov       ds:[MouseK],cl           ; star stav (kvli barv podkladu)

         mov       dx,ds:[EdiOldPz]
         mov       bx,ds:[EdiBegPz]         ; BX <- poten bod
         call      EditCtve                 ; nakreslen tverce

         mov       ds:[MouseK],ch           ; navrcen stavu myi
         ret

Edi6Edit ENDP

; -----------------------------------------------------------------------------
;        ukonen editace bloku, blok se ulo
; -----------------------------------------------------------------------------

Edi7EEnd PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx
         push      si

         call      BlokKMaz                 ; vymazn kurzoru bloku

         cmp       word ptr ds:[BlokSize],0
         je        Edi7EEn9

; ------ zruen ikony s vymazanm blokem

         mov       ax,ds:[AktHICO]          ; aktuln ikona v historii
         add       ax,ICOSize/16            ; adresa dal ikony
         cmp       ax,ds:[DataICO]          ; je dal ikona ?
         jae       Edi7EEn2                 ; nen dal ikona
         mov       ds:[AktHICO],ax          ; nov aktivn ikona
         mov       ds:[BegHICO],ax

; ------ penesen bloku do obrzku

Edi7EEn2:mov       dh,byte ptr ds:[BlokPoz+1] ; poten pozice bloku
         mov       bh,byte ptr ds:[BlokSize+1] ; velikost bloku
         or        bh,bh
         jz        Edi7EEn9                 ; nen blok
         mov       si,offset BlokBuff       ; buffer s blokem
Edi7EEn3:mov       dl,byte ptr ds:[BlokPoz] ; poten pozice bloku
         mov       bl,byte ptr ds:[BlokSize] ; ka bloku
         or        bl,bl
         jz        Edi7EEn9
Edi7EEn4:cld
         lodsb                              ; naten jednoho bodu
         call      EdiSetB                  ; nastaven bodu do obrzku
         inc       dl                       ; zven ukazatele pozice
         dec       bl                       ; ta ky bloku
         jnz       Edi7EEn4                 ; dal bod na dku
         inc       dh                       ; zven ukazatele dku
         dec       bh                       ; ta vky bloku
         jnz       Edi7EEn3                 ; dal dek

; ------ uloen obrzku do historie

         mov       word ptr ds:[BlokSize],0 ; zruen bloku
         call      EdiIPush                 ; uloen zmn

; ------ nvrat registr

Edi7EEn9:pop       si
         pop       dx
         pop       bx
         pop       ax
         ret

Edi7EEnd ENDP

; -----------------------------------------------------------------------------
;        obsluha oznaenho bloku
; -----------------------------------------------------------------------------

Edi7Edit:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace

         mov       ax,ds:[BlokPoz]
         cmp       dl,al
         jl        Edi7Edi1
         add       al,byte ptr ds:[BlokSize]
         cmp       dl,al
         jge       Edi7Edi1

         cmp       dh,ah
         jl        Edi7Edi1
         add       ah,byte ptr ds:[BlokSize+1]
         cmp       dh,ah
         jl        Edi7Edi2

Edi7Edi1:mov       byte ptr ds:[FunkceEd],5 ; nvrat zkladnho reimu bloku

         call      Edi7EEnd                 ; ukonen editace bloku

         jmp       Edi6Edit                 ; obsluha oznaovn bloku

; ------ posunut bloku

Edi7Edi2:call      EdiGetM                  ; adresa pozice kurzoru myi -> DX
         cmp       dx,ds:[EdiBegPz]         ; je zmna pozice ?
         je        Edi7Edi4                 ; nen zmna pozice

;         call      BlokKMaz                 ; vymazn kurzoru bloku
;
         push      dx
         sub       dl,byte ptr ds:[EdiBegPz] ; zmna pozice
         add       byte ptr ds:[BlokPoz],dl  ; posun pozice bloku
         sub       dh,byte ptr ds:[EdiBegPz+1]
         add       byte ptr ds:[BlokPoz+1],dh ; posun dku bloku
         pop       dx
         mov       ds:[EdiBegPz],dx         ; schova pozice potku operace

;         call      BlokKDis                 ; zobrazen kurzoru
         call      EdiEdDis                 ; zobrazen ikony pi editaci

; ------ ekn na zmnu myi

Edi7Edi4:
;         call      MouseOn                  ; zapnut kurzoru myi
         call      MousDPoz                 ; zobrazen pozice kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       Edi7Edi8                 ; je znak z klvesnice
         mov       cl,ds:[MouseK]           ; schova stavu myi
         call      IntMouse                 ; obsluha myi
         jc        Edi7Edi4                 ; nen zmna

         test      byte ptr ds:[MouseK],bit4+bit5 ; je konec ?
         jnz       Edi7Edi8                 ; je uvolnn tlatka myi

         test      byte ptr ds:[MouseK],bit7
         jz        Edi7Edi4
         jmp       Edi7Edi2                 ; obsluha myi


Edi7Edi8:ret

; -----------------------------------------------------------------------------
;        obsluha zobrazovn kurzoru bloku
; -----------------------------------------------------------------------------

BlokKDis PROC      NEAR

         push      ax
         cmp       word ptr ds:[BlokSize],0
         je        BlokKDs8
         test      byte ptr ds:[Param],bit5 ; je kurzor zobrazen ?
         jnz       BlokKDs8                 ; je zobrazen
         cmp       byte ptr ds:[FunkceEd],5
         jb        BlokKDs8
         call      EdiBKDis                 ; nov zobrazen kurzoru
BlokKDs8:pop       ax
         ret

BlokKDis ENDP

; -----------------------------------------------------------------------------
;        vymazn zobrazen kurzoru bloku
; -----------------------------------------------------------------------------

BlokKMaz PROC      NEAR

         push      ax
         test      byte ptr ds:[Param],bit5 ; je kurzor vypnut ?
         jz        BlokKMz2                 ; kurzor je vypnut
         call      EdiBKDis                 ; zobrazen kurzoru bloku
BlokKMz2:pop       ax
         ret

BlokKMaz ENDP

; -----------------------------------------------------------------------------
;        zobrazen oznaen bloku
; -----------------------------------------------------------------------------

EdiBKDis PROC      NEAR

; ------ schova registr

         xor       byte ptr ds:[Param],bit5 ; zmna pznaku kurzoru
         call      MouseOff                 ; vypnut kurzoru myi

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      es

; ------ vpoet adresy ve videopamti -> DI

         mov       al,14                    ; poet linek na dek
         imul      byte ptr ds:[BlokPoz+1]  ; poten linka s blokem
         mov       si,ax                    ; SI <- poten linka bloku
         add       ax,8                     ; piten potku
         imul      word ptr ds:[DispSirB]   ; pepoet na adresu ve videopamti
         mov       bh,0
         mov       bl,byte ptr ds:[BlokPoz]
         or        bl,bl
         jns       EdiBKD02
         dec       bh
EdiBKD02:shl       bx,1                     ; pepoet na bajtovou pozici
         inc       bx                       ; piten potku
         add       ax,bx                    ; piten pozice
         xchg      ax,di                    ; DI <- adresa ve videopamti

; ------ pprava k operaci

         cld
         cli                                ; zkaz peruen bhem operace
         xor       cx,cx                    ; CX <- 0
         mov       es,ds:[AdrVRAM]          ; adresa videopamti

; ------ nastaven zpisov roviny

         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,0fh                   ; zpisov rovina - vechno
         out       dx,al                    ; volba zpisov roviny

; ------ nastaven zpisovho mdu XOR

         mov       dx,3ceh
         mov       al,3
         out       dx,al
         inc       dx
         mov       al,18h
         out       dx,al                    ; zpisov md XOR

; ------ zpis horn linky

         cld
         call      EdiBKDsV
         call      EdiBKDsV
         call      EdiBKDsV
         call      EdiBKDsV

; ------ zpis okraj

         mov       dl,byte ptr ds:[BlokPoz]
         mov       dh,0
         shl       dx,1
         mov       al,byte ptr ds:[BLokSize] ; ka bloku
         mov       ah,0
         shl       ax,1                     ; ka bloku v bajtech
         dec       ax
         xchg      ax,bp

         mov       al,14                    ; poet linek na dek
         mul       byte ptr ds:[BlokSize+1]
         xchg      ax,cx
         sub       cx,9
         jbe       EdiBKDs4

EdiBKDs1:cmp       si,14*32                 ; je platn linka bloku ?
         jae       EdiBKD14                 ; nen platn linka bloku

         mov       al,0f8h
         cmp       dl,64
         jae       EdiBKD12
         xchg      al,es:[di]
EdiBKD12:mov       al,3eh
         add       dx,bp
         cmp       dl,64
         jae       EdiBKD13
         xchg      al,es:[di+bp]
EdiBKD13:sub       dx,bp
EdiBKD14:add       di,80
         inc       si
         loop      EdiBKDs1

; ------ zpis spodn linky

EdiBKDs4:call      EdiBKDsV
         call      EdiBKDsV
         call      EdiBKDsV
         call      EdiBKDsV

; ------ nvrat bاnho zpisovho mdu

EdiBKDs5:mov       dx,3cfh
         mov       al,0
         out       dx,al                    ; nastaven bاnho mdu

; ------ nvrat registr

         sti                                ; peruen opt povoleno
         pop       es
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

EdiBKDis ENDP

; ------ zpis linky EGA a VGA

EdiBKDsV PROC      NEAR

         mov       dl,byte ptr ds:[BlokPoz] ; poten pozice bloku
         shl       dl,1
         mov       cl,byte ptr ds:[BLokSize] ; ka bloku
         mov       ch,0
         shl       cx,1                     ; ka bloku v bajtech
         push      di
         dec       cx
         jcxz      EdiBKDV4

         cmp       si,14*32                 ; je platn linka bloku ?
         jae       EdiBKDV6                 ; nen platn linka bloku

EdiBKDV2:mov       al,-1
         cmp       dl,64
         jae       EdiBKDV3
         xchg      al,es:[di]
EdiBKDV3:inc       di
         inc       dl
         loop      EdiBKDV2

EdiBKDV4:cmp       dl,64
         jae       EdiBKDV6
         mov       al,0feh
         xchg      al,es:[di]

EdiBKDV6:pop       di
         add       di,80
         inc       si                       ; zven ukazatele linky bloku
         ret

EdiBKDsV ENDP

; -----------------------------------------------------------------------------
;     vyplnn plochy od souadnice DX (vol se rekurzivn !)
; -----------------------------------------------------------------------------
; VSTUP: DX=aktuln souadnice
;        BL=aktuln plnc barva (sud)
;        BH=doplkov plnc barva (lich)
;        CL=aktuln plnn barva (sud)
;        CH=doplkov plnn barva (lich)
; -----------------------------------------------------------------------------

EditFill PROC      NEAR

; ------ schova registr (zachovat poad - navrac se v procedue !)

         push      bx                       ; plnc barva
         push      cx                       ; barva pod kurzorem
         push      dx                       ; souadnice

; ------ test peteen zsobnku

         cmp       sp,offset Zasob0+2*50    ; je zsobnk bezpen ?
         jbe       EditFil9                 ; peteen zsobnku

; ------ nastaven barvy bodu pod kurzorem

EditFil2:mov       al,bl                    ; AL <- aktuln plnc barva
         call      EdiSetB                  ; nastaven bodu pod kurzorem

; ------ test bodu smrem dol

         inc       dh                       ; bod smrem dol
         xchg      bl,bh                    ; zmna plnc barvy
         xchg      cl,ch                    ; zmna plnn barvy
         call      EdiGetB                  ; naten bodu smrem dol
         cmp       al,cl                    ; je to plnn barva ?
         jne       EditFil3                 ; nen to plnn barva
         call      EditFill                 ; vyplnn dal linky
EditFil3:dec       dh                       ; nvrat dku

; ------ test bodu smrem nahoru (CL/CH a BL/BH nejsou nyn zamnny !)

         dec       dh                       ; bod smrem nahoru
         call      EdiGetB                  ; naten bodu smrem dol
         cmp       al,cl                    ; je to plnn barva ?
         jne       EditFil4                 ; nen to plnn barva
         call      EditFill                 ; vyplnn dal linky
EditFil4:inc       dh                       ; nvrat dku

; ------ test dalho bodu (CL/CH a BL/BH nejsou nyn zamnny !)

         inc       dl                       ; zven pozice
         call      EdiGetB                  ; naten dalho bodu
         cmp       al,cl                    ; je to plnn barva ?
         je        EditFil2                 ; naplnn dalho bodu

; ------ nvrat ukazatel

         pop       dx                       ; nvrat ukazatele linky
         pop       cx                       ; nvrat plnn barvy
         pop       bx                       ; nvrat plnc barvy

         push      bx
         push      cx
         push      dx

; ------ test pedelho bodu

         xchg      bl,bh                    ; zmna plnc barvy
         xchg      cl,ch                    ; zmna plnn barvy
EditFil6:dec       dl                       ; snen pozice
         call      EdiGetB                  ; naten dalho bodu
         cmp       al,cl                    ; je to plnn barva ?
         jne       EditFil9                 ; nen to plnn barva

; ------ nastaven barvy bodu pod kurzorem

         mov       al,bl                    ; AL <- aktuln plnc barva
         call      EdiSetB                  ; nastaven bodu pod kurzorem

; ------ test bodu smrem dol

         inc       dh                       ; bod smrem dol
         xchg      bl,bh                    ; zmna plnc barvy
         xchg      cl,ch                    ; zmna plnn barvy
         call      EdiGetB                  ; naten bodu smrem dol
         cmp       al,cl                    ; je to plnn barva ?
         jne       EditFil7                 ; nen to plnn barva
         call      EditFill                 ; vyplnn dal linky
EditFil7:dec       dh                       ; nvrat dku

; ------ test bodu smrem nahoru (CL/CH a BL/BH nejsou nyn zamnny !)

         dec       dh                       ; bod smrem nahoru
         call      EdiGetB                  ; naten bodu smrem dol
         cmp       al,cl                    ; je to plnn barva ?
         jne       EditFil8                 ; nen to plnn barva
         call      EditFill                 ; vyplnn dal linky
EditFil8:inc       dh                       ; nvrat dku
         jmp       short EditFil6           ; dal bod (BX,CX nejsou zamnny!)

; ------ nvrat registr

EditFil9:pop       dx
         pop       cx
         pop       bx
         ret

EditFill ENDP

;; -----------------------------------------------------------------------------
;;        naten aktuln barvy myi -> AL
;; -----------------------------------------------------------------------------
;
;GetACol  PROC      NEAR
;
;         mov       al,ds:[ColLeft]          ; barva pro lev tlatko
;         test      byte ptr ds:[MouseK],bit0 ; je lev tlatko ?
;         jnz       GetACol2                 ; je lev tlatko
;         mov       al,ds:[ColRight]         ; barva pro prav tlatko
;GetACol2:ret
;
;GetACol  ENDP

; -----------------------------------------------------------------------------
;        pole volby barvy a ikony
; -----------------------------------------------------------------------------

EdiVCol  PROC      NEAR

; ------ volba ikony

         cmp       dx,HistEdiM*32           ; je ikona z historie ?
         jae       EdiVCol2                 ; nen historie
         sub       dx,8
         jb        EdiVCol1                 ; nen platn ikona
         mov       cl,5
         shr       dx,cl                    ; DL = slo ikony
         mov       bx,dx                    ; BX <- slo ikony
         cmp       bx,ds:[EdiIHAkt]         ; je ji aktivn ?
         je        EdiVCol1                 ; je ji aktivn

         call      Edi7EEnd                 ; ukonen editace bloku

         mov       ds:[EdiIHAkt],bx         ; aktivn ikona
         shl       bx,1
         mov       ax,ds:[bx+EdiIHist]      ; slo ikony
         mov       ds:[EditIcoC],ax         ; slo editovan ikony

         mov       ax,ds:[DataICO]          ; zatek ikon
         mov       ds:[BegHICO],ax          ; adresa prvn ikony v historii
         mov       ds:[AktHICO],ax          ; aktuln ikona v historii

         call      EdiIPush                 ; uloen ikony do historie

         call      EdiIDNam                 ; zobrazen jmna ikony

EdiVCol1:ret

; ------ volba barvy

EdiVCol2:
         cmp       dx,PVYSKA*32-5*32
         jb        EdiIco45

         mov       al,-1
         sub       dx,PVYSKA*32-4*32-8
         jc        EdiIc446
         shr       dx,1
         shr       dx,1
         shr       dx,1
         shr       dx,1
         and       dl,7
         cmp       cx,32*2+4
         jb        EdiIc444
         add       dl,8
EdiIc444:mov       al,dl
EdiIc446:test      byte ptr ds:[MouseK],bit2
         jz        EdiIc447
         mov       ds:[ColLeft],al
EdiIc447:test      byte ptr ds:[MouseK],bit3
         jz        EdiIc448
         mov       ds:[ColRight],al
EdiIc448:ret




EdiIco45:
         ret


EdiVCol  ENDP

; -----------------------------------------------------------------------------
;        zobrazen editovan ikony
; -----------------------------------------------------------------------------

EdiIDisp PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx

         and       byte ptr ds:[Param],not bit5 ; kurzor bloku nen zobrazen

; ------ zobrazen plochy

         mov       bx,ds:[BlokPoz]           ; pozice bloku
         add       bl,byte ptr ds:[BlokSize] ; pozice konce bloku
         add       bh,byte ptr ds:[BlokSize+1]

         mov       dh,0                     ; ukazatel dku
EdiIDis2:mov       dl,0
EdiIDis4:call      EdiGetB                  ; naten barvy bodu

         cmp       byte ptr ds:[FunkceEd],5
         jb        EdiIDis8                 ; nen obsluha bloku
         cmp       dl,bl
         jge       EdiIDis8
         cmp       dh,bh
         jge       EdiIDis8
         cmp       dl,byte ptr ds:[BlokPoz]
         jl        EdiIDis8                 ; nen blok
         cmp       dh,byte ptr ds:[BlokPoz+1]
         jl        EdiIDis8

         push      bx
         mov       al,dh                    ; aktuln dek
         sub       al,byte ptr ds:[BlokPoz+1] ; dek relativn v bloku
         mul       byte ptr ds:[BlokSize] ; pepoet na offset v bloku
         xchg      ax,bx                    ; BX <- offset dku v bloku
         mov       al,dl                    ; aktuln pozice
         sub       al,byte ptr ds:[BlokPoz] ; pozice relativn v bloku
         mov       ah,0
         add       bx,ax                    ; BX <- offset bodu v bloku
         mov       al,ds:[bx+BlokBuff]      ; bod z bufferu
         pop       bx

EdiIDis8:call      EdiDispB                 ; zobrazen bodu
         inc       dx
         cmp       dl,32
         jb        EdiIDis4
         inc       dh
         cmp       dh,32
         jb        EdiIDis2

; ------ nvrat registr

         pop       dx
         pop       bx
         pop       ax

         call      BlokKDis                 ; obsluha zobrazovn kurzoru bloku

         ret

EdiIDisp ENDP

; -----------------------------------------------------------------------------
;        nastaven tverce mezi souadnicemi BX/DX na aktuln barvu
; -----------------------------------------------------------------------------

EditCtve PROC      NEAR

; ------ schova registr

         push      dx

; ------ oprava souadnic, aby byl vdy zleva doprava -> DX=potek, BX=konec

         cmp       dl,bl                    ; je DX vpravo od BX ?
         jbe       EditCtv1                 ; DX je OK
         xchg      bx,dx                    ; DX bude jako potek vlevo

; ------ nakreslen tverce

EditCtv1:push      bx
         mov       bl,dl                    ; pozice konce = pozice zatku
         call      EditLine                 ; nakreslen jedn ry
         pop       bx
         inc       dx                       ; zven ukazatele pozice
         cmp       dl,bl                    ; je ji koncov pozice ?
         jbe       EditCtv1                 ; nen jet pekroen pozice

; ------ nvrat registr

EditCtv9:pop       dx
         ret

EditCtve ENDP

; -----------------------------------------------------------------------------
;        nastaven kruhu mezi souadnicemi BX/DX (max. 32 !) na aktuln barvu
; -----------------------------------------------------------------------------
;
EditKruh PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp

; ------ kvadrt rozdlu vzdlenosti X -> CX (=max. 1024)

         cmp       dl,bl                    ; je DL ped BL ?
         jbe       EditKrh1                 ; DL je ped BL
         xchg      dl,bl                    ; oprava poad
EditKrh1:inc       bl                       ; vetn koncovho bodu
         mov       al,bl                    ; AL <- druh bod X
         sub       al,dl                    ; rozdl vzdlenost X (max. 32)
         mul       al                       ; rozdl vzdlenosti X^2
         xchg      ax,cx                    ; CX <- rozdl vzdlenosti X^2

; ------ kvadrt rozdlu vzdlenosti Y -> AX (=max. 1024)

         cmp       dh,bh                    ; je DH ped BH ?
         jbe       EditKrh2                 ; DH je ped BH
         xchg      dh,bh                    ; oprava poad
EditKrh2:inc       bh                       ; vetn koncovho bodu
         mov       al,bh                    ; AL <- druh bod Y
         sub       al,dh                    ; rozdl vzdlenosti Y (max. 32)
         mul       al                       ; rozdl vzdlenosti Y^2

; ------ vpoet prmru kruhu -> SI (= ka kruhu vetn koncovch bod)

         add       ax,cx                    ; AX <- souet X^2 + Y^2 (=max. 2048)
         mov       cl,4
         shl       ax,cl                    ; * 16 pro zven pesnosti
         call      Odmocn                   ; vpoet odmocniny z AX
         shr       ax,1
         shr       ax,1                     ; AX = prmr kruhu
         mov       si,ax                    ; SI <- prmr kruhu (max. 46)

; ------ vpoet 4*polomr^2 -> BP

         mul       al                       ; AX <- prmr^2
         test      si,1
         jnz       EditKr22
         add       ax,si                    ; + mal korekce pro zaokrouhlen
         add       ax,si
         add       ax,si
EditKr22:xchg      ax,bp                    ; BP <- 4*polomr^2

; ------ vpoet stedu krunice -> DX

         add       dl,bl                    ; poten + koncov bod X
         sar       dl,1                     ; DL <- potek X
         add       dh,bh                    ; DH <- sted Y * 2
         sar       dh,1                     ; DH <- sted Y

; ------ vpoet potu bod k malovn -> CX (tj. prmr/2 * 1/sqrt2)

         mov       ax,si                    ; AX <- prmr
;         mov       ah,91                    ; 256*(1/2)*(1/sqrt(2)) (trochu vc)
         mov       ah,96
         mul       ah                       ; vpoet potu bod * 256
         mov       ch,0
         mov       cl,ah                    ; CX <- poet bod k malovn
         inc       cx

; ------ vpoet stedu pro sud body -> BX

         mov       bx,dx                    ; BX <- sted kruhu
         mov       ax,si                    ; AX <- prmr
         not       ax
         and       al,bit0                  ; 1=sud prmr
         sub       bl,al                    ; posun X
         sub       bh,al                    ; posun Y

; ------ ukazatel vzdlenosti 2*X

         xor       si,si                    ; SI <- 0 ta vzdlenosti X
EditKrh3:mov       ax,si                    ; AL <- 2*vzdlenost X
         mul       al                       ; 4*vzdlenost X^2
         sub       ax,bp                    ; - 4*polomr^2 + 4*vzdlenost X^2
         jnc       EditKrh8                 ; je peteen
         neg       ax                       ; oprava znamnka
         call      Odmocn                   ; vpoet odmocniny
         shr       ax,1                     ; vka Y
         xchg      ax,di                    ; DI <- vka Y

; ------ nakreslen ry vlevo od stedu

         push      bx
         push      dx
         mov       ax,si                    ; AX <- vzdlenost * 2
         shr       ax,1                     ; polovina vzdlenosti
         sub       dl,al                    ; souadnice X
         js        EditKrh4                 ; pozice X je zporn
         mov       bl,dl                    ; BL <- souadnice X
         mov       ax,di                    ; AX <- vka Y
         sub       dh,al                    ; poten souadnice Y
         add       bh,al                    ; koncov souadnice Y
         call      EditLine                 ; zobrazen ry
EditKrh4:pop       dx
         pop       bx

; ------ nakreslen ry vpravo od stedu

         push      bx
         push      dx
         mov       ax,si                    ; AX <- vzdlenost * 2
         shr       ax,1                     ; polovina vzdlenosti
         add       bl,al                    ; souadnice X
         js        EditKrh5                 ; pozice X je zporn
         mov       dl,bl                    ; DL <- souadnice X
         mov       ax,di                    ; AX <- vka Y
         sub       dh,al                    ; poten souadnice Y
         add       bh,al                    ; koncov souadnice Y
         call      EditLine                 ; zobrazen ry
EditKrh5:pop       dx
         pop       bx

; ------ nakreslen ry nahoru od stedu

         push      bx
         push      dx
         mov       ax,si                    ; AX <- vzdlenost * 2
         shr       ax,1                     ; polovina vzdlenosti
         sub       dh,al                    ; souadnice Y
         js        EditKrh6                 ; pozice Y je zporn
         mov       bh,dh                    ; BH <- souadnice Y
         mov       ax,di                    ; AX <- vka Y
         sub       dl,al                    ; poten souadnice X
         add       bl,al                    ; koncov souadnice X
         call      EditLine                 ; zobrazen ry
EditKrh6:pop       dx
         pop       bx

; ------ nakreslen ry dol od stedu

         push      bx
         push      dx
         mov       ax,si                    ; AX <- vzdlenost * 2
         shr       ax,1                     ; polovina vzdlenosti
         add       bh,al                    ; souadnice Y
         js        EditKrh7                 ; pozice Y je zporn
         mov       dh,bh                    ; DH <- souadnice Y
         mov       ax,di                    ; AX <- vka Y
         sub       dl,al                    ; poten souadnice X
         add       bl,al                    ; koncov souadnice X
         call      EditLine                 ; zobrazen ry
EditKrh7:pop       dx
         pop       bx

EditKrh8:inc       si
         inc       si                       ; ukazatel vzdlenosti * 2
         loop      EditKrh3                 ; dal bod

; ------ nvrat registr

EditKrh9:pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

EditKruh ENDP

;; -----------------------------------------------------------------------------
;;   nastaven kruhu mezi souadnicemi BX (=okraj)/DX (=sted) na aktuln barvu
;; -----------------------------------------------------------------------------
;
;EditKruh PROC      NEAR
;
;         cmp       bx,dx
;         jne       EditKrh0
;         jmp       EditLine
;
;; ------ schova registr
;
;EditKrh0:push      ax
;         push      bx
;         push      cx
;         push      dx
;         push      bp
;
;; ------ vpoet polomru kruhu -> CX
;
;         mov       al,dl                    ; AL <- sted X
;         sub       al,bl                    ; AL <- rozdl vzdlenosti X
;         imul      al                       ; rozdl X^2
;         xchg      ax,cx                    ; CX <- rozdl X^2
;
;         mov       al,dh                    ; AH <- sted Y
;         sub       al,bh                    ; AL <- rozdl vzdlenosti Y
;         imul      al                       ; rozdl Y^2
;
;         add       ax,cx                    ; AX <- souet X^2 + Y^2
;         call      Odmocn                   ; vpoet odmocniny z AX
;         mov       cx,ax                    ; CX <- polomr kruhu
;         mul       al
;         add       ax,cx                    ; korekce
;         xchg      ax,bp                    ; BP <- polomr kruhu^2
;
;; ------ vpoet okraje X a Y
;
;         sub       dl,cl                    ; nov okraj X
;         inc       cx
;
;; ------ nakreslen kruhu
;
;EditKrh3:push      bx
;         push      dx
;
;         mov       al,cl                    ; zbyl vzdlenost
;         dec       ax
;         mul       al                       ; zbyl vzdlenost X^2
;         sub       ax,bp                    ; polomr^2 - rozdl X^2
;         neg       ax
;         or        ax,ax                    ; je platn slo ?
;         jns       EditKrh4
;         xor       ax,ax                    ; omezen
;EditKrh4:call      Odmocn                   ; vpoet odmocniny
;         mov       bh,dh                    ; BH <- sted Y
;         sub       dh,al                    ; potek Y
;         add       bh,al                    ; konec Y
;         mov       bl,dl                    ; pozice konce = pozice zatku
;         cmp       dl,32
;         jae       EditKrh5
;         call      EditLine                 ; nakreslen jedn ry
;
;EditKrh5:mov       ax,cx                    ; AX <- zbyl ry
;         dec       ax                       ; zbyl ry - 1
;         jz        EditKrh6                 ; je posledn ra
;         shl       ax,1
;         add       dl,al
;         mov       bl,dl
;         cmp       dl,32
;         jae       EditKrh6
;         call      EditLine                 ; zrcadlov ra
;
;EditKrh6:pop       dx
;         pop       bx
;
;         inc       dl                       ; zven ukazatele pozice
;         loop      EditKrh3
;
;; ------ nvrat registr
;
;EditKrh9:pop       bp
;         pop       dx
;         pop       cx
;         pop       bx
;         pop       ax
;         ret
;
;EditKruh ENDP

; -----------------------------------------------------------------------------
;        vpoet odmocniny z AX -> AX
; -----------------------------------------------------------------------------

Odmocn   PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      bp

; ------ kontrola povolen hodnoty

         cmp       ax,1                     ; minimln hodnota = 2
         jbe       Odmocn9                  ; pli mal hodnota

; ------ inicializace registr

         mov       bp,ax                    ; BP <- pvodn slo
         shr       ax,1
         xchg      ax,bx                    ; BX <- vsledek (zde jet nen 0)

; ------ vpoet jedn hodnoty

         mov       cx,100                   ; asi tak maximln pokus
Odmocn2: xor       dx,dx                    ; DX <- 0
         mov       ax,bp                    ; AX <- pvodn slo
         div       bx                       ; vydlen mezivsledkem
         cmp       ax,bx                    ; je ji slo nemnn ?
         je        Odmocn8                  ; slo je ji nemnn
         add       ax,bx                    ; + mezivsledek
         shr       ax,1                     ; stedn hodnota
         xchg      ax,bx                    ; BX <- nov mezivsledek
         loopnz    Odmocn2                  ; vsledek nen = 0

; ------ nvrat registr

Odmocn8: xchg      ax,bx                    ; AX <- vypoten slo
Odmocn9: pop       bp
         pop       dx
         pop       cx
         pop       bx
         ret

Odmocn   ENDP

; -----------------------------------------------------------------------------
;        nastaven linky mezi souadnicemi BX/DX na aktuln barvu
; -----------------------------------------------------------------------------

EditLine PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di

; ------ omezen souadnic

         or        dl,dl
         jns       EditLn02
         mov       dl,0
EditLn02:cmp       dl,32
         jb        EditLn03
         mov       dl,31
EditLn03:or        dh,dh
         jns       EditLn04
         mov       dh,0
EditLn04:cmp       dh,32
         jb        EditLn05
         mov       dh,31

EditLn05:or        bl,bl
         jns       EditLn06
         mov       bl,0
EditLn06:cmp       bl,32
         jb        EditLn07
         mov       bl,31
EditLn07:or        bh,bh
         jns       EditLn08
         mov       bh,0
EditLn08:cmp       bh,32
         jb        EditLin0
         mov       bh,31

; ------ oprava souadnic, aby byl vdy zleva doprava -> DX=potek, BX=konec

EditLin0:cmp       dl,bl                    ; je DX vpravo od BX ?
         jbe       EditLin1                 ; DX je OK
         xchg      bx,dx                    ; DX bude jako potek vlevo

; ------ prustek souadnice X -> BL (bude vdy kladn nebo minimln 0)

EditLin1:sub       bl,dl                    ; BL <- prustek souadnice X
         mov       ch,0
         mov       cl,bl                    ; CL <- poet bod k zobrazen - 1
         mov       si,-1                    ; SI <- ta prustku pro 1/1
         inc       cx                       ; vetn koncovho bodu
         mov       di,40                    ; DI <- ta prustku
                                            ;  (mal hodnota je pro ppad 1/1)

; ------ test, zda je smr ry nahoru nebo dol

         sub       bh,dh                    ; prustek souadnice Y
         jb        EditLin5                 ; prustek je nahoru

; ====== prustek je rovn nebo dol (tj. prustek DH je kladn)

; ------ rozlien, zda je vt prustek ve smru X nebo Y

         cmp       bl,bh                    ; je vt prustek Y nebo X ?
         jb        EditLin3                 ; je vt prustek Y
         je        EditLin2                 ; prustky jsou stejn

; ====== ra jde mlo strm dol

; ------ vpoet zlomku prustku -> SI

         call      EditLiY                  ; vpoet prustku pro Y

; ------ zobrazen ry

EditLin2:call      EdiSetA                  ; nastaven bodu
         inc       dx                       ; zven souadnice X
         add       di,si                    ; zven tae prustku Y
         jnc       EditLn22                 ; nen zven souadnice Y
         inc       dh                       ; zven souadnice Y
EditLn22:loop      EditLin2                 ; dal bod
         jmp       short EditLin9

; ====== ra jde hodn strm dol

EditLin3:mov       cl,bh                    ; CX <- poet bod k zobrazen
         inc       cx                       ; vetn koncovho bodu

; ------ vpoet zlomku prustku -> SI

         call      EditLiX                  ; vpoet prustku pro X

; ------ zobrazen ry

EditLin4:call      EdiSetA                  ; nastaven bodu
         inc       dh                       ; zven souadnice Y
         add       di,si                    ; zven tae prustku X
         jnc       EditLn42                 ; nen zven souadnice X
         inc       dx                       ; zven souadnice X
EditLn42:loop      EditLin4                 ; dal bod
         jmp       short EditLin9

; ====== prustek je nahoru (tj. prustek DH je zporn)

EditLin5:neg       bh                       ; oprava prustku BH

; ------ rozlien, zda je vt prustek ve smry X nebo Y

         cmp       bl,bh                    ; je vt prustek Y nebo X ?
         jb        EditLin7                 ; je vt prustek Y
         je        EditLin6                 ; prustky jsou stejn

; ====== ra jde mlo strm nahoru

; ------ vpoet zlomku prustku -> SI

         call      EditLiY                  ; vpoet prustku pro Y

; ------ zobrazen ry

EditLin6:call      EdiSetA                  ; nastaven bodu
         inc       dx                       ; zven souadnice X
         add       di,si                    ; zven tae prustku Y
         jnc       EditLn62                 ; nen zven souadnice Y
         dec       dh                       ; snen souadnice Y
EditLn62:loop      EditLin6                 ; dal bod
         jmp       short EditLin9

; ====== ra jde hodn strm nahoru

EditLin7:mov       cl,bh                    ; CL <- poet bod k zobrazen
         inc       cx                       ; vetn koncovho bodu

; ------ vpoet zlomku prustku -> SI

         call      EditLiX                  ; vpoet prustku pro X

; ------ zobrazen ry

EditLin8:call      EdiSetA                  ; nastaven bodu
         dec       dh                       ; snen souadnice Y
         add       di,si                    ; zven tae prustku X
         jnc       EditLn82                 ; nen zven souadnice X
         inc       dx                       ; zven souadnice X
EditLn82:loop      EditLin8                 ; dal bod

; ------ nvrat registr

EditLin9:pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

EditLine ENDP

; ------ vpoet prustku -> SI

EditLiY: push      dx
         mov       dl,bh                    ; AX <- rozdl souadnic Y * HI
         jmp       short EditLiX2

EditLiX: push      dx
         mov       dl,bl                    ; AX <- rozdl souadnic X * HI

EditLiX2:push      ax

         mov       ax,-1
         mov       dh,0
         div       cx                       ; / (poet prustk)
         mov       si,ax                    ; SI <- prustek * HI
         shr       ax,1
         add       di,ax

         pop       ax

         pop       dx
         ret

;; -----------------------------------------------------------------------------
;;  nastaven bodu na souadnicch DX na aktuln hodnotu -> CY=chyba souadnic
;; -----------------------------------------------------------------------------
;
;EditBod  PROC      NEAR
;
;; ------ schova registr
;
;         push      ax
;
;; ------ pprava poadovan barvy -> AH
;
;         mov       ah,ds:[ColLeft]          ; barva pro lev tlatko
;         test      byte ptr ds:[MouseK],bit0 ; je lev tlatko ?
;         jnz       EditBod2                 ; je lev tlatko
;         mov       ah,ds:[ColRight]         ; barva pro prav tlatko
;
;; ------ test, zda je bod ji nastaven
;
;EditBod2:call      EdiGetB                  ; poskytnut bodu
;         jc        EditBod8                 ; neplatn souadnice
;         cmp       al,ah                    ; je bod ji nastaven ?
;         je        EditBod8                 ; bod je ji nastaven
;
;; ------ nastaven a zobrazen novho bodu
;
;         mov       al,ah                    ; AL <- poadovan bod
;         call      EdiSetB                  ; nastaven novho bodu
;         call      EdiDispB                 ; zobrazen bodu
;
;; ------ zobrazen editovan ikony
;
;         push      bx
;         push      dx
;         push      es
;
;         mov       bx,ds:[EdiIHAkt]         ; aktuln ikona v historii
;         mov       dh,bl                    ; aktuln ikona v historii
;         shl       dh,1
;         shl       dh,1                     ; * 4
;         add       dh,2
;         mov       dl,1+32*2+2
;         shl       bx,1
;         mov       es,ds:[EdiIHist+bx]      ; adresa aktivn ikony
;         call      DispIcon                 ; zobrazen ikony
;
;         pop       es
;         pop       dx
;         pop       bx
;
;; ------ nvrat registr
;
;         clc
;EditBod8:pop       ax
;         ret
;
;EditBod  ENDP

; -----------------------------------------------------------------------------
;        nastaven bodu DX na aktuln barvu (-> AL=pouit barva, CY=chyba)
; -----------------------------------------------------------------------------

EdiSetA  PROC      NEAR

         mov       al,ds:[ColLeft]          ; barva pro lev tlatko
         test      byte ptr ds:[MouseK],bit1 ; je prav tlatko ?
         jz        EdiSetB                  ; nen prav tlatko, je jen lev
         test      byte ptr ds:[MouseK],bit0 ; je lev tlatko ?
         jz        EdiSetA2                 ; nen lev tlatko, je jen prav
         mov       al,dl                    ; pozice bodu
         xor       al,dh                    ; test lichosti bodu
         test      al,bit0                  ; je lich bod ?
         mov       al,ds:[ColLeft]          ; barva pro sud bod
         jz        EdiSetB                  ; je sud bod
EdiSetA2:mov       al,ds:[ColRight]         ; jinak lich bod
         jmp       short EdiSetB

EdiSetA  ENDP

; -----------------------------------------------------------------------------
;        nastaven bodu se souadnic DX na AL (-1=pozad) -> CY=mimo rozsah
; -----------------------------------------------------------------------------

EdiSetB  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      ds
         push      es

; ------ kontrola peteen souadnic

         cmp       dl,32                    ; peteen pozice ?
         jae       EdiSetB1                 ; je peteen pozice
         cmp       dh,32                    ; peteen dku ?
EdiSetB1:cmc
         jc        EdiSetB3                 ; je peteen dku

; ------ vpoet bitov masky -> CH

         mov       cl,dl                    ; CL <- pozice na dku
         and       cl,bit0+bit1+bit2        ; bitov pozice v bajtu
         mov       ch,bit7
         shr       ch,cl                    ; CH <- maska bodu

; ------ vpoet adresy bajtu -> DS:SI

         shr       dl,1
         shr       dl,1
         shr       dl,1                     ; DL = slo bajtu na dku 0...3
         shl       dh,1
         shl       dh,1
         or        dl,dh                    ; DL <- offset bajtu v rovin
         mov       dh,0
         mov       si,dx                    ; SI <- offset bajtu v rovin

         push      ax
         mov       ax,ds:[ICONic]           ; ikona pozad
         call      AdrICO                   ; adresa ikony -> ES

         push      es

         mov       ax,ds:[EditIcoC]         ; AX <- slo ikony
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         pop       ds                       ; DS <- adresa ikony

         pop       es

         pop       ax

; ------ vynulovn bodu, nastaven jako pozad

         not       ch
         and       ds:[si],ch               ; rovina 0
         and       ds:[si+128],ch           ; rovina 1
         and       ds:[si+2*128],ch         ; rovina 2
         and       ds:[si+3*128],ch         ; rovina 3

; ------ test, je-li poadovno pozad

         cmp       al,-1                    ; je pozad ?
         jne       EdiSetB4                 ; nen pozad
         and       ds:[si+4*128],ch         ; maska - pozad

         not       ch
         test      es:[si],ch
         jz        EdiSetB2
         or        ds:[si],ch

EdiSetB2:test      es:[si+128],ch
         jz        EdiStB22
         or        ds:[si+128],ch

EdiStB22:test      es:[si+2*128],ch
         jz        EdiStB24
         or        ds:[si+2*128],ch

EdiStB24:test      es:[si+3*128],ch
         jz        EdiSetB3
         or        ds:[si+3*128],ch

EdiSetB3:jmp       short EdiSetB9

; ------ nastaven bit bodu

EdiSetB4:not       ch                       ; maska bodu

         shr       al,1
         jnc       EdiSetB5
         or        ds:[si],ch

EdiSetB5:shr       al,1
         jnc       EdiSetB6
         or        ds:[si+128],ch

EdiSetB6:shr       al,1
         jnc       EdiSetB7
         or        ds:[si+2*128],ch

EdiSetB7:shr       al,1
         jnc       EdiSetB8
         or        ds:[si+3*128],ch

EdiSetB8:or        ds:[si+4*128],ch         ; maska - je platn bit

; ------ nvrat registr

EdiSetB9:pop       es
         pop       ds
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

EdiSetB  ENDP

; -----------------------------------------------------------------------------
;        poskytnut bodu se souadnic DX -> AL (-2/CY=mimo rozsah, -1=pozad)
; -----------------------------------------------------------------------------

EdiGetB  PROC      NEAR

; ------ schova registr

         push      cx
         push      dx
         push      si
         push      es

; ------ kontrola peteen souadnic

         mov       al,-2                    ; nhradn barva pro okol
         cmp       dl,32                    ; peteen pozice ?
         jae       EdiGetB1                 ; je peteen pozice
         cmp       dh,32                    ; peteen dku ?
EdiGetB1:cmc
         jc        EdiGetB9                 ; je peteen dku

; ------ vpoet bitov masky -> CH

         mov       cl,dl                    ; CL <- pozice na dku
         and       cl,bit0+bit1+bit2        ; bitov pozice v bajtu
         mov       ch,bit7
         shr       ch,cl                    ; CH <- maska bodu

; ------ vpoet adresy bajtu -> DS:SI

         shr       dl,1
         shr       dl,1
         shr       dl,1                     ; DL = slo bajtu na dku 0...3
         shl       dh,1
         shl       dh,1
         or        dl,dh                    ; DL <- offset bajtu v rovin
         mov       dh,0
         mov       si,dx                    ; SI <- offset bajtu v rovin

         push      ax
         mov       ax,ds:[EditIcoC]         ; slo ikony
         call      AdrICO                   ; adresa ikony -> ES
         pop       ax

; ------ test pozad

         mov       al,-1
         test      byte ptr es:[si+4*128],ch ; je pozad ?
         jz        EdiGetB9                 ; je pozad

; ------ naten barevnch rovin

         mov       al,0                     ; inicializace stadae
         test      byte ptr es:[si],ch      ; je bit v rovin 0 ?
         jz        EdiGetB2                 ; nen bit v rovin 0
         inc       ax                       ; nastaven bitu roviny 0

EdiGetB2:test      byte ptr es:[si+128],ch  ; je bit v rovin 1 ?
         jz        EdiGetB3                 ; nen bit v rovin 1
         or        al,bit1                  ; nastaven bitu 1

EdiGetB3:test      byte ptr es:[si+2*128],ch ; je bit v rovin 2 ?
         jz        EdiGetB4                 ; nen bit v rovin 2
         or        al,bit2                  ; nastaven bitu 2

EdiGetB4:test      byte ptr es:[si+3*128],ch ; je bit v rovin 3 ?
         jz        EdiGetB9                 ; nen bit v rovin 3
         or        al,bit3                  ; nastaven bitu 3

; ------ nvrat registr

EdiGetB9:pop       es
         pop       si
         pop       dx
         pop       cx
         ret

EdiGetB  ENDP

; -----------------------------------------------------------------------------
;        zobrazen bodu se souadnic DX na AL (-1=pozad) -> CY=mimo rozsah
; -----------------------------------------------------------------------------

EdiDispB PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi

         push      ax
         push      bx
         push      cx
         push      dx
         push      di
         push      es

; ------ kontrola peteen souadnic

         cmp       dl,32                    ; peteen pozice ?
         jae       EdiDisB1                 ; je peteen pozice
         cmp       dh,32                    ; peteen dku ?
EdiDisB1:
         jb        EdiDsB12
         stc
         jmp       EdiDisB9                 ; je peteen dku

; ------ pprava adresy ve videopamti -> ES:DI

EdiDsB12:xchg      ax,bx                    ; BL <- poadovan barva
         mov       al,14                    ; poet linek na bod
         mul       dh                       ; pepoet dku na linku
         mov       dh,0
         shl       dl,1                     ; pepoet pozice na bajty
         mov       di,dx                    ; DI <- bajtov pozice na dku
         mov       dx,80                    ; poet bajt na dek
         mul       dx                       ; pepoet linky na offset
         add       di,ax                    ; DI <- adresa bajtu
         add       di,8*80 + 1              ; korekce potku
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         cli
         cld

; ------ nastaven zpisu do vech rovin

         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,1111b                 ; vechny zpisov roviny
         out       dx,al                    ; volba zpisov roviny

; ------ nastaven registr barvy a masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,0
         out       dx,al                    ; volba registru 0
         inc       dx
         out       dx,al                    ; registr 0 nastaven na ernou barvu
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         inc       dx

; ------ zpis pozad

         mov       cx,13                    ; poet linek k zpisu - 1

         cmp       bl,-1                    ; je pozad ?
         jne       EdiDisB3                 ; nen pozad

         mov       al,NOT CPOZADI           ; barva pro pozad
         out       dx,al                    ; nastaven barvy pro pozad

         mov       bx,4444h
EdiDisB2:mov       ax,bx
         and       ah,not bit0
         stosw                              ; uloen vzorku
         add       di,80-2                  ; adresa dal linky
         rol       bx,1
         loop      EdiDisB2                 ; dal linka
         jmp       short EdiDisB7

; ------ zpis ern barvy

EdiDisB3:cmp       bl,0                     ; je ern barva ?
         jne       EdiDisB5                 ; nen ern barva

         mov       al,NOT 7                 ; barva pro rmeek ern
         out       dx,al                    ; nastaven barvy pro ernou

         mov       ax,100h                  ; zapisovan hodnota
EdiDisB4:stosw                              ; uloen vzorku
         add       di,80-2                  ; adresa dal linky
         loop      EdiDisB4                 ; dal linka
         mov       ax,-1                    ; spodn linka
         jmp       short EdiDisB8

; ------ zpis bاn barvy

EdiDisB5:mov       al,bl                    ; poadovan barva
         not       al
         out       dx,al                    ; nastaven poadovan barvy

         mov       ax,0feffh                ; zapisovan vzorek
EdiDisB6:stosw                              ; uloen vzorku
         add       di,80-2                  ; adresa dal linky
         loop      EdiDisB6                 ; dal linka

; ------ zpis spodn linky

EdiDisB7:xor       ax,ax                    ; spodn linka
EdiDisB8:stosw                              ; oddlovac ra

; ------ nvrat nastaven barvy podle dat

         mov       al,0
         out       dx,al                    ; vechny roviny podle dat
         clc                                ; pznak operace OK

; ------ nvrat registr

EdiDisB9:pop       es
         pop       di
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

EdiDispB ENDP

; -----------------------------------------------------------------------------
;        zobrazen voleb editoru
; -----------------------------------------------------------------------------

EdiVDis  PROC      NEAR

         call      MouseOff                 ; vypnut kurzoru myi

; ------ pprava ikony aktivnch barev

         mov       ax,ds:[ICOBarv1]         ; ikona zvolen barvy
         call      AdrICO                   ; adresa ikony -> ES
         mov       bl,bit0                  ; maska rovin
         xor       di,di                    ; ukldac adresa
EdiVDs12:mov       si,32*32*4/8             ; tabulka masky
         mov       cx,32                    ; poet linek k nastaven
EdiVDs13:mov       bh,ds:[ColLeft]          ; barva pro lev tlatko
         call      EdiVDMsk                 ; maskovn
         mov       bh,ds:[ColRight]         ; barva pro prav tlatko
         call      EdiVDMsk                 ; maskovn
         loop      EdiVDs13
         shl       bl,1                     ; pprava pro dal rovinu
         cmp       bl,bit4                  ; jsou ji vechny roviny ?
         jne       EdiVDs12                 ; dal rovina

; ------ zobrazen malch ikon (historie)

         mov       si,offset EdiIHist       ; historie ikon
         mov       dx,2*HI + 1+32*2+2       ; pozice k zobrazen ikony
         mov       cx,HistEdiM              ; poet ikon v historii
EdiVDis4:mov       ax,ds:[si]               ; slo ikony
         call      DispIcon                 ; zobrazen editovan ikony
         inc       si
         inc       si
         add       dh,4                     ; ukazatel dku
         loop      EdiVDis4

; ------ zobrazen aktivn funkce

         mov       ch,0
         mov       cl,ds:[FunkceEd]         ; funkce
         mov       dx,28*HI + 1+32*2+2
         mov       ax,ds:[ICOPero]          ; pero
         jcxz      EdiVDis5                 ; je pero
         mov       ax,ds:[ICOCara]
         dec       cx
         jz        EdiVDis5                 ; je ra
         mov       ax,ds:[ICOCtve]
         dec       cx
         jz        EdiVDis5                 ; je tverec
         mov       ax,ds:[ICOKruh]
         dec       cx
         jz        EdiVDis5                 ; je kruh
;         mov       ax,ds:[ICOText]
;         dec       cx
;         jz        EdiVDis5                 ; je text
         mov       ax,ds:[ICOFill]
         dec       cx
         jz        EdiVDis5                 ; je naplnn
         mov       ax,ds:[ICOBlok]
EdiVDis5:call      DispIcon

; ------ zobrazen volby barev

         mov       dx,32*HI + 1+32*2+2
         mov       ax,ds:[ICOBarv1]
         call      DispIcon
         add       dh,4
         mov       ax,ds:[ICOBarv2]
         call      DispIcon
         add       dh,4
         mov       ax,ds:[ICOBarv3]
         call      DispIcon
         add       dh,4
         mov       ax,ds:[ICOBarv4]
         call      DispIcon
         add       dh,4
         mov       ax,ds:[ICOBarv5]
         call      DispIcon
         add       dh,4
         mov       ax,ds:[ICOBarv6]
         call      DispIcon

         ret

EdiVDis  ENDP

; ------ maska se slovem AX

EdiVDMsk:xor       ax,ax                    ; barva nen nastavena
         test      bh,bl                    ; je bit nastaven ?
         jz        EdiVDMs2                 ; bit nen nastaven
         dec       ax                       ; AX <- -1 bit nastaven

EdiVDMs2:cmp       bh,-1                    ; je pozad ?
         jne       EdiVDMs5                 ; nen pozad
         mov       ax,4444h                 ; barva pro pozad
         test      di,bit2                  ; je lich linka ?
         jz        EdiVDMs3                 ; nen lich linka
         rol       ax,1                     ; vzorek pro lichou linku
EdiVDMs3:test      di,bit3
         jz        EdiVDMs4
         rol       ax,1
         rol       ax,1
EdiVDMs4:cmp       bl,bit0
         je        EdiVDMs5
         cmp       bl,bit1
         je        EdiVDMs5
         xor       ax,ax

EdiVDMs5:mov       dx,es:[si]               ; maska
         and       es:[di],dx               ; zruen starch dat
         not       dx                       ; inverze
         and       dx,ax                    ; nov data
         or        es:[di],dx               ; uloen novch dat

         inc       di
         inc       di                       ; zven ukazatele v datech

         inc       si
         inc       si                       ; zven ukazatele v masce
         ret

; -----------------------------------------------------------------------------
;        volba ikony -> AX=slo ikony, CY=peruen
; -----------------------------------------------------------------------------

VolIcon  PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      es
         mov       bl,ds:[Rezim]            ; aktuln reim
         push      bx
         mov       byte ptr ds:[Rezim],3    ; reim volby ikon

; ------ zobrazen rmu kolem hrac plochy

         call      DispRam                  ; zobrazen rmu kolem hrac plochy

; ------ zobrazen rmu kolem menu

         call      MenuRam                  ; zobrazen rmu kolem menu

; ------ zobrazen menu

         call      DispMenu                 ; zobrazen menu

; ------ zobrazen ikon

         mov       dh,1                     ; ukazatel sla dku
         xor       ax,ax                    ; ukazatel sla ikony
VolIcon2:mov       dl,1                     ; ukazatel pozice

VolIcon3:push      ax
         cmp       ax,ds:[DataICON]         ; je platn slo ikony ?
         jb        VolIco32                 ; je platn slo ikony
         mov       ax,ds:[ICONic]           ; przdn plocha
VolIco32:call      DispIcon                 ; zobrazen ikony
         pop       ax

         inc       ax                       ; zven sla ikony
         add       dl,4                     ; zven ukazatele pozice
         cmp       dl,1+4*PSIRKA            ; jsou vechny pozice ?
         jb        VolIcon3                 ; dal pozice
         add       dh,4                     ; zven ukazatele dku
         cmp       dh,1+4*PVYSKA            ; jsou vechny dky ?
         jb        VolIcon2                 ; dal dek

; ------ zobrazen jmna ikony (BX=souadnice ikony !!!)

VolIcon4:mov       bx,ds:[VolILast]         ; ukazatel dku a pozice
         call      VolKZap                  ; zapnut kurzoru
         call      TextRam                  ; zobrazen rmu kolem textu

         mov       word ptr ds:[ProgStr]," "*HI + 1 ; przdn etzec

         mov       al,PSIRKA                ; poet pozic na dek
         mul       bh                       ; pepoet dku na pozice
         add       al,bl                    ; piten pozice
         adc       ah,0
         cmp       ax,ds:[DataICON]         ; je to platn slo ikony ?
         jae       VolIco48                 ; nen to platn slo ikony
         call      GetIName                 ; naten jmna ikony AX

VolIco48:xor       ax,ax                    ; barva textu = ern
         mov       cx,-1                    ; doba
         mov       si,offset ProgStr        ; buffer s textem
         call      DispHlas                 ; zobrazen jmna ikony

; ------ obsluha blikn kurzoru

VolIcon5:push      es
         xor       ax,ax
         mov       es,ax                    ; ES <- 0
         test      byte ptr es:[46ch],4     ; m bt kurzor zapnut ?
         pop       es
         jnz       VolIco51                 ; zapnut kurzoru
         call      VolKVyp                  ; vypnut kurzoru volby
         jmp       short VolIco52

VolIco51:call      VolKZap                  ; zapnut kurzoru volby

; ------ ekn na stisk klvesy nebo stisk myi

VolIco52:call      MouseOn                  ; zapnut kurzoru myi
         call      InpChar                  ; vstup znaku z klvesnice
         jnc       VolIcon7                 ; je klvesa
         call      GetMouse                 ; naten stavu myi
         jc        VolIcon5                 ; nen stisk myi

; ------ obsluha stisku myi

         cmp       dl,PSIRKA                ; je pozice OK ?
         jae       VolIcon6                 ; pekroen pozice
         cmp       dh,PVYSKA                ; je dek OK ?
         jae       VolIcon5                 ; pekroen dku

         mov       bx,dx                    ; BX <- nastaven dku a pozice
         jmp       VolIc772                 ; zvolen poloky

VolIcon6:jmp       VolIcon8                 ; peruen operace

; ------ vstup znaku z klvesnice

VolIcon7:call      VolKVyp                  ; vypnut kurzoru

; ------ kurzor nahoru

         cmp       ah,48h                   ; nahoru
         je        VolIco71                 ; je nahoru

; ------ Home

         cmp       ah,47h                   ; HOME
         je        VolIco72                 ; je Home

; ------ kurzor vlevo

         cmp       ah,4bh                   ; vlevo
         jne       VolIco73
         dec       bl                       ; snen pozice na dku
         jns       VolIco79                 ; pozice je OK
         mov       bl,PSIRKA-1              ; posledn poloka na dku
VolIco71:dec       bh                       ; snen dku
         jns       VolIco79                 ; dek je OK
VolIco72:xor       bx,bx                    ; ukazatel na potek
         jmp       short VolIco79

; ------ END - posledn poloka

VolIco73:cmp       ah,4fh                   ; End
         je        VolIco76                 ; je End

; ------ dol

         cmp       ah,50h                   ; dol
         je        VolIco74                 ; je dol

; ------ vpravo

         cmp       ah,4dh                   ; vpravo
         jne       VolIco77                 ; nen vpravo
         inc       bl                       ; zven pozice na dku
         cmp       bl,PSIRKA
         jb        VolIco75                 ; je to OK
         mov       bl,0                     ; potek dku
VolIco74:inc       bh                       ; zven ukazatele dku

; ------ kontrola peteen

VolIco75:mov       al,PSIRKA                ; poet poloek na dek
         mul       bh                       ; pepoet dku na poloky
         add       al,bl                    ; piten pozcie
         adc       ah,0
         cmp       ax,ds:[DataICON]         ; peteen potu poloek ?
         jae       VolIco76                 ; je peteen potu poloek
         cmp       ax,PSIRKA*PVYSKA         ; peteen obrazovky ?
         jb        VolIco79                 ; ve OK

; ------ nastaven maximln poloky

VolIco76:mov       ax,ds:[DataICON]         ; poet poloek
         cmp       ax,PSIRKA*PVYSKA         ; je vce strnek ?
         jbe       VolIc762                 ; nen vce strnek
         mov       ax,PSIRKA*PVYSKA         ; omezen
VolIc762:dec       ax                       ; posledn poloka
         mov       cl,PSIRKA                ; poet poloek na dek
         div       cl                       ; pepoet na dek a pozici
         xchg      al,ah                    ; oprava poad poloek
         xchg      ax,bx                    ; BX <- maximln poloka
         jmp       short VolIco79

; ------ proveden volby ENTER

VolIco77:cmp       al,13                    ; je ENTER ?
         jne       VolIco78                 ; nen ENTER

VolIc772:mov       ds:[VolILast],bx         ; nov pozice kurzoru
         mov       al,PSIRKA                ; poet pozic na dek
         mul       bh                       ; pepoet dku na pozice
         add       al,bl                    ; piten pozice
         adc       ah,0
         cmp       ax,ds:[DataICON]         ; je to platn slo ikony ?
         jae       VolIco76                 ; nen to platn slo ikony
         clc                                ; pznak operace OK
         jmp       short VolIcon9           ; AX = slo zvolen ikony

; ------ peruen volby ESC nebo Ctrl-Break

VolIco78:cmp       al,27                    ; ESC
         je        VolIcon8                 ; peruen ESC
         or        ax,ax                    ; Ctrl-Break
         jz        VolIcon8                 ; peruen Ctrl-Break
VolIco79:mov       ds:[VolILast],bx         ; nov pozice kurzoru
         jmp       VolIcon4                 ; nov zobrazen kurzoru
VolIcon8:stc                                ; pznak peruen operace

; ------ nvrat registr

VolIcon9:pop       bx
         mov       ds:[Rezim],bl            ; nvrat reimu
         pop       es
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

VolIcon  ENDP

; -----------------------------------------------------------------------------
;        naten jmna ikony (+.ICO) AX do bufferu PROGSTR -> CY=nenalezeno
; -----------------------------------------------------------------------------

GetIName PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      si
         push      di
         push      ds
         push      es

         mov       word ptr ds:[ProgStr],0  ; pednastaven - nen jmno

; ------ nalezen jmna ikony

         mov       cx,ds:[DataICON]         ; poet ikon
         push      ds
         mov       ds,ds:[DataSegm]         ; segment symbol ikon
         pop       es
         xor       si,si                    ; zatek jmen
         cld
GetINam2:mov       bl,ds:[si]               ; dlka jmna ikony
         mov       bh,0
         cmp       ax,ds:[si+bx+1]          ; souhlas slo ikony ?
         je        GetINam4                 ; slo ikony souhlas
         add       si,bx                    ; peskoen jmna ikony
         add       si,3                     ; peskoen dlky a adresy
         loop      GetINam2
         stc                                ; pznak chyby
         jmp       short GetINam8

; ------ penesen jmna ikony do bufferu

GetINam4:mov       di,offset ProgStr        ; buffer pro text
         mov       cx,bx                    ; CX <- dlka jmna ikony
         movsb                              ; penesen dlky
         rep       movsb                    ; penesen jmna

; ------ penesen ppadn ppony ".ICO"

         mov       ax,"I."
         stosw
         mov       ax,"OC"
         stosw
         mov       al,0
         stosb
         clc                                ; pznak operace OK

; ------ nvrat registr

GetINam8:pop       es
         pop       ds
         pop       di
         pop       si
         pop       cx
         pop       bx
         pop       ax
         ret

GetIName ENDP

; -----------------------------------------------------------------------------
;        zapnut kurzoru volby (souadnice BX)
; -----------------------------------------------------------------------------

VolKZap  PROC      NEAR

         test      byte ptr ds:[Param],bit5 ; je kurzor zapnut ?
         jz        VolKurz                  ; kurzor nen zapnut - zapnut
         ret

VolKZap  ENDP

; -----------------------------------------------------------------------------
;        vypnut kurzoru volby (souadnice BX)
; -----------------------------------------------------------------------------

VolKVyp  PROC      NEAR

         test      byte ptr ds:[Param],bit5 ; je kurzor zapnut ?
         jnz       VolKurz                  ; kurzor je zapnut - vypnut
         ret

VolKVyp  ENDP

; -----------------------------------------------------------------------------
;        inverze kurzoru volby (souadnice BX)
; -----------------------------------------------------------------------------

VolKurz  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi

         xor       byte ptr ds:[Param],bit5 ; zmna pznaku kurzoru
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ vpoet adresy ve videopamti -> DI

         shl       bh,1
         shl       bh,1                     ; pepoet na dek
         inc       bh                       ; piten potku
         mov       al,8                     ; poet linek na dek
         mul       bh                       ; pepoet dku na linku
         mul       word ptr ds:[DispSirB]   ; pepoet na adresu ve videopamti
         shl       bl,1
         shl       bl,1                     ; pepoet na bajtovou pozici
         inc       bx                       ; piten potku
         mov       bh,0
         add       ax,bx                    ; piten pozice
         xchg      ax,di                    ; DI <- adresa ve videopamti

; ------ pprava k operaci

         cld
         cli                                ; zkaz peruen bhem operace
         xor       cx,cx                    ; CX <- 0
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       bx,1001h                 ; maska barevn roviny

; ------ nastaven zpisov roviny

         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,0fh                   ; zpisov rovina - vechno
         out       dx,al                    ; volba zpisov roviny

; ------ nastaven zpisovho mdu XOR

         mov       dx,3ceh
         mov       al,3
         out       dx,al
         inc       dx
         mov       al,18h
         out       dx,al                    ; zpisov md XOR

; ------ zpis horn linky

         cld
         call      DispKrV
         call      DispKrV

; ------ zpis okraj

         mov       cx,28
VolKurz4:mov       al,0c0h
         xchg      al,es:[di]
         mov       al,3
         xchg      al,es:[di+3]
         add       di,80
         loop      VolKurz4

; ------ zpis spodn linky

         call      DispKrV
         call      DispKrV

; ------ nvrat bاnho zpisovho mdu

         mov       al,0
         out       dx,al                    ; nastaven bاnho mdu

; ------ nvrat registr

         sti                                ; peruen opt povoleno
         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

VolKurz  ENDP

; ------ zpis linky EGA a VGA

DispKrV  PROC      NEAR

DispKrV2:mov       al,-1
         xchg      al,es:[di]
         inc       di

         mov       al,-1
         xchg      al,es:[di]
         inc       di

         mov       al,-1
         xchg      al,es:[di]
         inc       di

         mov       al,-1
         xchg      al,es:[di]
         inc       di

         add       di,80-4
         ret

DispKrV  ENDP

; -----------------------------------------------------------------------------
;        naten vech ikon -> CY=chyba pamti
; -----------------------------------------------------------------------------

ReadICO  PROC      NEAR

; ------ nastaven adresy DTA

         mov       dx,offset DTA            ; buffer DTA
         mov       ah,1ah
         int       21h                      ; nastaven adresy DTA

; ------ nalezen souboru ikony

         mov       dx,offset ICOAll         ; specifikace - vechny ICO
         mov       ah,4eh
         xor       cx,cx                    ; atributy
ReadICO1:int       21h                      ; nalezen souboru
         jnc       ReadICO2                 ; nalezen dal soubor
         clc                                ; pznak operace OK
ReadIC19:ret

; ------ oteven souboru ikony

ReadICO2:mov       word ptr ds:[DTA+1eh-4],"CI"
         mov       word ptr ds:[DTA+1eh-2],"\O"
         mov       dx,offset DTA+1eh - 4    ; jmno souboru
         mov       ax,3d00h
         int       21h                      ; oteven souboru
         jnc       ReadIC22
         jmp       ReadICO8                 ; njak chyba

ReadIC22:xchg      ax,bx                    ; BX <- identifiktor souboru

; ------ naten souboru do pamti

         mov       dx,offset SoubICO        ; buffer k naten ikony
         mov       cx,offset(SoubICO2-SoubICO) ; dlka souboru
         mov       ah,3fh
         int       21h                      ; naten souboru

; ------ uzaven souboru

         mov       ah,3eh
         int       21h                      ; uzaven souboru

; ------ korekce naten ikony

         call      KorIcon                  ; korekce naten ikony

; ------ adresa bufferu

         mov       ax,ds:[DataICO]          ; adresa potku ikon
         sub       ax,ICOSize/16            ; nov pote ikon
         cmp       ax,ds:[DataProg]         ; je peteen ?
         jb        ReadIC19                 ; peteen pamti
         mov       ds:[DataICO],ax          ; nov potek
         mov       es,ax                    ; ES <- adresa bufferu

; ------ vymazn bufferu

         xor       di,di
         mov       cx,ICOSize/2             ; velikost bufferu
         xor       ax,ax
         rep       stosw                    ; vymazn bufferu

; ------ konverze obrzku ikony

         cld
         xor       di,di                    ; ukldac adresa
         mov       si,offset IcoBuff+31*32/2 ; buffer dat ikony - posledn linka
         mov       bx,32                    ; poet linek ke konverzi
         mov       ah,80h                   ; maska pro nastaven bitu
ReadICO3:mov       cx,32/2                  ; poet bajt na lince
ReadICO4:lodsb                              ; naten jednoho bajtu

         shl       al,1                     ; test jednoho bitu
         jnc       ReadIC42                 ; nen nastaven
         or        byte ptr es:[di+3*4*32],ah
ReadIC42:shl       al,1
         jnc       ReadIC43
         or        byte ptr es:[di+2*4*32],ah
ReadIC43:shl       al,1
         jnc       ReadIC44
         or        byte ptr es:[di+4*32],ah
ReadIC44:shl       al,1
         jnc       ReadIC45
         or        byte ptr es:[di],ah      ; nastaven bitu
ReadIC45:ror       ah,1                     ; posun ukldac masky

         shl       al,1                     ; test jednoho bitu
         jnc       ReadIC46                 ; nen nastaven
         or        byte ptr es:[di+3*4*32],ah
ReadIC46:shl       al,1
         jnc       ReadIC47
         or        byte ptr es:[di+2*4*32],ah
ReadIC47:shl       al,1
         jnc       ReadIC48
         or        byte ptr es:[di+4*32],ah
ReadIC48:shl       al,1
         jnc       ReadIC49
         or        byte ptr es:[di],ah      ; nastaven bitu
ReadIC49:ror       ah,1
         cmp       ah,80h
         jne       ReadICO5
         inc       di                       ; zven ukldac adresy

ReadICO5:loop      ReadICO4                 ; dal bajt na lince
         sub       si,2*(32/2)              ; pedel linka

         dec       bx                       ; ta linek k uloen
         jnz       ReadICO3                 ; dal linka

; ------ penesen masky ikony

         add       di,3*4*32
         mov       si,offset IcoMask+31*32/8 ; maska ikony
         mov       cx,32                    ; poet linek
ReadIC52:lodsw
         not       ax
         stosw
         lodsw
         not       ax
         stosw
         sub       si,2*(32/8)
         loop      ReadIC52

; ------ uloen jmna ikony

         cld
         mov       es,ds:[DataSegm]         ; adresa zatku bufferu
         mov       si,offset DTA+1eh        ; jmno souboru
         mov       di,ds:[DataICOE]         ; offset konce symbol ikon
         mov       bx,di                    ; BX <- dlka jmna ikony
         mov       al,0                     ; dlka jmna ikony
         stosb                              ; dlka jmna ikony

         lodsb                              ; naten prvnho znaku
         jmp       short ReadIC66           ; kontrola, zda to je psmeno

ReadICO6:lodsb
         cmp       al,0                     ; je konec jmna ?
         je        ReadIC69                 ; konec jmna
         cmp       al,"."
         je        ReadIC69                 ; konec jmna
         cmp       al,"_"                   ; je to podtrtko ?
         je        ReadIC68                 ; podtrtko je povoleno
         cmp       al,"0"                   ; je to slice ?
         jb        ReadIC66                 ; nen to slice
         cmp       al,"9"                   ; je to slice ?
         jbe       ReadIC68                 ; je to slice

ReadIC66:call      UpCase                   ; konverze na velk psmeno
         cmp       al,"A"                   ; je to psmeno ?
         jb        ReadICO9                 ; nen to psmeno - chyba
         cmp       al,"Z"                   ; je to psmeno ?
         ja        ReadICO9                 ; nen to psmeno - chyba
ReadIC68:cmp       byte ptr es:[bx],8       ; je ji maximln dlka jmna ?
         jae       ReadICO6                 ; je ji maximln dlka jmna
         stosb                              ; uloen psmene
         inc       byte ptr es:[bx]         ; ta dlky jmna ikony
         jmp       short ReadICO6           ; dal znak

ReadIC69:mov       ax,ds:[DataICON]         ; star poet ikon
         stosw                              ; uloen sla ikony

; ------ nov adresa konce symbol

         inc       word ptr ds:[DataICON]   ; zven tae ikon

         mov       ds:[DataICOE],di         ; nov adresa konce symbol
         add       di,0fh                   ; zaokrouhlen nahoru
         mov       cl,4
         shr       di,cl                    ; pevod na odstavce
         add       di,ds:[DataSegm]
         mov       ds:[DataProg],di         ; nov adresa programu
         mov       ax,ds:[DataICO]          ; adresa ikony
         cmp       ax,di                    ; je peteen pamti ?
         jae       ReadICO8                 ; je to v podku
         ret                                ; CY=chyba peteen pamti

; ------ chybn jmno ikony

ReadICO9:push      ds
         pop       es                       ; ES <- datov segment
         mov       di,offset ICOErr2        ; buffer jmna ikony
         cld
         mov       cx,13                    ; maximln dlka jmna
         mov       si,offset DTA+1eh        ; jmno souboru
ReadIC92:lodsb
         stosb                              ; uloen znaku
         cmp       al,0
         loopne    ReadIC92                 ; dal
         dec       di                       ; nvrat na koncovou 0
         mov       al," "
         rep       stosb                    ; vymazn zbytku bufferu

         add       word ptr ds:[DataICO],ICOSize/16 ; nvrat adresy ikon
         mov       bp,offset ICOErr
         call      DispErr                  ; zobrazen chyby

; ------ dal soubor ikony

ReadICO8:mov       ah,4fh                   ; bude dal soubor
         jmp       ReadICO1                 ; dal soubor

ReadICO  ENDP

; -----------------------------------------------------------------------------
;        inicializace implicitnch ikon
; -----------------------------------------------------------------------------

IniICOD  PROC      NEAR

; ------ nalezen implicitn ikony

         mov       si,offset ICODef         ; implicitn ikony
IniICOD2:call      SrcICO                   ; nalezen ikony
         jnc       IniICOD6                 ; ikona nalezena OK

; ------ chyba - ikona nenalezena

         push      ds
         pop       es
         mov       di,offset ICODErr2
         cld

         push      si
         mov       cl,ds:[si]               ; dlka jmna ikony
         inc       si
         mov       ch,0
         rep       movsb                    ; penesen jmna ikony
         pop       si

         mov       ax,"I."
         stosw
         mov       ax,"OC"
         stosw
         mov       cl,13-4
         sub       cl,ds:[si]               ; zbytek bufferu
         mov       al," "
         rep       stosb                    ; vymazn zbytku bufferu

         mov       bp,offset ICODErr
         call      DispErr                  ; zobrazen chyby

; ------ uloen sla ikony

IniICOD6:cld
         push      ax
         lodsb                              ; dlka jmna ikony
         mov       ah,0
         add       si,ax                    ; peskoen jmna
         pop       ax
         mov       ds:[si],ax               ; slo ikony

; ------ dal ikona

         inc       si
         inc       si                       ; peskoen adresy ikony
         cmp       si,offset ICODef0        ; je konec tabulky ?
         jb        IniICOD2                 ; bude dal ikona
         ret

IniICOD  ENDP

; -----------------------------------------------------------------------------
;        vpoet adresy ikony AX -> ES (CY=chybn jmno ikony, ES nezmnno
; -----------------------------------------------------------------------------

AdrICO   PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ kontrola sla ikony

         mov       dx,ds:[DataICON]         ; poet ikon celkem
         cmp       ax,dx                    ; kontrola sla ikony
         cmc                                ; CY = chybn slo
         jc        AdrICO9                  ; neplatn slo ikony

; ------ vpoet adresy ikony

         dec       dx                       ; DX <- slo posledn ikony
         sub       dx,ax                    ; DX <- doplkov slo ikony
         mov       ax,ICOSize/16            ; velikost ikony v odstavcch
         mul       dx                       ; vpoet offsetu ikony
         add       ax,ds:[DataICO]          ; adresa ikony
         mov       es,ax                    ; ES <- adresa ikony

; ------ nvrat registr

AdrICO9: pop       dx
         pop       ax
         ret

AdrICO   ENDP

; -----------------------------------------------------------------------------
;        nalezen ikony DS:SI -> AX (CY=nenalezeno, AX nezmnno)
; -----------------------------------------------------------------------------

SrcICO   PROC      NEAR

; ------ schova registr

         push      cx
         push      dx
         push      di

; ------ pprava k prohledn tabulky

         cld
         xor       di,di                    ; ukazatel v tabulce ikon
         mov       dx,ds:[DataICON]         ; DX <- poet ikon
         mov       es,ds:[DataSegm]         ; segment symbol ikon
         xor       cx,cx                    ; CX <- 0

; ------ test, zda je dal ikona

SrcICO2: or        dx,dx                    ; je dal ikona ?
         stc                                ; pznak chyby
         jz        SrcICO9                  ; nen dal ikona

; ------ porovnn jmna ikony

         mov       cl,es:[di]               ; dlka jmna jedn ikony
         inc       cx                       ; vetn bajtu dlky
         push      cx
         push      si
         push      di
         repe      cmpsb
         pop       di
         pop       si
         pop       cx
         je        SrcICO4                  ; ikona nalezena OK

; ------ dal ikona

         add       di,cx                    ; piten dlky jmna ikony + 1
         inc       di
         inc       di                       ; peskoen adresy ikony
         dec       dx                       ; ta ikon
         jmp       short SrcICO2            ; dal ikona

; ------ slo ikony -> AX

SrcICO4: add       di,cx                    ; piten dlky jmna ikony + 1
         mov       ax,es:[di]               ; slo ikony
         clc                                ; pznak operace OK

; ------ nvrat registr

SrcICO9: pop       di
         pop       dx
         pop       cx
         ret

SrcICO   ENDP

; -----------------------------------------------------------------------------
;        inicializace pozad ikon
; -----------------------------------------------------------------------------

IniPozad PROC      NEAR

         push      ds

         mov       ax,ds:[ICONic]           ; ikona pozad
         call      AdrICO                   ; adresa ikony -> ES

         push      es

         mov       es,ds:[DataICO]          ; zatek ikon
         mov       dx,ds:[DataICON]         ; poet ikon

         pop       ds                       ; adresa pozad plochy

IniPoza2:xor       si,si                    ; ukazatel v datech
         mov       bp,4                     ; poet barevnch rovin
IniPoza3:mov       cx,32*32/8               ; poet bajt v jedn rovin
         mov       bx,32*32*4/8             ; ukazatel v masce
IniPoza4:mov       al,es:[bx]               ; bajt masky
         and       byte ptr es:[si],al      ; zruen maskovanch dat
         not       al
         and       al,ds:[si]               ; nov data
         or        es:[si],al               ; nastaven novch dat
         inc       si                       ; zven ukazatele dat
         inc       bx                       ; zven ukazatele masky
         loop      IniPoza4                 ; dal bajt dat

         dec       bp                       ; ta rovin
         jnz       IniPoza3                 ; dal rovina

         mov       ax,es
         add       ax,ICOSize/16            ; dal ikona
         mov       es,ax
         dec       dx                       ; ta ikon
         jnz       IniPoza2                 ; dal ikona

         pop       ds
         ret

IniPozad ENDP

; -----------------------------------------------------------------------------
;        korekce naten ikony
; -----------------------------------------------------------------------------

KorIcon  PROC      NEAR

; ------ sestaven korekn tabulky barev

         mov       bx,offset PalKonv        ; konverzn tabulka barev
         mov       si,offset PalIco         ; tabulka palet
KorIcon1:mov       di,offset PalVGA         ; tabulka normovanch palet VGA
         mov       bp,-1                    ; BP=nejmen nalezen vzdlenost
         xor       cx,cx                    ; ukazatel sla barvy

KorIcon2:mov       al,ds:[si]               ; skuten modr
         shr       al,1
         inc       ax                       ; zaokrouhlen nahoru
         shr       al,1                     ; pevod na modul 64
         sub       al,ds:[di]               ; vzdlenost od standardn modr
         inc       di
         imul      al                       ; absolutn hodnota
         xchg      ax,dx                    ; DX <- schova vzdlenosti

         mov       al,ds:[si+1]             ; skuten zelen
         shr       al,1
         inc       ax                       ; zaokrouhlen nahoru
         shr       al,1                     ; pevod na modul 64
         sub       al,ds:[di]               ; vzdlenost od standardn zelen
         inc       di
         imul      al                       ; absolutn hodnota
         add       dx,ax                    ; DX <- pidn ke stadai

         mov       al,ds:[si+2]             ; skuten erven
         shr       al,1
         inc       ax                       ; zaokrouhlen nahoru
         shr       al,1                     ; pevod na modul 64
         sub       al,ds:[di]               ; vzdlenost od standardn erven
         inc       di
         imul      al                       ; absolutn hodnota
         add       ax,dx                    ; AX <- pidn ke stadai (v AX !)

         cmp       ax,bp                    ; je men vzdlenost ?
         jae       KorIco22                 ; nen men vzdlenost
         xchg      ax,bp                    ; BP <- schova vzdlenosti
         mov       ds:[bx],cl               ; nalezen nejbli barva

KorIco22:inc       cx                       ; zven ukazatele sla barvy
         cmp       cl,16                    ; jsou ji vechny barvy ?
         jb        KorIcon2                 ; dal barva

         add       si,4                     ; dal paleta
         inc       bx                       ; zven ukazatele tabulky barev
         cmp       bx,offset PalKonv + 16   ; je konec tabulky ?
         jb        KorIcon1                 ; nen jet konec tabulky

; ------ korekce barev

         mov       bx,offset PalKonv        ; konverzn tabulka barev
         mov       si,offset IcoBuff        ; buffer dat ikony
         mov       dx,32*32/2               ; poet bajt ke korekci
         mov       cl,4                     ; poet rotac
         cld
KorIcon3:lodsb                              ; naten bajtu
         mov       ah,al                    ; AH <- schova bajtu
         and       ax,0f00fh                ; AH=prvn bajt, AL=druh bajt
         xlat                               ; konverze bajtu v AL
         xchg      al,ah
         shr       al,cl                    ; rotace dol
         xlat                               ; konverze bajtu z AH
         shl       al,cl                    ; rotace zpt nahoru
         or        al,ah                    ; slouen bod zpt
         mov       ds:[si-1],al             ; navrcen bajtu zpt
         dec       dx
         jnz       KorIcon3                 ; dal bajt
         ret

KorIcon  ENDP

; *****************************************************************************
;
;                       Obsluha displeje a zobrazen
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        vymazn pole
; -----------------------------------------------------------------------------

Vymaz    PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      di
         push      es

; ------ vymazn hracho pole

         mov       di,offset Pole           ; hrac pole
         mov       ax,ds:[ICONic]           ; slo ikony plochy
         mov       cx,PSIRKA*PVYSKA         ; velikost plochy
         push      ds
         pop       es
         cld
         rep       stosw                    ; vymazn plochy

; ------ nvrat registr

         pop       es
         pop       di
         pop       cx
         pop       ax
         ret

Vymaz    ENDP

; -----------------------------------------------------------------------------
;        inicializan vymazn plochy
; -----------------------------------------------------------------------------

IniVymaz PROC      NEAR

; ------ zobrazen rmu kolem hrac plochy

         call      DispRam                  ; zobrazen rmu kolem hrac plochy

; ------ zobrazen rmu kolem menu

         call      MenuRam                  ; zobrazen rmu kolem menu

; ------ zobrazen rmu textu (s vymaznm textu)

         call      TextRam                  ; zobrazen rmu kolem textu

; ------ zobrazen plochy

         call      DispPole                 ; zobrazen pole

; ------ zobrazen menu

         call      DispMenu                 ; zobrazen menu
         ret

IniVymaz ENDP

; -----------------------------------------------------------------------------
;        zobrazen menu
; -----------------------------------------------------------------------------

DispMenu PROC      NEAR

         push      ax
         push      bx
         push      dx

         mov       dh,1
         mov       bh,0
DispMen2:mov       dl,1+PSIRKA*4+1+1
         mov       bl,0
DispMen3:mov       ax,ds:[ICOMenu]

         cmp       byte ptr ds:[Rezim],1    ; je provdn programu ?
         jne       DispM301
         jmp       DispMenD                 ; je provdn programu

DispM301:
         cmp       byte ptr ds:[Rezim],3    ; je reim volby ikon
         jne       DispMn30
         jmp       DispMn38

DispMn30:cmp       byte ptr ds:[Rezim],4    ; je reim editace ikon
         je        DispM302
         jmp       DispMn39

DispM302:
         or        bx,bx
         jnz       DispMn31
         mov       ax,ds:[ICOPero]
DispMn31:cmp       bx,100h
         jne       DispMn32
         mov       ax,ds:[ICOCara]
DispMn32:cmp       bx,200h
         jne       DispMn33
         mov       ax,ds:[ICOCtve]
DispMn33:cmp       bx,300h
         jne       DispMn34
         mov       ax,ds:[ICOKruh]
DispMn34:
;         cmp       bx,400h
;         jne       DispM342
;         mov       ax,ds:[ICOText]
DispM342:cmp       bx,400h
         jne       DispMn35
         mov       ax,ds:[ICOFill]
DispMn35:cmp       bx,500h
         jne       DispM352
         mov       ax,ds:[ICOBlok]
DispM352:
;         cmp       bx,600h
;         jne       DispM354
;         mov       ax,ds:[ICOBlokS]
DispM354:cmp       bx,600h
         jne       DispMn36
         mov       ax,ds:[ICOBlokL]
DispMn36:cmp       bx,700h
         jne       DispMn37
         mov       ax,ds:[ICOFlip]
DispMn37:cmp       bx,800h
         jne       DispM371
         mov       ax,ds:[ICORot]
DispM371:cmp       bx,900h
         jne       DispM372
         mov       ax,ds:[ICOXCol]
DispM372:cmp       bx,0a00h
         jne       DispM373
         mov       ax,ds:[ICOUndo]
DispM373:cmp       bx,0b00h
         jne       DispM374
         mov       ax,ds:[ICORedo]
DispM374:

;         cmp       bx,0b00h
;         jne       DispM377
;         mov       ax,ds:[ICOLoad]
;DispM377:

         cmp       bx,0c00h
         jne       DispM378
         mov       ax,ds:[ICOSave]
DispM378:


DispMn38:jmp       short DispMenC

DispMn39:or        bx,bx
         jnz       DispMen4
         mov       ax,ds:[ICOVlevo]
DispMen4:cmp       bx,100h
         jne       DispMen5
         mov       ax,ds:[ICOVzad]
DispMen5:cmp       bx,200h
         jne       DispMen6
         mov       ax,ds:[ICOVprav]
DispMen6:cmp       bx,300h
         jne       DispMen7
         mov       ax,ds:[ICOKrok]
DispMen7:cmp       bx,400h
         jne       DispMen8
         mov       ax,ds:[ICOLast]
DispMen8:cmp       bx,500h
         jne       DispMen9
         mov       ax,ds:[ICOIkony]
DispMen9:
;         cmp       bx,600h
;         jne       DispMn92
;         mov       ax,ds:[ICOStart]
DispMn92:

DispMenA:cmp       bx,0b00h
         jne       DispMenB
;         mov       ax,ds:[ICODisk]
         mov       ax,ds:[ICOStart]
DispMenB:cmp       bx,0c00h
         jne       DispMenC
         mov       ax,ds:[ICOMaluj]

DIspMenC:cmp       bx,0d00h
         jne       DispMenD
         mov       ax,ds:[ICOKonec]

DispMenD:call      DispIcon
         inc       bx
         add       dl,4
         cmp       dl,1+PSIRKA*4+1+1+MSIRKA*4
         jae       DispMnD2
         jmp       DispMen3

DispMnD2:inc       bh
         add       dh,4
         cmp       dh,1+MVYSKA*4
         jae       DispMenX
         jmp       DispMen2

DispMenX:
         pop       dx
         pop       bx
         pop       ax
         ret

DispMenu ENDP

; -----------------------------------------------------------------------------
;        zobrazen rmu kolem textu (s vymaznm textu)
; -----------------------------------------------------------------------------

TextRam  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ pprava registr

         mov       ax,8+PVYSKA*32+8         ; poet linek
         mul       word ptr ds:[DispSirB]   ; * dlka linky v bajtech
         xchg      ax,bp                    ; BP <- poten adresa rmu

         mov       ax,ds:[ICORamT]          ; slo ikony rmu kolem textu
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         mov       es,ds:[AdrVRAM]          ; ES <- adresa videopamti
         pop       ds                       ; adresa ikony rmu kolem textu

         mov       ch,0
         xor       si,si                    ; SI <- 0 potek dat ikony
         cld
         cli

; ------ nastaven registr barvy a masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nastaven zpisov roviny

         mov       ah,bit0                  ; ukazatel zpisov roviny
TextRam1:mov       di,bp                    ; ukldac adresa
         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,ah                    ; zpisov rovina
         out       dx,al                    ; volba zpisov roviny

; ------ lev okraj

         mov       bx,16                    ; poet linek k penesen
TextRam5:movsb                              ; penos levho okraje

; ------ stedn st

         mov       cx,(80-2)/2              ; dlka linky ve slovech
TextRam6:movsw
         dec       si
         dec       si
         loop      TextRam6

; ------ prav okraj

         inc       si
         inc       si
         movsb                              ; penos pravho okraje

; ------ pprava pro dal linku

         dec       bx
         jnz       TextRam5                 ; dal linka

; ------ pprava pro dal rovinu

         add       si,16*4                  ; peskoen nevyuit spodn sti
         shl       ah,1                     ; posun masky barevn roviny
         cmp       ah,bit4                  ; jsou ji vechny roviny ?
         jne       TextRam1                 ; zpis dal roviny

; ------ nvrat zpisu do vech rovin

         mov       al,1111b
         out       dx,al                    ; zpis do vech rovin

; ------ nvrat registr

         sti
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         mov       word ptr ds:[TimeTxt],0  ; nulovn tae pro vypnut
         ret

TextRam  ENDP

; -----------------------------------------------------------------------------
;        zobrazen rmu kolem menu
; -----------------------------------------------------------------------------

MenuRam  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ pprava registr

         mov       bp,ds:[DispSirB]         ; dlka linky v bajtech
         sub       bp,MSIRKA*4+2            ; prustek adresy mezi linkami

         mov       ax,ds:[ICORamM]          ; slo ikony rmu kolem menu
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         mov       es,ds:[AdrVRAM]          ; ES <- adresa videopamti
         pop       ds                       ; adresa ikony rmu kolem menu

         mov       ch,0
         xor       si,si                    ; SI <- 0 potek dat ikony
         cld
         cli

; ------ nastaven registr barvy a masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nastaven zpisov roviny

         mov       ah,bit0                  ; ukazatel zpisov roviny
MenuRam1:mov       di,1+PSIRKA*4+1          ; ukldac adresa
         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,ah                    ; zpisov rovina
         out       dx,al                    ; volba zpisov roviny

; ------ lev horn roh

         mov       bx,8                     ; poet linek k zpisu
MenuRam2:movsb                              ; lev horn roh

; ------ horn okraj

         mov       cx,MSIRKA*2              ; poet slov k penesen
MenuRam3:movsw                              ; penesen linky
         dec       si
         dec       si
         loop      MenuRam3

; ------ prav horn roh

         inc       si
         inc       si
         movsb                              ; prav horn roh

; ------ pprava pro dal linku hornho okraje

         add       di,bp                    ; adresa dal linky
         dec       bx                       ; ta linek
         jnz       MenuRam2                 ; dal linka

; ------ lev okraj

         mov       bx,MVYSKA*2              ; poet dk k penesen
MenuRam4:mov       cx,16                    ; poet linek v jednom dku
MenuRam5:movsb                              ; penos levho okraje
         inc       si
         inc       si

; ------ prav okraj

         add       di,MSIRKA*4              ; aresa pravho okraje
         movsb                              ; penos pravho okraje

; ------ pprava pro dal linku stedn sti

         add       di,bp                    ; adresa dal linky
         loop      MenuRam5                 ; dal linka

; ------ pprava pro dal dek stedn sti

         sub       si,16*4                  ; nvrat potku dku
         dec       bx                       ; ta dk
         jnz       MenuRam4                 ; dal dek
         add       si,16*4                  ; adresa spodnho okraje

; ------ lev doln roh

         mov       bx,8                     ; poet linek k zpisu
MenuRam6:movsb                              ; lev doln roh

; ------ doln okraj

         mov       cx,MSIRKA*2              ; poet slov k penesen
MenuRam7:movsw                              ; penesen linky
         dec       si
         dec       si
         loop      MenuRam7

; ------ prav doln roh

         inc       si
         inc       si
         movsb                              ; prav doln roh

; ------ pprava pro dal linku dolnho okraje

         add       di,bp                    ; adresa dal linky
         dec       bx                       ; ta linek
         jnz       MenuRam6                 ; dal linka

; ------ pprava pro dal rovinu

         shl       ah,1                     ; posun masky barevn roviny
         cmp       ah,bit4                  ; jsou ji vechny roviny ?
         jne       MenuRam1                 ; zpis dal roviny

; ------ nvrat zpisu do vech rovin

         mov       al,1111b
         out       dx,al                    ; zpis do vech rovin

; ------ nvrat registr

         sti
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

MenuRam  ENDP

; -----------------------------------------------------------------------------
;        zobrazen rmu kolem hrac plochy
; -----------------------------------------------------------------------------

DispRam  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ pprava registr

         mov       bp,ds:[DispSirB]         ; dlka linky v bajtech
         sub       bp,PSIRKA*4+2            ; prustek adresy mezi linkami

         mov       ax,ds:[ICORam]           ; slo ikony rmu
         call      AdrICO                   ; adresa ikony -> ES
         push      es
         mov       es,ds:[AdrVRAM]          ; ES <- adresa videopamti
         pop       ds                       ; adresa ikony rmu

         mov       ch,0
         xor       si,si                    ; SI <- 0 potek dat ikony
         cld
         cli

; ------ nastaven registr barvy a masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nastaven zpisov roviny

         mov       ah,bit0                  ; ukazatel zpisov roviny
DispRam1:xor       di,di                    ; ukldac adresa
         mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,ah                    ; zpisov rovina
         out       dx,al                    ; volba zpisov roviny

; ------ lev horn roh

         mov       bx,8                     ; poet linek k zpisu
DispRam2:movsb                              ; lev horn roh

; ------ horn okraj

         mov       cx,PSIRKA*2              ; poet slov k penesen
DispRam3:movsw                              ; penesen linky
         dec       si
         dec       si
         loop      DispRam3

; ------ prav horn roh

         inc       si
         inc       si
         movsb                              ; prav horn roh

; ------ pprava pro dal linku hornho okraje

         add       di,bp                    ; adresa dal linky
         dec       bx                       ; ta linek
         jnz       DispRam2                 ; dal linka

; ------ lev okraj

         mov       bx,PVYSKA*2              ; poet dk k penesen
DispRam4:mov       cx,16                    ; poet linek v jednom dku
DispRam5:movsb                              ; penos levho okraje
         inc       si
         inc       si

; ------ prav okraj

         add       di,PSIRKA*4              ; aresa pravho okraje
         movsb                              ; penos pravho okraje

; ------ pprava pro dal linku stedn sti

         add       di,bp                    ; adresa dal linky
         loop      DispRam5                 ; dal linka

; ------ pprava pro dal dek stedn sti

         sub       si,16*4                  ; nvrat potku dku
         dec       bx                       ; ta dk
         jnz       DispRam4                 ; dal dek
         add       si,16*4                  ; adresa spodnho okraje

; ------ lev doln roh

         mov       bx,8                     ; poet linek k zpisu
DispRam6:movsb                              ; lev doln roh

; ------ doln okraj

         mov       cx,PSIRKA*2              ; poet slov k penesen
DispRam7:movsw                              ; penesen linky
         dec       si
         dec       si
         loop      DispRam7

; ------ prav doln roh

         inc       si
         inc       si
         movsb                              ; prav doln roh

; ------ pprava pro dal linku dolnho okraje

         add       di,bp                    ; adresa dal linky
         dec       bx                       ; ta linek
         jnz       DispRam6                 ; dal linka

; ------ pprava pro dal rovinu

         shl       ah,1                     ; posun masky barevn roviny
         cmp       ah,bit4                  ; jsou ji vechny roviny ?
         jne       DispRam1                 ; zpis dal roviny

; ------ nvrat zpisu do vech rovin

         mov       al,1111b
         out       dx,al                    ; zpis do vech rovin

; ------ nvrat registr

         sti
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispRam  ENDP

; -----------------------------------------------------------------------------
;        zobrazen celho pole
; -----------------------------------------------------------------------------

DispPole PROC      NEAR

; ------ schova registr

         push      dx

; ------ zobrazen plochy

         mov       dh,0                     ; poten dek
DispPol1:mov       dl,0                     ; poten pozice
DispPol2:call      PoleIcon                 ; zobrazen ikony
         inc       dx
         cmp       dl,PSIRKA
         jb        DispPol2
         inc       dh
         cmp       dh,PVYSKA
         jb        DispPol1

; ------ nvrat registr

         pop       dx
         ret

DispPole ENDP

; -----------------------------------------------------------------------------
;        zobrazen poloky pole (DH=linka, DL=pozice, mohou bt mimo rozsah)
; -----------------------------------------------------------------------------

PoleIcon PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx

; ------ kontrola ukazatel

         cmp       dh,PVYSKA
         jae       PoleIco9                 ; chybn dek
         cmp       dl,PSIRKA
         jae       PoleIco9                 ; chybn pozice

; ------ kontrola, zda se tm vymae Petr

         cmp       dx,ds:[PetrOPz]         ; je to star pozice Petra ?
         jne       PoleIco4                 ; nen to star pozice Petra
         and       byte ptr ds:[Param],not bit3 ; Petr nen zobrazen

; ------ slo ikony -> AX

PoleIco4:mov       al,PSIRKA                ; poet pozic na dek
         mul       dh                       ; pepoet dku na pozici
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; offset v tabulce
         xchg      ax,bx                    ; BX <- offset v tabulce
         mov       ax,ds:[bx+Pole]          ; AX <- slo ikony

; ------ pozice k zobrazen -> DX

         shl       dx,1
         shl       dx,1
         add       dx,101h

; ------ zobrazen ikony

         call      DispIcon                 ; zobrazen ikony

; ------ nvrat registr

PoleIco9:pop       dx
         pop       bx
         pop       ax
         ret

PoleIcon ENDP

; -----------------------------------------------------------------------------
;        zobrazen ikony AX, linka DH, pozice DL
; -----------------------------------------------------------------------------

DispIcon PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

; ------ adresa ikony AX -> ES

         call      AdrICO                   ; adresa ikony -> ES

; ------ ukldac adresa do videopamti -> DI

         push      dx
         mov       al,8
         mul       dh                       ; pepoet dku na linku
         mul       word ptr ds:[DispSirB]   ; pepoet na bajty
         pop       dx
         mov       dh,0
         add       ax,dx                    ; adresa k uloen
         xchg      ax,di                    ; DI <- adresa ve videopamti
         cld
         cli

; ------ pprava registr

         mov       bx,ds:[DispSirB]         ; ka linky v bajtech
         sub       bx,4                     ; prustek adresy linek ikony
         push      es
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         pop       ds                       ; DS <- segment ikony
         xor       si,si                    ; SI <- 0 potek dat ikony
         mov       ch,0

; ------ nastaven registr barvy a masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx
         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nastaven zpisov roviny

         mov       ah,bit0                  ; maska volby zpisov roviny
DispIco2:mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,ah                    ; zpisov rovina
         out       dx,al                    ; volba zpisov roviny

; ------ penos roviny obrzku

         mov       cl,32                    ; vka ikony v linkch
         push      di
DispIco3:movsw
         movsw
         add       di,bx                    ; adresa dal linky
         loop      DispIco3                 ; dal linka
         pop       di

; ------ pprava pro dal rovinu

         shl       ah,1                     ; posun masky barevn roviny
         cmp       ah,bit4                  ; jsou ji vechny roviny ?
         jne       DispIco2                 ; zpis dal roviny

; ------ nvrat zpisu do vech rovin

         mov       al,1111b
         out       dx,al                    ; zpis do vech rovin

; ------ nvrat registr

         sti
         pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispIcon ENDP

; -----------------------------------------------------------------------------
; zobrazen pedmtu s maskou (AX=pedmt, DH=linka, DL=pozice, mohou bt mimo rozsah)
; -----------------------------------------------------------------------------

PoleMask PROC      NEAR

; ------ schova registr

         push      dx

; ------ kontrola ukazatel

         cmp       dh,PVYSKA
         jae       PoleMsk9                 ; chybn dek
         cmp       dl,PSIRKA
         jae       PoleMsk9                 ; chybn pozice

; ------ kontrola, zda se tm vymae Petr

         cmp       dx,ds:[PetrOPz]         ; je to star pozice Petra ?
         jne       PoleMsk4                 ; nen to star pozice Petra
         and       byte ptr ds:[Param],not bit3 ; Petr nen zobrazen

; ------ pozice k zobrazen -> DX

PoleMsk4:shl       dx,1
         shl       dx,1
         add       dx,101h

; ------ zobrazen ikony

         call      MaskIcon                 ; zobrazen ikony

; ------ nvrat registr

PoleMsk9:pop       dx
         ret

PoleMask ENDP

; -----------------------------------------------------------------------------
;        zobrazen ikony s maskou AX, linka DH, pozice DL
; -----------------------------------------------------------------------------

MaskIcon PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ adresa ikony AX -> ES

         call      AdrICO                   ; adresa ikony -> ES

; ------ ukldac adresa do videopamti -> DI

         push      dx
         mov       al,8
         mul       dh                       ; pepoet dku na linku
         mul       word ptr ds:[DispSirB]   ; pepoet na bajty
         pop       dx
         mov       dh,0
         add       ax,dx                    ; adresa k uloen
         xchg      ax,di                    ; DI <- adresa ve videopamti
         cld
         cli

; ------ pprava registr

         mov       bp,ds:[DispSirB]         ; ka linky v bajtech
         sub       bp,4                     ; prustek adresy linek ikony
         push      es
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         pop       ds                       ; DS <- segment ikony
         xor       si,si                    ; SI <- 0 potek dat ikony
         mov       ch,0

; ------ nastaven registru barvy

         mov       dx,3ceh
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nastaven zpisov roviny

         mov       ah,bit0                  ; maska volby zpisov roviny
MaskIco2:mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,ah                    ; zpisov rovina
         out       dx,al                    ; volba zpisov roviny

; ------ pednastaven registru bitov masky

         mov       dx,3ceh
         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx

; ------ penos roviny obrzku

         mov       bx,32*32*4/8             ; offset masky ikony
         mov       cl,32                    ; vka ikony v linkch
         push      di
MaskIco3:mov       al,ds:[bx]               ; maska
         inc       bx
         out       dx,al                    ; nastaven masky
         mov       al,es:[di]               ; naten bajtu
         movsb                              ; uloen bajtu

         mov       al,ds:[bx]               ; maska
         inc       bx
         out       dx,al                    ; nastaven masky
         mov       al,es:[di]               ; naten bajtu
         movsb                              ; uloen bajtu

         mov       al,ds:[bx]               ; maska
         inc       bx
         out       dx,al                    ; nastaven masky
         mov       al,es:[di]               ; naten bajtu
         movsb                              ; uloen bajtu

         mov       al,ds:[bx]               ; maska
         inc       bx
         out       dx,al                    ; nastaven masky
         mov       al,es:[di]               ; naten bajtu
         movsb                              ; uloen bajtu

         add       di,bp                    ; adresa dal linky
         loop      MaskIco3                 ; dal linka
         pop       di

; ------ pprava pro dal rovinu

         shl       ah,1                     ; posun masky barevn roviny
         cmp       ah,bit4                  ; jsou ji vechny roviny ?
         jne       MaskIco2                 ; zpis dal roviny

; ------ nvrat videoregistr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         mov       dx,3c4h
         mov       al,1111b
         out       dx,al                    ; zpis do vech rovin

; ------ nvrat registr

         sti
         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

MaskIcon ENDP

; -----------------------------------------------------------------------------
;        asov obsluha mazn hlen
; -----------------------------------------------------------------------------

IntHlas  PROC      NEAR

         cmp       word ptr ds:[TimeTxt],1  ; je poteba vymazat ?
         jne       IntHlas9                 ; nen poteba vymazat
         call      TextRam                  ; vymazn hlen
IntHlas9:ret

IntHlas  ENDP

; -----------------------------------------------------------------------------
;        zobrazen hlen DS:SI, barva AH (=bاn)/AL (=vrazn), doba CX
; -----------------------------------------------------------------------------
; dlka textu DS:SI se udv jako zobrazen dlka (bez pepnacch znak):
;             %* ........ zmna zvraznn (=AL) / normln (=AH) barva
; -----------------------------------------------------------------------------

DispHlas PROC      NEAR

         push      bx
         push      cx
         push      dx
         push      si

         cmp       word ptr ds:[TimeTxt],0  ; je nco zobrazeno ?
         je        DispHls2                 ; nen nic zobrazeno
         call      TextRam                  ; vymazn textu

DispHls2:mov       ds:[TimeTxt],cx          ; nov ta doby

         mov       cl,ds:[si]               ; dlka textu
         inc       si
         mov       ch,0
         mov       bx,78                    ; maximln dlka textu
         sub       bx,cx
         jnc       DispHls3
         xor       bx,bx
         mov       cl,78
DispHls3:shr       bx,1

         mov       dx,480-15

         call      DispTxt

         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

DispHlas ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu programem
; -----------------------------------------------------------------------------

PetText  PROC      NEAR

; ------ pprava textu hlen

         call      IniHlas                  ; pprava textu hlen
         jc        PetText9                 ; chyba

; ------ test, zda je blokovn pkazu

         call      TestBlok                 ; test blokovn programu
         jnz       PetText9                 ; je blokovn pkaz

; ------ inicializace sla dku a pozice -> BX

         call      NextPoz                  ; pt pozice -> BX
         shl       bh,1                     ; budou 2 dky na ikonu
         cmp       byte ptr ds:[TextRad],-1 ; je platn slo dku ?
         je        PetText6                 ; slo dku nen platn
         mov       bh,ds:[TextRad]          ; plat uschovan dek
PetText6:mov       ds:[TextRad],bh          ; schova sla dku

; ------ kontrola platnosti sla dku

         cmp       byte ptr ds:[TextRad],PVYSKA*2 ; je platn slo dku ?
         jae       PetText8                 ; peteen sla dku

; ------ vpoet sla videolinky -> DX

         mov       al,16                    ; poet linek na dek
         mul       bh                       ; pepoet dku na linku
         add       ax,8                     ; piten poten linky
         xchg      ax,dx                    ; DX <- slo videolinky

; ------ vpoet sla pozice -> BX

         xchg      ax,bx                    ; AL <- pozice ikony
         cbw                                ; konverze na slovo
         shl       ax,1
         shl       ax,1                     ; AX <- offset v bajtech
         inc       ax                       ; piten poten pozice
         xchg      ax,bx                    ; BX <- ukazatel pozice

; ------ omezen dlky textu

         mov       ax,PSIRKA*4+1            ; konec za plochou
         sub       ax,bx                    ; zbvajc poet znak
         js        PetText8                 ; text je za koncem dku
         cmp       al,byte ptr ds:[ProgStr] ; je peteen dlky textu ?
         jae       PetText7                 ; dlka textu je OK
         mov       ds:[ProgStr],al          ; omezen dlky textu

; ------ zobrazen textu

PetText7:mov       si,offset ProgStr+1      ; text hlen
         mov       cl,ds:[si-1]             ; dlka textu
         mov       ch,0
         mov       ax,99h                   ; barva textu - ern/erven
         call      DispTxt                  ; zobrazen textu
PetText8:inc       byte ptr ds:[TextRad]    ; zven ukazatele dku
         clc
PetText9:ret

PetText  ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu DS:SI, barva AH/AL, linka DX, pozice BX, CX znak
; -----------------------------------------------------------------------------
; dlka textu v CX se udv jako zobrazen dlka (bez pepnacch znak):
;             %* ........ zmna zvraznn (=AL) / normln (=AH) barva
;             %$N ....... nastaven barvy textu ("0" a "9", "A" a "F")
;                         "G" a "V" = barva pozad (pi nastaven textu a
;                         pozad na stejnou barvu je ponechno pvodn pozad)
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

         push      ax
         push      cx
         push      si

         jcxz      DispTxt8                 ; nen dn text

; ------ zmna zvraznn

DispTxt1:cmp       word ptr ds:[si],"*%"    ; je zmna barvy ?
         jne       DispTxt2                 ; nen zmna barvy
         xchg      ah,al                    ; zmna barvy
         inc       si
         inc       si                       ; peskoen znak
         jmp       short DispTxt1

; ------ nastaven barvy textu

DispTxt2:cmp       word ptr ds:[si],"$%"    ; je nastaven barvy ?
         jne       DispTxt4                 ; nen nastaven barvy

         inc       si
         inc       si                       ; peskoen znak

         push      dx

         mov       dl,ds:[si]               ; znak pro barvu
         xchg      ax,dx
         call      UpCase                   ; konverze na velk psmeno
         xchg      ax,dx
         cmp       dl,"G"                   ; je barva pozad ?
         jb        DispTx32                 ; nen barva pozad
         sub       dl,"G"                   ; slo barvy
         jmp       short DispTx33

DispTx32:cmp       dl,"9"                   ; je slice ?
         jbe       DispTxt3                 ; je slice
         sub       dl,7                     ; korekce psmene
DispTxt3:and       dl,0fh                   ; poadovan barva
         mov       ah,dl                    ; AH <- poadovan barva

DispTx33:shl       dl,1
         shl       dl,1
         shl       dl,1
         shl       dl,1                     ; DL <- slo barvy * 16
         and       ah,0fh                   ; slo barvy poped
         or        ah,dl                    ; nastaven barvy pozad

DispTx34:inc       si                       ; peskoen znaku

         pop       dx
         jmp       short DispTxt1           ; dal znak

; ------ zobrazen pozad (je-li pozad a poped jin)

DispTxt4:push      ax
         mov       al,ah
         and       al,0fh                   ; barva poped
         shr       ah,1
         shr       ah,1
         shr       ah,1
         shr       ah,1
         cmp       al,ah                    ; je stejn barva ?
         je        DispTx42                 ; je stejn barva

         mov       al,219
         call      DispChr
         dec       bx

DispTx42:pop       ax

; ------ zobrazen znaku

DispTxt7:push      ax
         cld
         lodsb
         and       ah,0fh
         call      DispChr                  ; zobrazen znaku
         pop       ax
         loop      DispTxt1

DispTxt8:pop       si
         pop       cx
         pop       ax
         ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        zobrazen znaku AL, barva AH, linka DX, pozice BX
; -----------------------------------------------------------------------------

DispChr  PROC      NEAR

; ------ kontrola bajtov pozice

         or        bx,bx                    ; prvn pozice nepovolena
         jz        DispCh02                 ; nepovoleno
         cmp       bx,79                    ; maximln pozice (bez konce)
         jb        DispChr0                 ; pozice je OK
DispCh02:inc       bx
         ret

; ------ schova registr

DispChr0:call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ adresa znaku -> SI

         push      ax                       ; schova barvy znaku

         mov       ah,byte ptr ds:[VysFont] ; vka pouitho fontu
         mul       ah                       ; offset znaku
         add       ax,ds:[AdrFont]          ; adresa znaku
         xchg      ax,si                    ; SI <- adresa znaku

; ------ vpoet adresy ve videopamti -> DI

         xor       di,di                    ; DI <- 0 nen korekce
         cmp       byte ptr ds:[TypCard],2  ; je videokarta CGA ?
         ja        DispChr2                 ; nen videokarta CGA ani Hercules
         shr       dx,1                     ; je lich linka ?
         jnc       DispChr1                 ; nen lich linka
         add       di,2000h                 ; korekce pro lichou linku CGA
DispChr1:cmp       byte ptr ds:[TypCard],1  ; je videokarta Hercules ?
         jne       DispChr2                 ; nen videokarta Hercules
         shr       dx,1                     ; je lich pr linek ?
         jnc       DispChr2                 ; nen lich pr linek
         add       di,4000h                 ; korekce pro lich pr linek
DispChr2:mov       ax,ds:[DispSirB]         ; poet bajt na linku
         mul       dx                       ; pepoet linky na adresu
         add       di,ax                    ; adresa linky
         add       di,bx                    ; piten pozice

         pop       ax                       ; poadovan barva znaku

; ------ pprava k operaci

         cld
         cli                                ; zkaz peruen bhem operace
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       cx,ds:[VysFont]          ; vka znaku v linkch

; ------ zobrazen znaku pro Hercules a CGA

         cmp       byte ptr ds:[TypCard],2  ; je videokarta CGA ?
         ja        DispChr7                 ; nen videokarta CGA ani Hercules
DispChr4:lodsb                              ; naten bajtu
         or        byte ptr es:[di],al      ; bl psmo
         cmp       ah,0fh                   ; je bl barva ?
         jne       DispCh41                 ; nen bl barva
;         cmp       byte ptr ds:[Barva],0    ; je pozad ern ?
;         je        DispCh41                 ; pozad je ern
;         xor       byte ptr es:[di],al      ; zmna na ernou barvu
DispCh41:;call      IncAdr                   ; zven adresy DI
         loop      DispChr4                 ; dal bajt
         jmp       short DispChr9

; ------ nastaven zpisu do vech rovin

DispChr7:mov       dx,3c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx                       ; datov registr
         mov       al,0fh                   ; zpisov rovina - ve
         out       dx,al                    ; volba zpisov roviny

; ------ nastaven barvy znaku

         mov       dx,3ceh
         mov       al,0                     ; registr 0
         out       dx,al                    ; volba registru 0
         inc       dx
         mov       al,ah                    ; poadovan barva znaku
;         cmp       al,0fh                   ; je bl barva ?
;         jne       DispCh72                 ; nen bl barva
;         cmp       byte ptr ds:[Barva],8    ; je svtl barva ?
;         jb        DispCh72                 ; nen svtl barva
;         cmp       byte ptr ds:[Barva],9
;         je        DispCh72                 ; je erven barva
;         cmp       byte ptr ds:[Barva],12
;         je        DispCh72                 ; je modr barva
;         cmp       byte ptr ds:[Barva],13
;         je        DispCh72                 ; je fialov barva
;         mov       al,0                     ; bude ern barva
DispCh72:out       dx,al                    ; nastaven barvy znaku
         dec       dx

; ------ nastaven volby rovin

         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,1111b                 ; vechny roviny podle registru 0
         inc       dx
         out       dx,al                    ; volba rovin
         dec       dx

; ------ pednastaven registru bitov masky

         mov       al,8                     ; registr 8
         out       dx,al                    ; volba registru 8
         inc       dx

; ------ zpis obrzku do roviny

DispChr8:lodsb
         out       dx,al                    ; nastaven masky
         xchg      al,es:[di]               ; zpis znaku
         add       di,640/8
         loop      DispChr8

; ------ nvrat videoregistr

         mov       al,0ffh                  ; maska - vechny bity
         out       dx,al                    ; vechny bity
         dec       dx
         mov       al,1                     ; registr 1
         out       dx,al                    ; volba registru 1
         mov       al,0                     ; vechny roviny podle dat
         inc       dx
         out       dx,al                    ; volba rovin

; ------ nvrat registr

DispChr9:sti                                ; peruen opt povoleno
         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         inc       bx                       ; zven ukazatele pozice
         ret

DispChr  ENDP

; -----------------------------------------------------------------------------
;        inicializace videokarty
; -----------------------------------------------------------------------------

IniCard  PROC      NEAR

; ------ test zadn karty Hercules

         mov       ah,0
         mov       al,ds:[TypCard]          ; zadan videokarta
         dec       ax
         jnz       IniCrd01                 ; nen Hercules
         mov       al,7
         call      TestVMod                 ; test videomdu
         jnz       IniCrd08                 ; nen Hercules
         jmp       IniCrd52                 ; je Hercules OK

; ------ test zadn karty CGA

IniCrd01:dec       ax
         jnz       IniCrd02                 ; nen CGA
         mov       al,6                     ; md pro CGA
         call      TestVMod                 ; test videomdu
         jnz       IniCrd08                 ; nen CGA
         jmp       IniCrd62                 ; je CGA OK

; ------ test zadn EGA

IniCrd02:dec       ax
         jnz       IniCrd03                 ; nen EGA
         mov       al,16
         call      TestVMod                 ; test videomdu
         jnz       IniCrd08                 ; nen EGA
         jmp       IniCrd42                 ; je EGA OK

; ------ test zadn VGA

IniCrd03:dec       ax
         jnz       IniCrd08                 ; nen VGA
         mov       al,18
         call      TestVMod                 ; test videomdu
         jz        IniCrd32                 ; je VGA OK

; ------ test videokarty EGA/VGA

IniCrd08:mov       ah,12h                   ; sluba EGA/VGA - informace o EGA
         mov       bx,4510h                 ; poskytnut informac o EGA
         call      Int10                    ; poskytnut informac o EGA/VGA
         cmp       bh,2                     ; kontrola navrcenho mdu displeje
         ja        IniCard1                 ; nen to karta EGA/VGA
         cmp       bl,5                     ; maximln povolen 1 MB pamti
         jbe       IniCard2                 ; je to EGA/VGA
IniCard1:jmp       IniCard5                 ; nen to karta EGA/VGA

; ------ rozlien videokarty EGA a VGA

IniCard2:mov       ax,1a00h
         call      Int10                    ; dotaz na instalaci karty
         cmp       al,1ah
         jne       IniCard4                 ; funkce nen obsluhovan - je EGA
         cmp       bl,7
         je        IniCard3                 ; je karta VGA
         cmp       bl,8
         je        IniCard3                 ; je karta VGA
         cmp       bl,11
         je        IniCard3                 ; je karta VGA
         cmp       bl,12
         jne       IniCard4                 ; nen karta VGA

; ------ je karta VGA

IniCard3:mov       al,18                    ; videomd VGA: 640*480
IniCrd32:mov       byte ptr ds:[TypCard],4  ; je karta VGA
         mov       word ptr ds:[AdrVRAM],0a000h ; adresa videopamti
         mov       word ptr ds:[DispSirX],640 ; ka obrazovky (bod)
         mov       word ptr ds:[DispSirB],80  ; ka obrazovky (bajt)
         mov       word ptr ds:[DispVysY],480 ; vka obrazovky (bod)
         mov       word ptr ds:[AdrFont],offset Font16 ; adresa pouitho fontu
         mov       word ptr ds:[VysFont],16 ; vka pouitho fontu
         jmp       IniCard7

; ------ je karta EGA

IniCard4:mov       al,16                    ; videomd EGA: 640*350
IniCrd42:mov       byte ptr ds:[TypCard],3  ; je EGA
         mov       word ptr ds:[AdrVRAM],0a000h ; adresa videopamti
         mov       word ptr ds:[DispSirX],640 ; ka obrazovky (bod)
         mov       word ptr ds:[DispSirB],80  ; ka obrazovky (bajt)
         mov       word ptr ds:[DispVysY],350 ; vka obrazovky (bod)
         mov       word ptr ds:[AdrFont],offset Font14 ; adresa pouitho fontu
         mov       word ptr ds:[VysFont],14 ; vka pouitho fontu
         jmp       IniCard7

; ------ rozlien karet CGA/Hercules

IniCard5:mov       ah,0fh
         call      Int10                    ; poskytnut aktivnho videomdu
         cmp       al,7                     ; je videomd 7 (Hercules) ?
         jne       IniCard6                 ; nen Hercules - je CGA

; ------ je karta Hercules (AL=7 nebo AL=0 ji je inicializovno)

IniCrd52:mov       byte ptr ds:[TypCard],1  ; Hercules
         mov       word ptr ds:[AdrVRAM],0b000h ; adresa videopamti
         mov       word ptr ds:[DispSirX],HercSir*8 ; ka obrazovky (bod)
         mov       word ptr ds:[DispSirB],HercSir  ; ka obrazovky (bajt)
         mov       word ptr ds:[DispVysY],350 ; vka obrazovky (bod)
         mov       word ptr ds:[AdrFont],offset Font14 ; adresa pouitho fontu
         mov       word ptr ds:[VysFont],14 ; vka pouitho fontu
         mov       ah,0
         or        ax,ax
         jz        IniCrd54                 ; je ji nastaven
         call      Int10                    ; nastaven videomdu
IniCrd54:call      InitHGC                  ; inicializace grafickho mdu HGC

         cld
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         xor       ax,ax
         xor       di,di
         mov       cx,8000h/2
         rep       stosw                    ; vymazn videopamti Hercules
         ret

; ------ je karta CGA

IniCard6:mov       al,6                     ; videomd CGA: 640*200
IniCrd62:mov       byte ptr ds:[TypCard],2  ; CGA
         mov       word ptr ds:[AdrVRAM],0b800h ; adresa videopamti
         mov       word ptr ds:[DispSirX],640 ; ka obrazovky (bod)
         mov       word ptr ds:[DispSirB],80  ; ka obrazovky (bajt)
         mov       word ptr ds:[DispVysY],200 ; vka obrazovky (bod)
         mov       word ptr ds:[AdrFont],offset Font08 ; adresa pouitho fontu
         mov       word ptr ds:[VysFont],8 ; vka pouitho fontu

; ------ nastaven videomdu AL

IniCard7:mov       ah,0
         or        ax,ax                    ; je ji nastaven ?
         jz        IniCrd72                 ; videomd je ji nastaven
         call      Int10                    ; nastaven videomdu
IniCrd72:ret

IniCard  ENDP

; ------ testovac nastaven videomdu AX -> NZ=nen, BX=znien, AL=0 pro ZY

TestVMod PROC      NEAR

         mov       bx,ax                    ; BX <- schova
         call      Int10                    ; nastaven mdu
         mov       ah,0fh
         call      Int10                    ; poskytnut aktivnho videomdu
         sub       al,bl                    ; OK ?
         ret

TestVMod ENDP

; -----------------------------------------------------------------------------
;        inicializace palet displeje
; -----------------------------------------------------------------------------

InitPal  PROC      NEAR

; ------ test, zda je videokarta EGA nebo VGA

         cmp       byte ptr ds:[TypCard],3  ; je videokarta EGA nebo VGA ?
         jb        InitPal8                 ; nen videokarta EGA ani VGA

; ------ inicializace palet EGA

         mov       ax,1002h
         push      ds
         pop       es                       ; ES <- datov segment
         mov       dx,offset PalEGA         ; tabulka palet EGA
         call      Int10                    ; nastaven palet EGA

; ------ test, zda je videokarta VGA

         cmp       byte ptr ds:[TypCard],4  ; je videokarta VGA ?
         jb        InitPal8                 ; nen videokarta VGA

; ------ inicializace palet VGA

         mov       si,offset PalVGA         ; tabulka palet VGA
         mov       di,offset PalEGA         ; tabulka palet EGA
         mov       bp,16                    ; poet palet k inicializaci
InitPal2:cld
         lodsw                              ; modr a zelen
         xchg      ax,cx                    ; CL <- modr, CH <- zelen
         lodsb                              ; erven
         mov       dh,al                    ; DH <- erven
         xchg      si,di
         lodsb
         xchg      si,di
         mov       ah,0
         xchg      ax,bx                    ; BX <- index barvy
         mov       ax,1010h
         call      Int10                    ; nastaven paletovho registru
         dec       bp
         jnz       InitPal2                 ; dal registr
InitPal8:ret

InitPal  ENDP

; -----------------------------------------------------------------------------
;        inicializace grafickho reimu karty HGC
; -----------------------------------------------------------------------------

InitHGC  PROC      NEAR

; ------ nastaven registru mdu karty HGC

         cli
         mov       al,3
         mov       dx,3bfh
         out       dx,al

         mov       al,2
         mov       dx,3b8h
         out       dx,al                    ; grafick md

; ------ inicializace registr HGC

         mov       ah,0
         mov       si,offset HGCTabR        ; tabulka registr karty HGC
         mov       dx,3b4h                  ; adresa portu karty HGC
         cld
InitHGC2:mov       al,ah                    ; slo registru
         out       dx,al                    ; nastaven sla registru
         inc       dx
         lodsb                              ; volba sla registru
         out       dx,al                    ; nastaven registru
         dec       dx
         inc       ah                       ; zven ukazatele registr
         cmp       ah,16
         jb        InitHGC2                 ; dal registr

; ------ zapnut videosignlu

         mov       al,1010b            ; graf.md, signl zap
         mov       dx,03b8h
         out       dx,al
         sti
         ret

InitHgc  ENDP

; -----------------------------------------------------------------------------
;        voln INT 10h s schovou registr
; -----------------------------------------------------------------------------

Int10    PROC      NEAR

         pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       10h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

Int10    ENDP

; *****************************************************************************
;
;                               Obsluha myi
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        naten stavu myi -> CY=nen volba, DX=pozice a dek ikony menu
; -----------------------------------------------------------------------------

GetMouse PROC      NEAR

         push      ax
         push      bx
         push      cx

         call      IntMouse                 ; obsluha myi
         jc        GetMous9                 ; nen zmna

         test      byte ptr ds:[MouseK],bit2+bit3 ; je stisk tlatka ?
         stc
         jz        GetMous9                 ; nen stisk tlatka

         mov       cx,ds:[MouseX]           ; souadnice X
         mov       dx,ds:[MouseY]           ; souadnice Y

         shr       cx,1
         shr       cx,1
         shr       cx,1                     ; bajtov pozice kurzoru
         dec       cx
         shr       cx,1
         shr       cx,1
         cmp       cx,13h
         jne       GetMous2
         dec       cx
GetMous2:
         shr       dx,1
         shr       dx,1
         shr       dx,1
         dec       dx
         shr       dx,1
         shr       dx,1

         mov       dh,dl                    ; dek
         mov       dl,cl                    ; pozice

         clc

GetMous9:pop       cx
         pop       bx
         pop       ax
         ret

GetMouse ENDP

; -----------------------------------------------------------------------------
;        obsluha myi -> CY=dn zmna
; -----------------------------------------------------------------------------

IntMouse PROC      NEAR

         call      MouseOn                  ; zapnut kurzoru myi

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ test, zda je my nainstalovna

         test      byte ptr ds:[Param],bit1 ; je my nainstalovna ?
         jz        IntMous8                 ; my nen nainstalovna

; ------ naten aktulnho stavu myi

         mov       al,3
         xor       bx,bx                    ; pednastaven - tlatka
         xor       cx,cx                    ; pednastaven - sloupec
         xor       dx,dx                    ; pednastaven - dek
         call      Mouse                    ; naten stavu myi

; ------ aktualizace stisku tlatek

         and       bl,bit0+bit1             ; nov stav tlatek
         mov       bh,bl                    ; BH <- schova novho stavu
         xchg      bl,ds:[MouseK]           ; uloen novho stavu tlatek
         and       bl,bit0+bit1             ; BL <- star stav tlatek

; ------ test zmny tlatek

         mov       al,bh                    ; AL <- nov stav tlatek
         xor       al,bl                    ; AL <- zmnn tlatka
         mov       bl,bh                    ; BL <- nov stav tlatek
         and       bh,al                    ; BH <- nov stisknut tlatka
         not       bl                       ; BL <- nov stav uvolnnch tlatek
         and       bl,al                    ; BL <- nov uvolnn tlatka
         shl       bx,1
         shl       bx,1
         or        ds:[MouseK],bh           ; stisknut tlatka
         shl       bl,1
         shl       bl,1
         or        ds:[MouseK],bl           ; uvolnn tlatka

; ------ uloen novch souadnic

         xchg      cx,ds:[MouseX]           ; nov pozice X
         xchg      dx,ds:[MouseY]           ; nov pozice Y

; ------ test, zda byl pohyb my s drenm

         test      byte ptr ds:[MouseK],bit0+bit1 ; stisknuto tlatko ?
         jz        IntMous7                 ; nen stisknuto tlatko
         cmp       cx,ds:[MouseX]           ; je zmna X ?
         jne       IntMous6                 ; je zmna X
         cmp       dx,ds:[MouseY]           ; je zmna Y ?
         je        IntMous7                 ; nen zmna Y
IntMous6:or        byte ptr ds:[MouseK],bit7 ; pznak pohyb myi

; ------ test, zda byla njak zmna

IntMous7:test      byte ptr ds:[MouseK],bit2+bit3+bit4+bit5+bit7 ; byla zmna ?
         jnz       IntMous9                 ; byla njak zmna
IntMous8:stc                                ; pznak, e nen zmna

; ------ nvrat registr

IntMous9:pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

IntMouse ENDP

; -----------------------------------------------------------------------------
;        inicializace myi
; -----------------------------------------------------------------------------

InitMous PROC      NEAR

         and       byte ptr ds:[Param],not bit1+bit2 ; pznak, e nen my

; ------ zkaz obsluhy pro Hercules

         cmp       byte ptr ds:[TypCard],1  ; je Hercules ?
         je        IniMous9                 ; je Hercules - zkaz

; ------ test platnosti adresy INT 33h

         mov       ax,3533h
         int       21h                      ; poskytnut adresy INT 33h
         cmp       bx,-2
         je        IniMous9                 ; neplatn adresa INT 33h
         mov       ax,es
         cmp       ax,70h
         jb        IniMous9                 ; neplatn adresa INT 33h

; ------ test instalace myi

         mov       al,0
         call      Mouse                    ; reset a test myi
         inc       ax
         jnz       IniMous9                 ; nen my
         or        byte ptr ds:[Param],bit1 ; pznak instalace myi

; ------ definice okna pro my

         xor       cx,cx                    ; poten pozice
         mov       dx,ds:[DispSirX]         ; ka obrazovky
         dec       dx
         mov       al,7
         call      Mouse                    ; horizontln rozmry obrazovky
         xor       cx,cx                    ; poten linka
         mov       dx,ds:[DispVysY]         ; vka obrazovky
         dec       dx                       ; posledn linka obrazovky
         mov       al,8
         call      Mouse                    ; vertikln rozmry obrazovky

; ------ definice obrzku myi

         mov       al,9
         xor       bx,bx
         xor       cx,cx
         mov       dx,offset KurzMous       ; obrzek kurzoru myi
         push      ds
         pop       es
         call      Mouse                    ; definice obrzku kurzoru myi

; ------ definice polohy kurzoru myi (doprosted obrazovky)

         mov       cx,ds:[DispSirX]         ; ka obrazovky
         shr       cx,1                     ; sted obrazovky
         mov       dx,ds:[DispVysY]         ; vka obrazovky
         shr       dx,1                     ; sted obrazovky
         mov       al,4
         call      Mouse                    ; nastaven pozice kurzoru myi

; ------ vyprzdn tae stisk tlatek myi

         mov       al,5
         xor       bx,bx                    ; lev tlatko
         call      Mouse                    ; test levho tlatka

         mov       al,5
         mov       bx,1                     ; prav tlatko
         call      Mouse                    ; test pravho tlatka

IniMous9:ret

InitMous ENDP

; -----------------------------------------------------------------------------
;        zapnut kurzoru myi
; -----------------------------------------------------------------------------

MouseOn  PROC      NEAR

         test      byte ptr ds:[Param],bit2 ; je kurzor myi ji zapnut ?
         jnz       MouseOn2                 ; kurzor myi je ji zapnut
         or        byte ptr ds:[Param],bit2 ; pznak zapnut kurzoru myi
         test      byte ptr ds:[Param],bit1 ; je my nainstalovna ?
         jz        MouseOn2                 ; my nen nainstalovna
         push      ax
         mov       al,1
         call      Mouse                    ; zapnut kurzoru
         pop       ax
MouseOn2:ret

MouseOn  ENDP

; -----------------------------------------------------------------------------
;        vypnut kurzoru myi
; -----------------------------------------------------------------------------

MouseOff PROC      NEAR

         test      byte ptr ds:[Param],bit2 ; je kurzor myi ji zapnut ?
         jz        MouseOf2                 ; kurzor myi nen zapnut
         and       byte ptr ds:[Param],not bit2 ; pznak vypnut kurzoru myi
         test      byte ptr ds:[Param],bit1 ; je my nainstalovna ?
         jz        MouseOf2                 ; my nen nainstalovna
         push      ax
         mov       al,2
         call      Mouse                    ; vypnut kurzoru
         pop       ax
MouseOf2:ret

MouseOff ENDP

; -----------------------------------------------------------------------------
;        obsluha myi (INT 33h)
; -----------------------------------------------------------------------------

Mouse    PROC      NEAR

         push      si
         push      di
         push      bp
         push      ds
         push      es

         sti
         mov       ah,0
         int       33h
         sti

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         ret

Mouse    ENDP

; *****************************************************************************
;
;                            Rzn procedury
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zobrazen chybovho hlen BP
; -----------------------------------------------------------------------------

DispErr  PROC      NEAR

         push      ax
         push      dx

         cmp       word ptr ds:[CitChyb],0  ; je to prvn chyba ?
         jne       DispErr2                 ; nen to prvn chyba

         mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

DispErr2:push      di
         push      es
         mov       di,offset ChybErr2
         mov       word ptr ds:[di-3],"  "
         mov       byte ptr ds:[di-4]," "
         mov       ax,ds:[CitRad]           ; ukazatel sla dku
         call      DekNumR                  ; dekdovn sla dku
         pop       es
         pop       di

         mov       dx,offset ChybErr
         mov       ah,9
         int       21h                      ; zobrazen prvn sti hlen

         mov       dx,bp
         mov       ah,9
         int       21h                      ; chybov hlen

         inc       word ptr ds:[CitChyb]    ; ta chyb

         pop       dx
         pop       ax
         ret

DispErr  ENDP

; -----------------------------------------------------------------------------
;    dekdovn sla AX do bufferu DS:DI (od levho okraje) -> DI=nov adresa
; -----------------------------------------------------------------------------

DekNum   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ pprava registr

         xor       cx,cx                    ; ta znak v bufferu
         mov       bx,10                    ; dlitel sla

; ------ vpoet slic

DekNum2: xor       dx,dx                    ; DX <- 0
         div       bx                       ; vpoet jedn slice
         inc       cx                       ; ta slic v zsobnku
         push      dx                       ; schova slice do zsobnku
         or        ax,ax                    ; bude dal slice ?
         jnz       DekNum2                  ; vpoet dal slice

; ------ uloen slic do bufferu

DekNum3: pop       ax                       ; AL <- slice
         add       al,"0"                   ; korekce na ASCII znak
         mov       ds:[di],al               ; uloen znaku do bufferu
         inc       di                       ; zven ukldac adresy
         loop      DekNum3                  ; dal slice

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekNum   ENDP

; -----------------------------------------------------------------------------
;        dekdovn sla AX od pravho okraje ES:DI
; -----------------------------------------------------------------------------

DekNumR  PROC      NEAR

         push      ax
         push      cx
         push      dx
         push      di

         mov       cx,10
DekNumR1:xor       dx,dx
         div       cx
         add       dl,"0"
         dec       di
         mov       es:[di],dl
         or        ax,ax
         jnz       DekNumR1

         pop       di
         pop       dx
         pop       cx
         pop       ax
         ret

DekNumR  ENDP

; -----------------------------------------------------------------------------
;        konverze na velk psmeno
; -----------------------------------------------------------------------------

UpCase   PROC      NEAR

         cmp       al,"a"
         jb        UpCase2
         cmp       al,"z"
         ja        UpCase2
         sub       al,32
UpCase2: ret

UpCase   ENDP

; *****************************************************************************
;
;                             Obsluha klvesnice
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        vstup znaku z klvesnice -> AX (CY=nen dn znak, AX=0)
; -----------------------------------------------------------------------------

InpChar  PROC      NEAR

         call      MouseOn                  ; zapnut kurzoru myi

; ------ test, zda je pipraven znak z klvesnice

InpChar0:mov       ah,1
         int       16h                      ; test znaku z klvesnice
         stc                                ; pznak, e nen dn klvesa
         mov       ax,0                     ; nen klvesa
         jz        InpChar2                 ; nen dn klvesa

; ------ vstup znaku z klvesnice

         mov       ah,0
         int       16h                      ; vstup znaku z klvesnice

; ------ korekce ASCII znak

         cmp       al,0                     ; je dic klvesa ?
         je        InpChar1                 ; je dic klvesa
         mov       ah,0                     ; je ASCII klvesa

; ------ test, zda je peruen programu Ctrl-Break

InpChar1:or        ax,ax                    ; je peruen Ctrl-Break ?
         jnz       InpChar2                 ; nen peruen Ctrl-Break
         or        byte ptr ds:[ParBreak],bit0 ; pznak peruen programu
         jmp       short InpChar0           ; test dal klvesy

InpChar2:ret

InpChar  ENDP

; -----------------------------------------------------------------------------
;        nulovn pznaku peruen programu
; -----------------------------------------------------------------------------

NulBreak PROC      NEAR

         and       byte ptr ds:[ParBreak],not bit0 ; nulovn pznaku peruen
         ret

NulBreak ENDP

; -----------------------------------------------------------------------------
;        test, zda je peruen programu -> CY=je peruen
; -----------------------------------------------------------------------------

TstBreak PROC      NEAR

         sti                                ; peruen mus bt povoleno
         test      byte ptr ds:[ParBreak],bit0 ; je peruen programu ?
         jz        TstBrea2                 ; nen peruen programu
         stc                                ; pznak peruen programu
TstBrea2:ret

TstBreak ENDP

; -----------------------------------------------------------------------------
;        obsluha klvesnice INT 09h
; -----------------------------------------------------------------------------

Int09    PROC      FAR

; ------ schova registr

         push      bx
         push      ds

; ------ zajitn opakovn klvesy Insert

         mov       bx,40h                   ; BX <- datov segment BIOS
         mov       ds,bx                    ; DS <- datov segment BIOS
         and       byte ptr ds:[18h],not bit7 ; nulovn pznaku klvesy Insert

; ------ test, zda nastane pesycen bufferu klvesnice

         mov       bx,ds:[1ch]              ; BX <- ukldac adresa do bufferu
         inc       bx
         inc       bx                       ; zven ukldac adresy
         cmp       bx,3eh                   ; bude pekroen konce bufferu ?
         jb        Int091                   ; nen jet pekroen konec bufferu
         sub       bx,20h                   ; pesun ukazatele na zatek
Int091:  cmp       bx,ds:[1ah]              ; bude pesycen bufferu ?
         jne       Int094                   ; nebude pesycen bufferu

; ------ zruen naposledy pijatho znaku v bufferu

         mov       bx,ds:[1ch]              ; BX <- ukldac adresa do bufferu
         dec       bx
         dec       bx                       ; snen ukldac adresy
         cmp       bx,1eh                   ; je podteen potku bufferu ?
         jae       Int092                   ; nen podteen potku bufferu
         add       bx,20h                   ; pesun ukazatele na konec
Int092:  mov       ds:[1ch],bx              ; nov ukldac adresa do bufferu

; ------ voln pvodn obsluhy INT 09h

Int094:  pushf
         call      dword ptr cs:[Old09]     ; pvodn obsluha INT 09h

; ------ test, zda je v bufferu njak znak

         mov       bx,ds:[1ch]              ; BX <- ukldac adresa do bufferu
         cmp       bx,ds:[1ah]              ; je v bufferu njak znak ?
         je        Int098                   ; v bufferu nen dn znak

; ------ adresa naposledy uloenho znaku -> BX

         dec       bx
         dec       bx                       ; snen ukldac adresy
         cmp       bx,1eh                   ; je podteen potku bufferu ?
         jae       Int096                   ; nen podteen potku bufferu
         add       bx,20h                   ; pesun ukazatele na konec

; ------ test, zda byla klvesa Ctrl-Break

Int096:  cmp       word ptr ds:[bx],0       ; byla to klvesa Ctrl-Break ?
         jne       Int098                   ; nebyla to klvesa Ctrl-Break
         or        byte ptr cs:[ParBreak],bit0 ; pznak peruen programu

; ------ nvrat registr

Int098:  pop       ds
         pop       bx
         iret

Int09    ENDP

Old09    dd        0                        ; pvodn obsluha INT 09h
ParBreak db        0                        ; bit 0 = pznak peruen programu

; *****************************************************************************
;
;                         Obsluha hodin a zvuku
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zapnut vstupu na reproduktor - dlic konstanta BX
; -----------------------------------------------------------------------------

SoundOn  PROC      NEAR

; ------ schova registr

         cli
         push      ax

; ------ nastaven frekvence

         mov       al,0b6h                  ; povel pro nastaven dliky
         out       [43h],al                 ; nastaven mdu dliky

         mov       al,bl                    ; dlic konstanta LOW
         out       [42h],al                 ; nastaven konstanty LOW
         mov       al,bh                    ; dlic konstanta HIGH
         out       [42h],al                 ; nastaven konstanty HIGH

; ------ zapnut vstupu na reproduktor

         in        al,[61h]
         or        al,bit0+bit1             ; zapnut vstupu na reproduktor
         out       [61h],al

; ------ nvrat registr

         pop       ax
         sti
         ret

SoundOn  ENDP

; -----------------------------------------------------------------------------
;        vypnut vstupu na reproduktor
; -----------------------------------------------------------------------------

SoundOff PROC      NEAR

; ------ schova registr

         cli
         push      ax

; ------ vypnut vstupu na reproduktor

         in        al,[61h]
         and       al,not bit0+bit1
         out       [61h],al                 ; vypnut vstupu na reproduktor

; ------ nastaven standardn frekvence genertoru

         mov       al,0b6h                  ; povel pro nastaven dliky
         out       [43h],al                 ; nastaven mdu dliky
         mov       al,5                     ; konstanta asi tak 920 Hz
         out       [42h],al                 ; konstanta - n bajt
         out       [42h],al                 ; konstanta - vy bajt

; ------ nvrat registr

         pop       ax
         sti
         ret

SoundOff ENDP

; -----------------------------------------------------------------------------
;        tabulka dlicch konstant tn
; -----------------------------------------------------------------------------

TabTon   label     word                     ; tabulka pro nastaven tn
         dw        36485,34437,32505,30680,28958,27333 ; oktva 0 (1 a 12)
         dw        25799,24351,22984,21694,20477,19327
         dw        18243,17219,16252,15340,14479,13667 ; oktva 1 (13 a 24)
         dw        12899,12175,11492,10847,10238,9664
         dw        9121,8609,8126,7670,7240,6833       ; oktva 2 (25 a 36)
         dw        6450,6088,5746,5424,5119,4832
         dw        4561,4305,4063,3835,3620,3417       ; oktva 3 (37 a 48)
         dw        3225,3044,2873,2712,2560,2416
         dw        2280,2152,2032,1918,1810,1708       ; oktva 4 (49 a 60)
         dw        1612,1522,1437,1356,1280,1208
         dw        1140,1076,1016,959,905,854          ; oktva 5 (61 a 72)
         dw        806,761,718,678,640,604
         dw        570,538,508,479,452,427             ; oktva 6 (73 a 84)
         dw        403,380,359,339,320,302
         dw        285,269,254,240,226,214             ; oktva 7 (85 a 96)
         dw        202,190,180,169,160,151
         dw        143,135,127,120,113,107             ; oktva 8 (97 a 108)
         dw        101,95,90,85,80,75
         dw        71,67,63,60,57,53,50,48,45,42,40,38 ; oktva 9 (109 a 120)

         dw        36                       ; to je pro "#" poslednho tnu

; -----------------------------------------------------------------------------
;        ekn na impuls hodin s aktualizac zobrazen Petra
; -----------------------------------------------------------------------------

CekKrokD PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       CekKrkD3                 ; je blokovn pkaz

         test      byte ptr ds:[Param],bit0 ; je reim TURBO ?
         jz        CekKrkD2                 ; nen reim TURBO
         call      MazPet                   ; vymazn Petra
         jmp       short CekKrok

CekKrkD2:call      DispPet                  ; zobrazen Petra
CekKrkD3:jmp       short CekKrok

CekKrokD ENDP

; -----------------------------------------------------------------------------
;        ekn na jeden impuls hodin (pro jeden krok) -> CY=peruen operace
; -----------------------------------------------------------------------------

CekKrok  PROC      NEAR

         call      TestBlok                 ; test blokovn programu
         jnz       CekKrok8                 ; je blokovn pkaz

         call      MouseOn                  ; zapnut kurzoru myi

         call      TstBreak                 ; test peruen z klvesnice
         jc        CekKrok8                 ; peruen operace

         mov       byte ptr cs:[TimeKrok],1 ; nastaven tae
CekKrok6:sti
         cmp       byte ptr cs:[TimeKrok],0
         jne       CekKrok6
         clc
CekKrok8:ret

CekKrok  ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 1Bh, INT 23h a INT 24h
; -----------------------------------------------------------------------------

INT24    PROC      FAR

         mov       al,0                     ; ignorovat chyby
INT1B:
INT23:   iret

INT24    ENDP

Old1B    dd        0                        ; pvodn obsluha INT 1Bh

; -----------------------------------------------------------------------------
;        Obsluha asovn INT 08h
; -----------------------------------------------------------------------------

Int08    PROC      FAR

; ------ ta kroku pohybu Petra

         cmp       byte ptr cs:[TimeKrok],0 ; je ta asu pro jeden krok ?
         je        Int081                   ; nen ta asu pro krok
         dec       byte ptr cs:[TimeKrok]   ; snen tae asu

; ------ ta zobrazen textu hlen

Int081:  cmp       word ptr cs:[TimeTxt],1
         jbe       Int082
         dec       word ptr cs:[TimeTxt]

; ------ ta dlky tnu

Int082:  cmp       byte ptr cs:[CitTon],0   ; je ta doby tnu vynulovn ?
         je        Int083                   ; ta doby tnu je ji vynulovn
         dec       byte ptr cs:[CitTon]     ; snen tae doby tnu
         jnz       Int085                   ; dal ekn
         call      SoundOff                 ; konec tnu-vypnut zvuk.genertoru

; ------ naten dalho tnu k pehrt

Int083:  push      ax
         push      bx
         push      si
         push      ds

         push      cs
         pop       ds

Int0832: cmp       word ptr ds:[CitacMel],0 ; je dal tn ?
         je        Int084                   ; nen dal tn
         dec       word ptr ds:[CitacMel]   ; snen tae melodie

         cld
         mov       si,ds:[UkazMel]          ; ukazatel melodie
         lodsw                              ; naten tnu a dlky
         mov       ds:[UkazMel],si          ; nov ukazatel melodie

         mov       ds:[CitTon],al           ; ta pro vypnut tnu
         mov       bl,ah                    ; vka tnu
         mov       bh,0
         shl       bx,1                     ; slo tnu * 2
         jz        Int084                   ; je mezera
         mov       bx,ds:[bx+TabTon-2]      ; dlic konstanta
         call      SoundOn                  ; zapnut tnu

Int084:  pop       ds
         pop       si
         pop       bx
         pop       ax

Int085:  jmp       dword ptr cs:[Old08]

Int08    ENDP

Old08    dd        0                        ; pvodn adresa INT 08h
TimeKrok db        0                        ; ta asu pro jeden krok
                                            ;  (pouv se t pro VSYN)
TimeTxt  dw        0                        ; ta pro vypnut textu
CitTon   db        0                        ; ta pro vypnut tnu hudby
UkazMel  dw        0                        ; ukazatel melodie
                                            ; melodie: 1 bajt dlka
                                            ;          1 bajt tn, 0=mezera
CitacMel dw        0                        ; ta zbyl melodie (0=nen)
BuffMel  dw        256 dup(0)               ; buffer melodie pro uivatele

; 
;
;                                  Data
;
; 
;
; ------ fonty

Font08   label     byte
INCLUDE  font08.asm

Font14   label     byte
INCLUDE  font14.asm

Font16   label     byte
INCLUDE  font16.asm

AdrFont  dw        Font16                   ; adresa pouitho fontu
VysFont  dw        16                       ; vka pouitho fontu

; ------ texty hlen

UvTxt    db        'Petr V1.0; (c) Miroslav Nemecek 1997',13,10,'$'
ZbyvMem  db        'Zbyvajici volna pamet:    '
ZbyvMem2 db        ' KB',13,10,'$'

MemErr   db        'nedostatek pameti ke startu programu !',13,10,'$'
ICOErr   db        'nepovolene znaky ve jmenu ikony '
 ICOErr2  db        13 dup(" "),13,10,'$'
ICODErr  db        'nenalezena implicitni ikona '
 ICODErr2 db        13 dup(" "),13,10,'$'
NeznErr  db        'neznamy prikaz '
 NeznErr2 db        30 dup(" "),13,10,'$'
FndErr   db        'Nenalezen vstupni soubor programu !',13,10,'$'
ProcErr  db        'prikazy musi byt definovany pred hlavnim programem !',13,10,'$'

ChybErr  db        'CHYBA [    '
ChybErr2 db        ']: $'

CitRad   dw        0                        ; ukazatel sla dku

; ------ nraz do zdi

NarazTxt db        35,'  ****  AU - NARAZIL JSEM !  ****  '
NarazTon db        M32,MG+MO4
         db        M32,ME+MO4
         db        M32,MC+MO4
         db        M32,ME+MO4
         db        M32,MG+MO4

; ------ poloen pedmtu na okraj

OkrajTxt db        39,'  ****  NEMOHU - JE TAM OKRAJ !  ****  '
OkrajTon db        M32,MG+MO4
         db        M32,ME+MO4
         db        M32,MC+MO4
         db        M32,MG+MO3
         db        M32,ME+MO3

; ------ kdy klves (zanaj textem "K_")

KodKlav  label     byte
         db        3,'ESC'
         dw        1bh
         db        2,'BS'
         dw        8
         db        9,'BACKSPACE'
         dw        8
         db        7,'CTRL_BS'
         dw        7fh
         db        14,'CTRL_BACKSPACE'
         dw        7fh
         db        3,'TAB'
         dw        9
         db        9,'SHIFT_TAB'
         dw        0f00h
         db        5,'ENTER'
         dw        0dh
         db        10,'CTRL_ENTER'
         dw        0ah
         db        5,'SPACE'
         dw        " "
         db        6,'MEZERA'
         dw        " "
         db        2,'F1'
         dw        3b00h
         db        2,'F2'
         dw        3c00h
         db        2,'F3'
         dw        3d00h
         db        2,'F4'
         dw        3e00h
         db        2,'F5'
         dw        3f00h
         db        2,'F6'
         dw        4000h
         db        2,'F7'
         dw        4100h
         db        2,'F8'
         dw        4200h
         db        2,'F9'
         dw        4300h
         db        3,'F10'
         dw        4400h
         db        8,'SHIFT_F1'
         dw        5400h
         db        8,'SHIFT_F2'
         dw        5500h
         db        8,'SHIFT_F3'
         dw        5600h
         db        8,'SHIFT_F4'
         dw        5700h
         db        8,'SHIFT_F5'
         dw        5800h
         db        8,'SHIFT_F6'
         dw        5900h
         db        8,'SHIFT_F7'
         dw        5a00h
         db        8,'SHIFT_F8'
         dw        5b00h
         db        8,'SHIFT_F9'
         dw        5c00h
         db        9,'SHIFT_F10'
         dw        5d00h
         db        7,'CTRL_F1'
         dw        5e00h
         db        7,'CTRL_F2'
         dw        5f00h
         db        7,'CTRL_F3'
         dw        6000h
         db        7,'CTRL_F4'
         dw        6100h
         db        7,'CTRL_F5'
         dw        6200h
         db        7,'CTRL_F6'
         dw        6300h
         db        7,'CTRL_F7'
         dw        6400h
         db        7,'CTRL_F8'
         dw        6500h
         db        7,'CTRL_F9'
         dw        6600h
         db        8,'CTRL_F10'
         dw        6700h
         db        6,'ALT_F1'
         dw        6800h
         db        6,'ALT_F2'
         dw        6900h
         db        6,'ALT_F3'
         dw        6a00h
         db        6,'ALT_F4'
         dw        6b00h
         db        6,'ALT_F5'
         dw        6c00h
         db        6,'ALT_F6'
         dw        6d00h
         db        6,'ALT_F7'
         dw        6e00h
         db        6,'ALT_F8'
         dw        6f00h
         db        6,'ALT_F9'
         dw        7000h
         db        7,'ALT_F10'
         dw        7100h
         db        4,'HOME'
         dw        4700h
         db        9,'CTRL_HOME'
         dw        7700h
         db        2,'UP'
         dw        4800h
         db        6,'NAHORU'
         dw        4800h
         db        6,'PAGEUP'
         dw        4900h
         db        11,'CTRL_PAGEUP'
         dw        8400h
         db        4,'LEFT'
         dw        4b00h
         db        5,'VLEVO'
         dw        4b00h
         db        9,'CTRL_LEFT'
         dw        7300h
         db        10,'CTRL_VLEVO'
         dw        7300h
         db        5,'RIGHT'
         dw        4d00h
         db        6,'VPRAVO'
         dw        4d00h
         db        10,'CTRL_RIGHT'
         dw        7400h
         db        11,'CTRL_VPRAVO'
         dw        7400h
         db        3,'END'
         dw        4f00h
         db        8,'CTRL_END'
         dw        7500h
         db        4,'DOWN'
         dw        5000h
         db        4,'DOLU'
         dw        5000h
         db        8,'PAGEDOWN'
         dw        5100h
         db        13,'CTRL_PAGEDOWN'
         dw        7600h
         db        6,'INSERT'
         dw        5200h
         db        6,'DELETE'
         dw        5300h
         db        5,'ALT_Q'
         dw        1000h
         db        5,'ALT_W'
         dw        1100h
         db        5,'ALT_E'
         dw        1200h
         db        5,'ALT_R'
         dw        1300h
         db        5,'ALT_T'
         dw        1400h
         db        5,'ALT_Y'
         dw        1500h
         db        5,'ALT_U'
         dw        1600h
         db        5,'ALT_I'
         dw        1700h
         db        5,'ALT_O'
         dw        1800h
         db        5,'ALT_P'
         dw        1900h
         db        5,'ALT_A'
         dw        1e00h
         db        5,'ALT_S'
         dw        1f00h
         db        5,'ALT_D'
         dw        2000h
         db        5,'ALT_F'
         dw        2100h
         db        5,'ALT_G'
         dw        2200h
         db        5,'ALT_H'
         dw        2300h
         db        5,'ALT_J'
         dw        2400h
         db        5,'ALT_K'
         dw        2500h
         db        5,'ALT_L'
         dw        2600h
         db        5,'ALT_Z'
         dw        2c00h
         db        5,'ALT_X'
         dw        2d00h
         db        5,'ALT_C'
         dw        2e00h
         db        5,'ALT_V'
         dw        2f00h
         db        5,'ALT_B'
         dw        3000h
         db        5,'ALT_N'
         dw        3100h
         db        5,'ALT_M'
         dw        3200h
         db        6,'CTRL_A'
         dw        1
         db        6,'CTRL_B'
         dw        2
         db        6,'CTRL_C'
         dw        3
         db        6,'CTRL_D'
         dw        4
         db        6,'CTRL_E'
         dw        5
         db        6,'CTRL_F'
         dw        6
         db        6,'CTRL_G'
         dw        7
         db        6,'CTRL_H'
         dw        8
         db        6,'CTRL_I'
         dw        9
         db        6,'CTRL_J'
         dw        10
         db        6,'CTRL_K'
         dw        11
         db        6,'CTRL_L'
         dw        12
         db        6,'CTRL_M'
         dw        13
         db        6,'CTRL_N'
         dw        14
         db        6,'CTRL_O'
         dw        15
         db        6,'CTRL_P'
         dw        16
         db        6,'CTRL_Q'
         dw        17
         db        6,'CTRL_R'
         dw        18
         db        6,'CTRL_S'
         dw        19
         db        6,'CTRL_T'
         dw        20
         db        6,'CTRL_U'
         dw        21
         db        6,'CTRL_V'
         dw        22
         db        6,'CTRL_W'
         dw        23
         db        6,'CTRL_X'
         dw        24
         db        6,'CTRL_Y'
         dw        25
         db        6,'CTRL_Z'
         dw        26
         db        0

; ------ implicitn ikony

ICODef   label     byte
         db        3,'RAM'                  ; rm kolem hrac plochy
ICORam   dw        0
         db        8,'RAM_MENU'             ; rm kolem menu
ICORamM  dw        0
         db        8,'RAM_TEXT'             ; rm kolem textu
ICORamT  dw        0
         db        3,'NIC'                  ; plocha (uprosted)
ICONic   dw        0
         db        7,'MNU_NIC'              ; plocha menu
ICOMenu  dw        0
         db        7,'PETRIKP'              ; Petk zepedu
ICOPetP  dw        0
         db        7,'PETRIKZ'              ; Petk zezadu
ICOPetZ  dw        0
         db        7,'PETRIKL'              ; Petk zleva
ICOPetL  dw        0
         db        7,'PETRIKR'              ; Petk zprava
ICOPetR  dw        0
         db        3,'ZED'                  ; ze
ICOZed   dw        0
         db        8,'MNU_VLEV'             ; ikona vlevo
ICOVlevo dw        0
         db        8,'MNU_PRAV'             ; ikona vpravo
ICOVprav dw        0
         db        8,'MNU_VZAD'             ; ikona vzad
ICOVzad  dw        0
         db        8,'MNU_KROK'             ; ikona kroku
ICOKrok  dw        0
         db        7,'MNU_KON'               ; konec programu
ICOKonec dw        0
;         db        4,'DISK'                 ; disketa - souborov funkce
;ICODisk  dw        0
         db        7,'MNU_MAL'              ; ikona menu pro malovn
ICOMaluj dw        0
         db        8,'MNU_IKON'             ; volba ikon
ICOIkony dw        0
         db        8,'MNU_STRT'             ; start programu
ICOStart dw        0
         db        8,'RAM_BAR1'             ; volba barvy 1
ICOBarv1 dw        0
         db        8,'RAM_BAR2'             ; volba barvy 2
ICOBarv2 dw        0
         db        8,'RAM_BAR3'             ; volba barvy 3
ICOBarv3 dw        0
         db        8,'RAM_BAR4'             ; volba barvy 4
ICOBarv4 dw        0
         db        8,'RAM_BAR5'             ; volba barvy 5
ICOBarv5 dw        0
         db        8,'RAM_BAR6'             ; volba barvy 6
ICOBarv6 dw        0
         db        8,'MNU_PERO'             ; pero
ICOPero  dw        0
         db        8,'MNU_CTVE'             ; tverec
ICOCtve  dw        0
         db        8,'MNU_KRUH'             ; kruh
ICOKruh  dw        0
         db        8,'MNU_BLOK'             ; blok
ICOBlok  dw        0
;         db        8,'MNU_BLOS'             ; blok SAVE
;ICOBlokS dw        0
         db        8,'MNU_BLOL'             ; blok LOAD
ICOBlokL dw        0
         db        8,'MNU_CARA'             ; ra
ICOCara  dw        0
         db        8,'MNU_UNDO'             ; UNDO
ICOUndo  dw        0
         db        8,'MNU_REDO'             ; REDO
ICORedo  dw        0
         db        8,'MNU_FILL'             ; vpl
ICOFill  dw        0
         db        8,'MNU_FLIP'             ; pevrcen
ICOFlip  dw        0
         db        7,'MNU_ROT'              ; rotace
ICORot   dw        0
         db        8,'MNU_XCOL'             ; zmna barev
ICOXCol  dw        0
         db        8,'MNU_SAVE'             ; save
ICOSave  dw        0
;         db        8,'MNU_LOAD'             ; load
;ICOLoad  dw        0

ICODef0  label     byte

ICOLast  dw        0                        ; naposledy zvolen ikona

; ------ pkazy

Prikazy  label     byte
         db        1,' '                    ; 1: kreslen obrzku
         db        6,'OPAKUJ'               ; 2: OPAKUJ
         db        1,'('                    ; 3: lev zvorka
         db        1,')'                    ; 4: prav zvorka
         db        1,'!'                    ; 5: definice/proveden pkazu
         db        1,','                    ; 6: rka
         db        4,'KROK'                 ; 7: KROK
         db        5,'VLEVO'                ; 8: VLEVO
         db        6,'VPRAVO'               ; 9: VPRAVO
         db        4,'VZAD'                 ; 10: VZAD
         db        5,'CEKEJ'                ; 11: CEKEJ
         db        6,'RYCHLE'               ; 12: RYCHLE
         db        6,'POMALU'               ; 13: POMALU
         db        5,'SEVER'                ; 14: SEVER
         db        3,'JIH'                  ; 15: JIH
         db        6,'VYCHOD'               ; 16: VYCHOD
         db        5,'ZAPAD'                ; 17: ZAPAD
         db        6,'JESTLI'               ; 18: JESTLI
         db        5,'JINAK'                ; 19: JINAK
         db        4,'NENI'                 ; 20: NENI
         db        6,'PRERUS'               ; 21: PRERUS
         db        5,'DOKUD'                ; 22: DOKUD
         db        5,'MASKA'                ; 23: MASKA
         db        4,'VSYN'                 ; 24: VSYN
         db        1,'#'                    ; 25: PROMENNA
         db        1,' '                    ; 26: CISLO
         db        1,'='                    ; 27: ROVNITKO
         db        1,'+'                    ; 28: PLUS
         db        1,'-'                    ; 29: MINUS
         db        1,'*'                    ; 30: KRAT
         db        1,'/'                    ; 31: DELENO
         db        1,'<'                    ; 32: MENSI
         db        1,'>'                    ; 33: VETSI
         db        6,'NAHODA'               ; 34: NAHODA
         db        6,'VEKTOR'               ; 35: VEKTOR
         db        6,'MISTNI'               ; 36: MISTNI
         db        1,'A'                    ; 37: A
         db        4,'NEBO'                 ; 38: NEBO
         db        7,'POZICEX'              ; 39: POZICEX
         db        7,'POZICEY'              ; 40: POZICEY
         db        7,'KLAVESA'              ; 41: KLAVESA
         db        5,'OBNOV'                ; 42: OBNOV
         db        4,'SMER'                 ; 43: SMER
         db        7,'HLASENI'              ; 44: HLASENI
         db        7,'PREDMET'              ; 45: PREDMET
         db        4,'TEXT'                 ; 46: TEXT
         db        4,'POLE'                 ; 47: POLE
         db        3,'MOD'                  ; 48: MOD
         db        5,'HUDBA'                ; 49: HUDBA
Prikazy0 db        0

Prikazy2 label     byte
         db        1,' '                    ; 1: kreslen obrzku
         db        1,'@'                    ; 2: OPAKUJ
         db        1,'('                    ; 3: lev zvorka
         db        1,')'                    ; 4: prav zvorka
         db        1,'!'                    ; 5: definice/proveden pkazu
         db        1,','                    ; 6: rka
         db        1,'K'                    ; 7: KROK
         db        1,'L'                    ; 8: VLEVO
         db        1,'P'                    ; 9: VPRAVO
         db        1,'V'                    ; 10: VZAD
         db        1,'C'                    ; 11: CEKEJ
         db        1,'R'                    ; 12: RYCHLE
         db        1,'U'                    ; 13: POMALU
         db        2,'SS'                   ; 14: SEVER
         db        2,'SJ'                   ; 15: JIH
         db        2,'SV'                   ; 16: VYCHOD
         db        2,'SZ'                   ; 17: ZAPAD
         db        1,'J'                    ; 18: JESTLI
         db        1,'I'                    ; 19: JINAK
         db        1,'~'                    ; 20: NENI
         db        1,'B'                    ; 21: PRERUS
         db        1,'D'                    ; 22: DOKUD
         db        1,'M'                    ; 23: MASKA
         db        1,' '                    ; 24: VSYN
         db        1,'#'                    ; 25: PROMENNA
         db        1,' '                    ; 26: CISLO
         db        1,'='                    ; 27: ROVNITKO
         db        1,'+'                    ; 28: PLUS
         db        1,'-'                    ; 29: MINUS
         db        1,'*'                    ; 30: KRAT
         db        1,'/'                    ; 31: DELENO
         db        1,'<'                    ; 32: MENSI
         db        1,'>'                    ; 33: VETSI
         db        1,' '                    ; 34: NAHODA
         db        1,'^'                    ; 35: VEKTOR
         db        1,'$'                    ; 36: MISTNI
         db        1,'&'                    ; 37: A
         db        1,'|'                    ; 38: NEBO
         db        1,'X'                    ; 39: POZICEX
         db        1,'Y'                    ; 40: POZICEY
         db        1,' '                    ; 41: KLAVESA
         db        1,' '                    ; 42: OBNOV
         db        1,' '                    ; 43: SMER
         db        1,' '                    ; 44: HLASENI
         db        1,' '                    ; 45: PREDMET
         db        1,' '                    ; 46: TEXT
         db        1,' '                    ; 47: POLE
         db        1,' '                    ; 48: MOD
         db        1,' '                    ; 49: HUDBA
         db        0

; ------ obsluha pkaz pi provdn programu

PrikazX  label     word
         dw        PetKresl                 ; 1: kreslen obrzku
         dw        PetOpak                  ; 2: OPAKUJ
         dw        PetLZav                  ; 3: lev zvorka
         dw        PetNop                   ; 4: prav zvorka
         dw        PetProc                  ; 5: definice/proveden pkazu
         dw        PetNop                   ; 6: rka
         dw        PetKrok                  ; 7: KROK
         dw        PetVlevo                 ; 8: VLEVO
         dw        PetVprav                 ; 9: VPRAVO
         dw        PetVzad                  ; 10: VZAD
         dw        CekKrokD                 ; 11: CEKEJ
         dw        PetRych                  ; 12: RYCHLE
         dw        PetPom                   ; 13: POMALU
         dw        PetSev                   ; 14: SEVER
         dw        PetJih                   ; 15: JIH
         dw        PetVych                  ; 16: VYCHOD
         dw        PetZap                   ; 17: ZAPAD
         dw        PetJest                  ; 18: JESTLI
         dw        PetNop                   ; 19: JINAK
         dw        PetNop                   ; 20: NENI
         dw        PetPrer                  ; 21: PRERUS
         dw        PetDok                   ; 22: DOKUD
         dw        PetMask                  ; 23: MASKA
         dw        PetVSyn                  ; 24: VSYN
         dw        PetProm                  ; 25: PROMENNA
         dw        PetCisl                  ; 26: CISLO
         dw        PetNop                   ; 27: ROVNITKO
         dw        PetNop                   ; 28: PLUS
         dw        PetNop                   ; 29: MINUS
         dw        PetNop                   ; 30: KRAT
         dw        PetNop                   ; 31: DELENO
         dw        PetNop                   ; 32: MENSI
         dw        PetNop                   ; 33: VETSI
         dw        PetNop                   ; 34: NAHODA
         dw        PetVekt                  ; 35: VEKTOR
         dw        PetMist                  ; 36: MISTNI
         dw        PetNop                   ; 37: A
         dw        PetNop                   ; 38: NEBO
         dw        PetPozX                  ; 39: POZICEX
         dw        PetPozY                  ; 40: POZICEY
         dw        PetKlav                  ; 41: KLAVESA
         dw        PetObn                   ; 42: OBNOV
         dw        PetSmer                  ; 43: SMER
         dw        PetHlas                  ; 44: HLASENI
         dw        PetNPre                  ; 45: PREDMET
         dw        PetText                  ; 46: TEXT
         dw        PetPole                  ; 47: POLE
         dw        PetNop                   ; 48: MOD
         dw        PetMus                   ; 49: HUDBA

; ------ pracovn ukazatele

Pole     dw        PSIRKA*PVYSKA dup(0)     ; hrac pole (obsahuje adresy ikon)

TextRad  db        -1                       ; ukazatel dku textu (-1=neplatn)
PetrOPz  dw        0                        ; star zobrazen pozice Petra
PetrPoz  dw        0                        ; aktuln dek a pozice Petra
PetrOSm  db        2                        ; star smr Petra
PetrSme  db        2                        ; smr Petra
                                            ;  1 = vpravo (vchod)
                                            ;  2 = dol (jih)
                                            ;  3 = vlevo (zpad)
                                            ;  4 = nahoru (sever)

RandomR  dd        21510d31h                ; promnn pro genertor nhody
RandomD  dw        8405h                    ; pomocn konstanta

Param    db        0                        ; parametry
                                            ;   bit 0: 1=je TURBO reim
                                            ;   bit 1: 1=je my
                                            ;   bit 2: 1=kurzor myi zapnut
                                            ;   bit 3: 1=Petr je zobrazen
                                            ;   bit 4: 1=je peruen cyklu
                                            ;   bit 5: 1=kurzor volby zapnut

                                            ;   bit 7:

Rezim    db        0                        ; aktuln reim
                                            ;    0 = inicializace
                                            ;    1 = bh programu
                                            ;    2 = zkladn ovldn
                                            ;    3 = volba ikon
                                            ;    4 = editace ikon

FunkceEd db        0                        ; funkce pi editaci
                                            ;    0: pero
                                            ;    1: ra
                                            ;    2: tverece
                                            ;    3: kruh
                                            ;    4: naplnn
                                            ;    5: blok
                                            ;    6: je oznaen blok

TypCard  db        0                        ; typ videokarty
                                            ;   0=nezadan
                                            ;   1=Hercules
                                            ;   2=CGA
                                            ;   3=EGA
                                            ;   4=VGA
AdrVRAM  dw        0                        ; adresa videopamti (segment)
;Hrana1   db        2                        ; hranice Mono pro edou barvu
;Hrana1X  db        20h                      ; hranice Mono pro edou barvu * 16
;Hrana2   db        8                        ; hranice Mono pro blou barvu
;Hrana2X  db        80h                      ; hranice Mono pro blou barvu * 16

DispSirX dw        0                        ; ka obrazovky (bod)
DispSirB dw        0                        ; ka obrazovky (bajt)
DispVysY dw        0                        ; vka obrazovky (bod)

CitBarev dw        16 dup(0)                ; ta rozloen barev

EditIcoC dw        0                        ; slo editovan ikony

MinHICO  dw        0                        ; adresa minimln ikony v historii
BegHICO  dw        0                        ; adresa prvn ikony v historii
AktHICO  dw        0                        ; aktuln ikona v historii

MousZPoz dw        -1                       ; zobrazen pozice myi pi editaci

MouseX   dw        0                        ; bitov souadnice kurzoru myi X
MouseY   dw        0                        ; bitov souadnice kurzoru myi Y
MouseK   db        0                        ; tlatka myi
                                            ;   bit 0: 1=dreno lev tlatko
                                            ;   bit 1: 1=dreno prav tlatko
                                            ;   bit 2: 1=lev tlatko stisknuto
                                            ;   bit 3: 1=prav tlatko stisknuto
                                            ;   bit 4: 1=lev tlatko uvolnno
                                            ;   bit 5: 1=prav tlatko uvolnno
                                            ;   bit 6:
                                            ;   bit 7: 1=pohyb s my s drenm

; ------ registry pro inicializaci grafickho reimu karty HGC

HGCTabR  db        53                       ; 0: horizontln celkem-1
         db        HercSir/2   ;40          ; 1: horizontln zobrazeno
         db        HercSir/2+1 ;44          ; 2: pozice HSYNC
         db        7                        ; 3: ka HSYNC
         db        91                       ; 4: vertikln celkem
         db        2           ;1           ; 5: vertikln korekce
         db        88                       ; 6: vertikln zobrazeno
         db        88                       ; 7: vertikln pozice
         db        2                        ; 8: md prokldn
         db        3                        ; 9: poet linek na dek
         db        0                        ; 10: potek kurzoru
         db        0           ;3           ; 11: konec kurzoru
         db        0                        ; 12: adresa potku HIGH
         db        0                        ; 13: adresa potku LOW
         db        0                        ; 14: kurzor HIGH
         db        0                        ; 15: kurzor LOW

; ------ obrzek kurzoru myi

KurzMous dw        0111111111111111b        ; obrzek kurzoru myi
         dw        0011111111111111b
         dw        0001111111111111b
         dw        0000111111111111b
         dw        0000011111111111b
         dw        0000001111111111b
         dw        0000000111111111b
         dw        0000000011111111b
         dw        0000000001111111b
         dw        0000001111111111b
         dw        0010001111111111b
         dw        0110000111111111b
         dw        1111000111111111b
         dw        1111000011111111b
         dw        1111100011111111b
         dw        1111100011111111b

         dw        0000000000000000b
         dw        0000000000000000b
         dw        0100000000000000b
         dw        0110000000000000b
         dw        0111000000000000b
         dw        0111100000000000b
         dw        0111110000000000b
         dw        0111111000000000b
         dw        0111100000000000b
         dw        0100100000000000b
         dw        0000100000000000b
         dw        0000010000000000b
         dw        0000010000000000b
         dw        0000001000000000b
         dw        0000001000000000b
         dw        0000000000000000b

; -----------------------------------------------------------------------------
; Na zatku bufferu je seznam jmen ikon (ve velk psmena):
;                0: (1) dlka jmna ikony
;                1: (x) jmno ikony
;              1+x: (2) adresa ikony v pamti (segment)
;
; Za seznamem jmen ikon nsleduje peloen program.
;
; Od konce datovho bufferu jsou ukldny ikony. Kad zabr 640 Bajt
; (4 barevn roviny + maska 32*32, horizontln 4 bajty, 1 rovina=32*32/8=128 B)
; -----------------------------------------------------------------------------
; Ve fz natn programu je za seznam ikon ukldn peloen program.
; Na zatku programu jsou definice promnnch:
;       (1) dlka jmna promnn
;       (x) jmno promnn
;       (2) promnn
; Za definicemi sel jsou definice procedur:
;       (2) adresa dal procedury v bufferu
;       (1) dlka jmna procedury
;       (x) jmno procedury
;       (...) pkaz nebo vce pkaz v zvorce
; -----------------------------------------------------------------------------
; Pi provdn programu je mezi koncem programu a zatkem symbol buffer
; nvratovch adres cykl OPAKUJ a DOKUD
; -----------------------------------------------------------------------------

DataVekt dw        0                        ; adresa vektoru
DataSegm dw        0                        ; adresa zatku datovho segmentu
DataEnd  dw        0                        ; adresa konce datovho segmentu
DataProg dw        0                        ; adresa zatku programu (segment)
UkazProg dw        0                        ; ukazatel zpracovn programu (offset)
DataNum  dw        0                        ; poet bajt programu v bufferu
MainProg dw        0                        ; offset hlavnho programu
ProcBeg  dw        0                        ; offset zatku procedur
ProcNum  dw        0                        ; poet procedur v programu
PromNum  dw        0                        ; poet promnnch v programu
DataICOE dw        0                        ; konec symbol ikon (offset)
DataICO  dw        0                        ; adresa zatku bufferu ikon (segment)
                                            ;  (posouv se shora dol, ikony
                                            ;   se ukldaj shora dol)
DataICON dw        0                        ; poet ikon v segmentu
                                            ;  (640 B na ikonu)

DataStru dw        0                        ; adresa bufferu struktur

ICOAll   db        'ICO\*.ICO',0            ; hledn vech ikon
DTA      db        44 dup(0)                ; buffer DTA souboru

CitChyb  dw        0                        ; ta chyb pekladu

VnorIf   dw        0                        ; ta vnoen IF pro blokovn
VnorCas  dw        0                        ; ta vnoen CASE pro blokovn
VnorFor  dw        0                        ; ta vnoen FOR pro blokovn
VnorPrik dw        0                        ; ta vnoen zvorek pro 1 pkaz

VolILast dw        0                        ; ukazatel pi volb ikon

EdiIHist dw        HistEdiM dup(0)          ; historie editovanch ikon

EdiIHAkt dw        0                        ; aktuln ikona v historii

ColLeft  db        0                        ; barva pro lev tlatko
ColRight db        8                        ; barva pro prav tlatko

EdiBegPz dw        0                        ; pozice potku operace
EdiOldPz dw        0                        ; uschovan pozice kurzoru

BlokBuff db        32*32 dup(0)             ; buffer k uloen bloku v editoru
BlokPoz  dw        0                        ; souadnice potku bloku
BlokSize dw        0                        ; velikost bloku (0=nen blok)
BlokSiz2 dw        0                        ; uschovan velikost bloku

; -----------------------------------------------------------------------------
;        vzor zhlav pro zpis ikony
; -----------------------------------------------------------------------------

VzorICO  label     byte
                                           ;* zhlav souboru
         dw        0                        ; (rezervovno)
         dw        1                        ; verze souboru
         dw        1                        ; poet obrzk v souboru
         db        32                       ; ka ikony (bod)
         db        32                       ; vka ikony (bod)
         db        16                       ; poet barev ikony
         db        0                        ; (rezervovno)
         dw        0,0                      ; (rezervovno)
         dd        744                      ; velikost dat
         dd        22                       ; velikost zhlav souboru
                                          ;* zhlav obrzku
         dd        40                       ; velikost zhlav obrzku
         dd        32                       ; ka a vka plochy obrzku
         dd        64                       ; velikost tabulky palet
         dw        1
         dd        4                        ; poet bit na bod
         dw        0
         dd        640                      ; velikost data+maska obrzku
         dd        0,0,0,0

         db          0,  0,  0,  0          ;  0: ern
         db          0,  0,128,  0          ;  1: tmav erven
         db          0,128,  0,  0          ;  2: tmav zelen
         db          0,128,128,  0          ;  3: tmav lut
         db        128,  0,  0,  0          ;  4: tmav modr
         db        128,  0,128,  0          ;  5: tmav purpurov
         db        128,128,  0,  0          ;  6: tmav azurov
         db        128,128,128,  0          ;  7: tmav ed
         db        192,192,192,  0          ;  8: svtle ed
         db          0,  0,255,  0          ;  9: svtle erven
         db          0,255,  0,  0          ; 10: svtle zelen
         db          0,255,255,  0          ; 11: svtle lut
         db        255,  0,  0,  0          ; 12: svtle modr
         db        255,  0,255,  0          ; 13: svtle purpurov
         db        255,255,  0,  0          ; 14: svtle azurov
         db        255,255,255,  0          ; 15: bl

; -----------------------------------------------------------------------------
;        soubor natenho obrzku ICO
; -----------------------------------------------------------------------------

SoubICO  label     byte
                                           ;* zhlav souboru
         dw        0                        ; (rezervovno)
         dw        1                        ; verze souboru
         dw        1                        ; poet obrzk v souboru
         db        32                       ; ka ikony (bod)
         db        32                       ; vka ikony (bod)
         db        16                       ; poet barev ikony
         db        0                        ; (rezervovno)
         dw        0,0                      ; (rezervovno)
         dd        744                      ; velikost dat
         dd        22                       ; velikost zhlav souboru
                                          ;* zhlav obrzku
         dd        40                       ; velikost zhlav obrzku
         dd        32                       ; ka a vka plochy obrzku
         dd        64                       ; velikost tabulky palet
         dw        1
         dd        4                        ; poet bit na bod
         dw        0
         dd        640                      ; velikost data+maska obrzku
         dd        0,0,0,0
                                          ;* tabulka palet (poad B/G/R/0)
PalIco   db          0,  0,  0,  0          ;  0: ern
         db          0,  0,128,  0          ;  1: tmav erven
         db          0,128,  0,  0          ;  2: tmav zelen
         db          0,128,128,  0          ;  3: tmav lut
         db        128,  0,  0,  0          ;  4: tmav modr
         db        128,  0,128,  0          ;  5: tmav purpurov
         db        128,128,  0,  0          ;  6: tmav azurov
         db        128,128,128,  0          ;  7: tmav ed
         db        192,192,192,  0          ;  8: svtle ed
         db          0,  0,255,  0          ;  9: svtle erven
         db          0,255,  0,  0          ; 10: svtle zelen
         db          0,255,255,  0          ; 11: svtle lut
         db        255,  0,  0,  0          ; 12: svtle modr
         db        255,  0,255,  0          ; 13: svtle purpurov
         db        255,255,  0,  0          ; 14: svtle azurov
         db        255,255,255,  0          ; 15: bl

IcoBuff  db        512 dup(0)               ; buffer dat ikony

IcoMask  db        128 dup(0)               ; maska ikony

SoubIco2 label     byte

; ------ konverzn tabulka barev (pi konverzi palet)

PalKonv  db        16 dup(0)                ; konverze barev

; ------ palety

PalVGA   label     byte                     ; palety VGA
;                    modr
;                       zelen
;                          erven
;                          
         db          0,  0,  0              ;  0: ern
         db          0,  0, 32              ;  1: tmav erven
         db          0, 32,  0              ;  2: tmav zelen
         db          0, 32, 32              ;  3: tmav lut
         db         32,  0,  0              ;  4: tmav modr
         db         32,  0, 32              ;  5: tmav purpurov
         db         32, 32,  0              ;  6: tmav azurov
         db         32, 32, 32              ;  7: tmav ed
         db         48, 48, 48              ;  8: svtle ed
         db          0,  0, 63              ;  9: svtle erven
         db          0, 63,  0              ; 10: svtle zelen
         db          0, 63, 63              ; 11: svtle lut
         db         63,  0,  0              ; 12: svtle modr
         db         63,  0, 63              ; 13: svtle purpurov
         db         63, 63,  0              ; 14: svtle azurov
         db         63, 63, 63              ; 15: bl

; ------ palety EGA

PalEGA   label     byte
;                  sek.erven
;                  sek.zelen
;                  sek.modr
;                  erven
;                  zelen
;                  modr
;                  
         db        000000b                  ;  0: ern
         db        000100b                  ;  1: tmav erven
         db        000010b                  ;  2: tmav zelen
         db        000110b                  ;  3: tmav lut
         db        000001b                  ;  4: tmav modr
         db        000101b                  ;  5: tmav purpurov
         db        000011b                  ;  6: tmav azurov
         db        111000b                  ;  7: tmav ed
         db        000111b                  ;  8: svtle ed
         db        100100b                  ;  9: svtle erven
         db        010010b                  ; 10: svtle zelen
         db        110110b                  ; 11: svtle lut
         db        001001b                  ; 12: svtle modr
         db        101101b                  ; 13: svtle purpurov
         db        011011b                  ; 14: svtle azurov
         db        111111b                  ; 15: bl
         db        000000b                  ; okol obrazovky

; ------ obsluha vstupnho programu

; nemnit poad - pouv se spolu !!!
JmenoICO db        'ICO'                    ; pipraven odkaz do adrese ICO
ProgStr  db        0,255 dup(0)             ; buffer etzce programu + dlka
                                            ;  (pouv se t pro zobrazen
                                            ;   textu pi volb ikony a
                                            ;   v programu - pkaz "Hlaseni")
ProgFile db        'PROGRAM.PRG',0          ; program
ProgIdnt dw        0                        ; identifiktor vstupnho souboru
InpRead  dw        0                        ; offset ve tecm bufferu
InpNum   dw        0                        ; poet bajt v bufferu
InpBuff  db        BUFFSIZE dup(0)          ; vstupn buffer programu
InpRetB  db        0,0                      ; navrcen znak do bufferu (0=nen)

Zasob0   label     word                     ; spodn hranice zsobnku
         dw        4096 dup(0)              ; pracovn zsobnk
Zasob    label     word                     ; konec zsobnku


Code     ENDS
         END       Start
